namespace ADV.Commands.Base
{
    public class BackGroundRelease : CommandBase
    {
        public override string[] ArgsLabel
        {
            get
            {
                return new string[1]
                {
                    "isActive"
                };
            }
        }

        public override string[] ArgsDefault
        {
            get
            {
                return new string[1]
                {
                    bool.FalseString
                };
            }
        }

        public override void Do()
        {
            base.Do();
            bool flag = bool.Parse(args[0]);
            scenario.BGParam.visibleAll = flag;
            if (scenario.AdvCamera != null)
            {
                CameraEffectorColorMask componentInChildren = scenario.AdvCamera.GetComponentInChildren<CameraEffectorColorMask>();
                if (componentInChildren != null)
                {
                    componentInChildren.Enabled = flag;
                }
            }
            scenario.BGParam.Release(flag);
        }
    }
}
