using Illusion.Extensions;
using UnityEngine;

namespace ADV.Commands.Base
{
    public class FontColor : CommandBase
    {
        public override string[] ArgsLabel
        {
            get
            {
                return new string[2]
                {
                    "Color",
                    "Target"
                };
            }
        }

        public override string[] ArgsDefault
        {
            get
            {
                return new string[2]
                {
                    "white",
                    string.Empty
                };
            }
        }

        public override void Do()
        {
            base.Do();
            int num = 0;
            string text = args[num++];
            string target = string.Empty;
            args.SafeProc(num++, delegate (string s)
            {
                target = s;
            });
            Color? colorCheck = text.GetColorCheck();
            if (colorCheck.HasValue)
            {
                scenario.commandController.fontColor.Set(target, colorCheck.Value);
                return;
            }
            int num2 = -1;
            string text2 = text.ToLower();
            if (text2 == null)
            {
                return;
            }
            if (!(text2 == "color0"))
            {
                if (!(text2 == "color1") && !(text2 == "color2"))
                {
                    return;
                }
                num2 = 1;
            }
            else
            {
                num2 = 0;
            }
            scenario.commandController.fontColor.Set(target, num2);
        }
    }
}
