using UnityEngine;

namespace ADV.Commands.Base
{
    public class LerpAngle : CommandBase
    {
        private string answer;

        public override string[] ArgsLabel
        {
            get
            {
                return new string[4]
                {
                    "Answer",
                    "A",
                    "B",
                    "T"
                };
            }
        }

        public override string[] ArgsDefault
        {
            get
            {
                return new string[4]
                {
                    "Answer",
                    "0",
                    "0",
                    "0"
                };
            }
        }

        public override void ConvertBeforeArgsProc()
        {
            base.ConvertBeforeArgsProc();
            answer = args[0];
        }

        public override void Do()
        {
            base.Do();
            int num = 1;
            scenario.Vars[answer] = new ValData(Mathf.LerpAngle(float.Parse(args[num++]), float.Parse(args[num++]), float.Parse(args[num++])));
        }
    }
}
