using Illusion;
using Illusion.Extensions;
using UnityEngine;

namespace ADV.Commands.Base
{
    public class NullSet : CommandBase
    {
        private enum Type
        {
            Base,
            Camera,
            Chara
        }

        public override string[] ArgsLabel
        {
            get
            {
                return new string[2]
                {
                    "Name",
                    "Type"
                };
            }
        }

        public override string[] ArgsDefault
        {
            get
            {
                return new string[2]
                {
                    string.Empty,
                    Type.Base.ToString()
                };
            }
        }

        public override void Do()
        {
            base.Do();
            int num = 0;
            string name = args[num++];
            string self = args[num++];
            switch (self.Check(true, Utils.Enum<Type>.Names))
            {
                case 0:
                    Set(scenario.commandController.BasePositon, name);
                    break;
                case 1:
                    {
                        Transform cameraPosition = scenario.commandController.CameraPosition;
                        Vector3 position = cameraPosition.position;
                        Quaternion rotation = cameraPosition.rotation;
                        cameraPosition.position = Vector3.zero;
                        cameraPosition.rotation = Quaternion.identity;
                        Set(scenario.AdvCamera.transform, name);
                        cameraPosition.SetPositionAndRotation(position, rotation);
                        break;
                    }
                case 2:
                    Set(scenario.commandController.Character, name);
                    break;
            }
        }

        private void Set(Transform transform, string name)
        {
            Transform value;
            if (scenario.commandController.NullDic.TryGetValue(name, out value))
            {
                transform.SetPositionAndRotation(value.position, value.rotation);
            }
        }
    }
}
