using System.Collections.Generic;
using UnityEngine;

namespace ADV.Commands.Base
{
    public class Vector : CommandBase
    {
        public override string[] ArgsLabel
        {
            get
            {
                return new string[5]
                {
                    "Variable",
                    "Type",
                    "X",
                    "Y",
                    "Z"
                };
            }
        }

        public override string[] ArgsDefault
        {
            get
            {
                return new string[5]
                {
                    string.Empty,
                    string.Empty,
                    string.Empty,
                    string.Empty,
                    string.Empty
                };
            }
        }

        public override void Do()
        {
            base.Do();
            int num = 0;
            string key = args[num++];
            string a = args[num++];
            Vector3 value = Vector3.zero;
            Dictionary<string, Vector3> v3Dic = scenario.commandController.V3Dic;
            if (a == "=")
            {
                if (!v3Dic.TryGetValue(args[num], out value))
                {
                    for (int i = 0; i < 3; i++)
                    {
                        int num2 = i + num;
                        float result;
                        if (!args.SafeGet(num2).IsNullOrEmpty() && float.TryParse(args[num2], out result))
                        {
                            value[i] = result;
                        }
                    }
                }
            }
            else if (a == "+=")
            {
                if (v3Dic.TryGetValue(key, out value))
                {
                    float result2;
                    if (float.TryParse(args[num], out result2))
                    {
                        for (int j = 0; j < 3; j++)
                        {
                            int num3 = j + num;
                            if (!args.SafeGet(num3).IsNullOrEmpty() && float.TryParse(args[num3], out result2))
                            {
                                value[j] += result2;
                            }
                        }
                    }
                    else
                    {
                        value += v3Dic[args[num++]];
                    }
                }
            }
            else if (a == "-=" && v3Dic.TryGetValue(key, out value))
            {
                float result3;
                if (float.TryParse(args[num], out result3))
                {
                    for (int k = 0; k < 3; k++)
                    {
                        int num4 = k + num;
                        if (!args.SafeGet(num4).IsNullOrEmpty() && float.TryParse(args[num4], out result3))
                        {
                            value[k] -= result3;
                        }
                    }
                }
                else
                {
                    value -= v3Dic[args[num++]];
                }
            }
            scenario.commandController.V3Dic[key] = value;
        }
    }
}
