namespace ADV.Commands.CameraEffect
{
    public class CrossFade : CommandBase
    {
        private float time;

        public override string[] ArgsLabel
        {
            get
            {
                return new string[1]
                {
                    "Time"
                };
            }
        }

        public override string[] ArgsDefault
        {
            get
            {
                return new string[1]
                {
                    "0"
                };
            }
        }

        public override void Do()
        {
            base.Do();
            time = float.Parse(args[0]);
            scenario.crossFade.FadeStart(time);
        }

        public override bool Process()
        {
            base.Process();
            return scenario.crossFade.isEnd;
        }

        public override void Result(bool processEnd)
        {
            base.Result(processEnd);
            if (!processEnd)
            {
                scenario.crossFade.End();
            }
        }
    }
}
