using Manager;
using System;

namespace ADV.Commands.Chara
{
    public class KaraokeStop : CommandBase
    {
        public override string[] ArgsLabel
        {
            get
            {
                return new string[1]
                {
                    "No"
                };
            }
        }

        public override string[] ArgsDefault
        {
            get
            {
                return new string[1]
                {
                    int.MaxValue.ToString()
                };
            }
        }

        public override void Do()
        {
            base.Do();
            CharaData chara = scenario.commandController.GetChara(int.Parse(args[0]));
            Singleton<Voice>.Instance.Stop(chara.voiceNo, chara.voiceTrans);
            scenario.loopVoiceList.RemoveAll(item => item.voiceNo == chara.voiceNo);
            scenario.karaokeList.ForEach(delegate (IDisposable p)
            {
                p.Dispose();
            });
            scenario.karaokeList.Clear();
        }
    }
}
