using Illusion.Extensions;
using System;
using System.Linq;
using UnityEngine;

namespace ADV.Commands.Chara
{
    public class StandFindPosition : CommandBase
    {
        public enum Type
        {
            World,
            Tag,
            Null,
            EventCG
        }

        public override string[] ArgsLabel
        {
            get
            {
                return new string[4]
                {
                    "No",
                    "Type",
                    "Name",
                    "Child"
                };
            }
        }

        public override string[] ArgsDefault
        {
            get
            {
                return new string[4]
                {
                    int.MaxValue.ToString(),
                    Type.World.ToString(),
                    string.Empty,
                    string.Empty
                };
            }
        }

        public override void Do()
        {
            base.Do();
            int num = 0;
            int no = int.Parse(args[num++]);
            string self = args[num++];
            int num2 = self.Check(true, Enum.GetNames(typeof(Type)));
            string findName = args[num++];
            string childName = string.Empty;
            args.SafeProc(num++, delegate (string s)
            {
                childName = s;
            });
            Transform transform = scenario.commandController.GetChara(no).transform;
            Transform stand = null;
            switch (num2)
            {
                case 0:
                    GameObject.Find(findName).SafeProc(delegate (GameObject p)
                    {
                        stand = p.transform;
                    });
                    break;
                case 1:
                    {
                        GameObject gameObject = GameObject.FindGameObjectWithTag(findName);
                        stand = gameObject.transform;
                        if (!childName.IsNullOrEmpty())
                        {
                            stand = gameObject.GetComponentsInChildren<Transform>().FirstOrDefault(t => t.name.Compare(childName, true));
                        }
                        break;
                    }
                case 2:
                    stand = scenario.commandController.NullDic[findName];
                    if (!childName.IsNullOrEmpty())
                    {
                        stand = stand.GetComponentsInChildren<Transform>().FirstOrDefault(t => t.name.Compare(childName, true));
                    }
                    break;
                case 3:
                    stand = scenario.commandController.EventCGRoot.Children().Find(p => p.name.Compare(findName, true));
                    if (!childName.IsNullOrEmpty())
                    {
                        stand = stand.Children().Find(t => t.name.Compare(childName, true));
                    }
                    break;
            }
            transform.SetPositionAndRotation(stand.position, stand.rotation);
        }
    }
}
