using Illusion.Extensions;
using System;
using UnityEngine;

namespace ADV.Commands.Chara2D
{
    public class StandPosition : CommandBase
    {
        public enum Type
        {
            Center,
            Left,
            Right
        }

        public override string[] ArgsLabel
        {
            get
            {
                return new string[2]
                {
                    "No",
                    "Stand"
                };
            }
        }

        public override string[] ArgsDefault
        {
            get
            {
                return new string[2]
                {
                    "0",
                    Type.Center.ToString()
                };
            }
        }

        public override void Do()
        {
            base.Do();
            int num = 0;
            int key = int.Parse(args[num++]);
            string self = args[num++];
            int num2 = self.Check(true, Enum.GetNames(typeof(Type)));
            RectTransform rectTransform = scenario.commandController.Characters2D[key].rectTransform;
            switch (num2)
            {
                case 0:
                    rectTransform.localPosition = Vector2.zero;
                    break;
                case 1:
                    {
                        Vector2 left = Vector2.left;
                        Vector2 sizeDelta2 = rectTransform.sizeDelta;
                        rectTransform.localPosition = left * sizeDelta2.x;
                        break;
                    }
                case 2:
                    {
                        Vector2 right = Vector2.right;
                        Vector2 sizeDelta = rectTransform.sizeDelta;
                        rectTransform.localPosition = right * sizeDelta.x;
                        break;
                    }
            }
        }
    }
}
