using Illusion.Extensions;
using System;

namespace ADV.Commands.Game
{
    public class CharaEvent : CommandBase
    {
        private enum Type
        {
            Check,
            Add,
            Sub
        }

        public override string[] ArgsLabel
        {
            get
            {
                return new string[5]
                {
                    "Type",
                    "No",
                    "Event",
                    "TrueName",
                    "FalseName"
                };
            }
        }

        public override string[] ArgsDefault
        {
            get
            {
                return new string[5]
                {
                    Type.Check.ToString(),
                    int.MaxValue.ToString(),
                    "0",
                    string.Empty,
                    string.Empty
                };
            }
        }

        public override void Do()
        {
            base.Do();
            int num = 0;
            string self = args[num++];
            int num2 = self.Check(true, Enum.GetNames(typeof(Type)));
            int no = int.Parse(args[num++]);
            CharaData chara = scenario.commandController.GetChara(no);
            int item = int.Parse(args[num++]);
            switch (num2)
            {
                case 0:
                    {
                        string text = args[num++];
                        string text2 = args[num++];
                        scenario.SearchTagJumpOrOpenFile(!chara.heroine.talkEvent.Contains(item) ? text2 : text, localLine);
                        break;
                    }
                case 1:
                    chara.heroine.talkEvent.Add(item);
                    break;
                case 2:
                    chara.heroine.talkEvent.Remove(item);
                    break;
            }
        }
    }
}
