using Illusion.Extensions;
using System;
using UnityEngine;

namespace ADV.Commands.Game
{
    public class CharaVisible : CommandBase
    {
        private enum Target
        {
            All,
            Head,
            Body,
            Son,
            Gomu
        }

        public override string[] ArgsLabel
        {
            get
            {
                return new string[4]
                {
                    "No",
                    "Target",
                    "isActive",
                    "Stand"
                };
            }
        }

        public override string[] ArgsDefault
        {
            get
            {
                return new string[4]
                {
                    int.MaxValue.ToString(),
                    Target.All.ToString(),
                    bool.TrueString,
                    string.Empty
                };
            }
        }

        public override void Do()
        {
            base.Do();
            int num = 0;
            int no = int.Parse(args[num++]);
            CharaData chara = scenario.commandController.GetChara(no);
            ChaControl chaCtrl = chara.chaCtrl;
            string self = args[num++];
            int num2 = self.Check(true, Enum.GetNames(typeof(Target)));
            bool flag = bool.Parse(args[num++]);
            args.SafeProc(num++, delegate (string findName)
            {
                Transform transform = scenario.commandController.characterStandNulls[findName];
                chara.transform.SetPositionAndRotation(transform.position, transform.rotation);
            });
            ChaFileStatus fileStatus = chaCtrl.fileStatus;
            switch (num2)
            {
                case 0:
                    chaCtrl.visibleAll = flag;
                    break;
                case 1:
                    fileStatus.visibleHeadAlways = flag;
                    break;
                case 2:
                    fileStatus.visibleBodyAlways = flag;
                    break;
                case 3:
                    fileStatus.visibleSonAlways = flag;
                    break;
                case 4:
                    fileStatus.visibleGomu = flag;
                    break;
            }
        }
    }
}
