using Illusion.Extensions;
using System;
using UnityEngine;

namespace ADV.Commands.Object
{
    public class AnimeParam : CommandBase
    {
        private enum Type
        {
            Float,
            Int,
            Bool,
            Trigger,
            Weight
        }

        public override string[] ArgsLabel
        {
            get
            {
                return new string[4]
                {
                    "Name",
                    "Type",
                    "Param1",
                    "Param2"
                };
            }
        }

        public override string[] ArgsDefault
        {
            get
            {
                return new string[5]
                {
                    string.Empty,
                    Type.Float.ToString(),
                    string.Empty,
                    string.Empty,
                    string.Empty
                };
            }
        }

        public override void Do()
        {
            base.Do();
            int num = 0;
            string key = args[num++];
            Animator component = scenario.commandController.Objects[key].GetComponent<Animator>();
            string self = args[num++];
            switch (self.Check(true, Enum.GetNames(typeof(Type))))
            {
                case 0:
                    component.SetFloat(args[num++], float.Parse(args[num++]));
                    break;
                case 1:
                    component.SetInteger(args[num++], int.Parse(args[num++]));
                    break;
                case 2:
                    component.SetBool(args[num++], bool.Parse(args[num++]));
                    break;
                case 3:
                    component.SetTrigger(args[num++]);
                    break;
                case 4:
                    component.SetLayerWeight(int.Parse(args[num++]), float.Parse(args[num++]));
                    break;
            }
        }
    }
}
