using Illusion;
using Illusion.Extensions;
using System;
using UnityEngine;

namespace ADV.Commands.Object
{
    public class Component : CommandBase
    {
        private enum Type
        {
            Add,
            Sub
        }

        public override string[] ArgsLabel
        {
            get
            {
                return new string[5]
                {
                    "Type",
                    "ComponentType",
                    "FindType",
                    "ChildName",
                    "RootName"
                };
            }
        }

        public override string[] ArgsDefault
        {
            get
            {
                return new string[5]
                {
                    Type.Add.ToString(),
                    string.Empty,
                    string.Empty,
                    string.Empty,
                    string.Empty
                };
            }
        }

        public override void Do()
        {
            base.Do();
            int num = 0;
            string self = args[num++];
            int num2 = self.Check(true, Enum.GetNames(typeof(Type)));
            string typeName = args[num++];
            string findType = args[num++];
            string childName = args[num++];
            string otherRootName = args[num++];
            GameObject gameObject = ObjectEx.FindGet(findType, childName, otherRootName, scenario.commandController).gameObject;
            System.Type type = Utils.Type.Get(typeName);
            switch (num2)
            {
                case 0:
                    gameObject.AddComponent(type);
                    break;
                case 1:
                    UnityEngine.Object.Destroy(gameObject.GetComponent(type));
                    break;
            }
        }
    }
}
