using Illusion.Extensions;
using System;
using UnityEngine;

namespace ADV.Commands.Object
{
    public class Rotation : CommandBase
    {
        private enum Type
        {
            Add,
            Set
        }

        public override string[] ArgsLabel
        {
            get
            {
                return new string[5]
                {
                    "Name",
                    "Type",
                    "Pitch",
                    "Yaw",
                    "Roll"
                };
            }
        }

        public override string[] ArgsDefault
        {
            get
            {
                return new string[5]
                {
                    string.Empty,
                    Type.Add.ToString(),
                    string.Empty,
                    string.Empty,
                    string.Empty
                };
            }
        }

        public override void Do()
        {
            base.Do();
            int cnt = 0;
            string key = args[cnt++];
            string self = args[cnt++];
            int num = self.Check(true, Enum.GetNames(typeof(Type)));
            Vector3 v = Vector3.zero;
            CountAddV3(args, ref cnt, ref v);
            switch (num)
            {
                case 0:
                    scenario.commandController.Objects[key].transform.eulerAngles += v;
                    break;
                case 1:
                    scenario.commandController.Objects[key].transform.eulerAngles = v;
                    break;
            }
        }
    }
}
