using ActionGame.Point;
using Illusion.Extensions;
using TMPro;
using UniRx;
using UniRx.Triggers;
using UnityEngine;

namespace ActionGame
{
    public class ActionMoveUI : MonoBehaviour
    {
        [SerializeField]
        private GameObject moveIcon;

        [SerializeField]
        private TextMeshProUGUI text;

        public void Initialize(ActionScene actScene)
        {
            ActionMap map = actScene.Map;
            (from _ in actScene.UpdateAsObservable()
             where actScene.Player != null
             select actScene.Player.hitGateID).DistinctUntilChanged().Subscribe(delegate (int id)
         {
             bool flag = actScene.Player.isGateHit;
             GateInfo gateInfo = null;
             if (flag)
             {
                 gateInfo = map.gateInfoDic[id];
                 flag = gateInfo.moveType == 0;
             }
             moveIcon.SetActiveIfDifferent(flag);
             if (flag)
             {
                 text.text = map.ConvertMapName(gateInfo.mapNo);
             }
             else
             {
                 text.text = string.Empty;
             }
         });
        }
    }
}
