using ActionGame.Chara;
using ActionGame.Chara.Backup;
using ActionGame.Chara.Mover;
using ADV;
using Illusion;
using Manager;
using System.Collections;
using UnityEngine;

namespace ActionGame
{
    public class CharaPatrolMover : PatrolMover
    {
        private NPC npc;

        private AgentSpeeder.Mode backupMode;

        public AgentSpeeder.Mode mode
        {
            private get;
            set;
        }

        protected override void Move()
        {
            if (!Singleton<Game>.Instance.IsRegulate(true) && !Program.isADVActionActive)
            {
                timer += Time.deltaTime * agent.speed;
            }
            else
            {
                agent.velocity = Vector3.zero;
            }
            if (isArrived)
            {
                SetDestination(_nowPosIndex % route.Length);
                _nowPosIndex++;
            }
            if (!isAgentActive)
            {
                cachedTransform.SetPositionAndRotation(Utils.Math.MoveSpeedPositionEnter(new Vector3[2]
                {
                    basePos,
                    nextPos
                }, timer), Quaternion.LookRotation(nextPos - cachedTransform.position));
                return;
            }
            npc.move.animParamSpeed = agent.velocity.magnitude;
            npc.corners = agent.path.corners;
        }

        protected override IEnumerator Start()
        {
            npc = GetComponent<NPC>();
            agent = npc.agent;
            agent.avoidancePriority = 99;
            backupMode = npc.move.agentSpeeder.mode;
            npc.move.agentSpeeder.mode = mode;
            yield return StartCoroutine(base.Start());
        }

        protected override void Update()
        {
            if (!npc.move.isStop)
            {
                Move();
            }
        }

        private void OnDestroy()
        {
            if (npc != null)
            {
                NavMeshAgent bkAgent = npc.bkAgent;
                agent.avoidancePriority = bkAgent.priority;
                npc.move.agentSpeeder.mode = backupMode;
            }
        }
    }
}
