using ChaCustom;
using Illusion.CustomAttributes;
using Illusion.Game;
using Manager;
using System;
using System.Collections.Generic;
using UniRx;
using UnityEngine;
using UnityEngine.UI;

namespace ActionGame
{
    public class ClassRoomCharaFile : MonoBehaviour
    {
        [SerializeField]
        private ClassRoomFileListCtrl listCtrl;

        [SerializeField]
        [Label("決定ボタン")]
        private Button enterButton;

        private ReactiveProperty<ChaFileControl> info = new ReactiveProperty<ChaFileControl>();

        private Dictionary<int, ChaFileControl> chaFileDic = new Dictionary<int, ChaFileControl>();

        public event Action<ChaFileControl> onEnter = delegate
        {
        };

        public void InitializeList()
        {
            FolderAssist folderAssist = new FolderAssist();
            folderAssist.CreateFolderInfoEx(UserData.Path + "chara/female/", new string[1]
            {
                "*.png"
            });
            listCtrl.ClearList();
            chaFileDic.Clear();
            info.Value = null;
            int fileCount = folderAssist.GetFileCount();
            int num = 0;
            for (int i = 0; i < fileCount; i++)
            {
                FolderAssist.FileInfo fileInfo = folderAssist.lstFile[i];
                ChaFileControl chaFileControl = new ChaFileControl();
                if (chaFileControl.LoadCharaFile(fileInfo.FullPath) && chaFileControl.parameter.sex != 0)
                {
                    string empty = string.Empty;
                    string empty2 = string.Empty;
                    VoiceInfo.Param value;
                    empty2 = Singleton<Voice>.Instance.voiceInfoDic.TryGetValue(chaFileControl.parameter.personality, out value) ? value.Personality : "不明";
                    ClubInfo.Param value2;
                    empty = Game.ClubInfos.TryGetValue(chaFileControl.parameter.clubActivities, out value2) ? value2.Name : "不明";
                    listCtrl.AddList(num, chaFileControl.parameter.fullname, empty, empty2, fileInfo.FullPath, fileInfo.FileName, fileInfo.time);
                    chaFileDic.Add(num, chaFileControl);
                    num++;
                }
            }
            listCtrl.Create(delegate (CustomFileInfoComponent fic)
            {
                if (!(fic == null))
                {
                }
            });
        }

        private void Start()
        {
            InitializeList();
            listCtrl.OnPointerClick += delegate (CustomFileInfo info)
            {
                if (info != null)
                {
                    Utils.Sound.Play(SystemSE.sel);
                    this.info.Value = chaFileDic[info.index];
                }
                else
                {
                    this.info.Value = null;
                }
            };
            info.Select(p => p != null).SubscribeToInteractable(enterButton);
            enterButton.OnClickAsObservable().Subscribe(delegate
            {
                ChaFileControl chaFileControl = new ChaFileControl();
                ChaFile.CopyChaFile(chaFileControl, info.Value);
                chaFileControl.facePngData = info.Value.facePngData;
                onEnter(chaFileControl);
                Utils.Sound.Play(SystemSE.sel);
            });
        }
    }
}
