using Illusion.Game;
using Manager;
using System;
using UniRx;
using UniRx.Triggers;
using UnityEngine;
using UnityEngine.UI;

namespace ActionGame
{
    public class PreviewCharaList : BaseLoader
    {
        [SerializeField]
        private ClassRoomCharaFile charFile;

        [SerializeField]
        private Button cancel;

        [SerializeField]
        private Button cancel2;

        private BoolReactiveProperty canvasEnabled = new BoolReactiveProperty(false);

        public ClassRoomCharaFile CharFile
        {
            get
            {
                return charFile;
            }
        }

        public bool isVisible
        {
            get
            {
                return canvasEnabled.Value;
            }
            set
            {
                canvasEnabled.Value = value;
            }
        }

        public event Action<ChaFileControl> onEnter = delegate
        {
        };

        public event Action onCancel = delegate
        {
        };

        private void Start()
        {
            Canvas canvas = GetComponent<Canvas>();
            canvasEnabled.TakeUntilDestroy(this).Subscribe(delegate (bool isOn)
            {
                canvas.enabled = isOn;
            });
            CanvasGroup canvasGroup = GetComponent<CanvasGroup>();
            this.ObserveEveryValueChanged(_ => !Singleton<Scene>.Instance.IsNowLoadingFade).Subscribe(delegate (bool isOn)
            {
                canvasGroup.interactable = isOn;
            });
            charFile.onEnter += delegate (ChaFileControl file)
            {
                onEnter(file);
            };
            cancel.OnClickAsObservable().Subscribe(delegate
            {
                onCancel();
                Utils.Sound.Play(SystemSE.sel);
            });
            cancel2.OnClickAsObservable().Subscribe(delegate
            {
                onCancel();
                Utils.Sound.Play(SystemSE.sel);
            });
            (from _ in this.UpdateAsObservable()
             where canvas.enabled
             where Singleton<Scene>.Instance.NowSceneNames[0] == "ClassRoomSelect"
             where Input.GetMouseButtonDown(1)
             select _).Subscribe(delegate
         {
             onCancel();
         });
        }
    }
}
