using Illusion.Game;
using UnityEngine;
using UnityEngine.UI;

namespace ActionGame
{
    public class TalkWindow : MonoBehaviour
    {
        public static Transform LookTransform;

        [SerializeField]
        private Text text;

        private float timer;

        public Text Text
        {
            get
            {
                return text;
            }
        }

        public void Set(SaveData.CharaData chara, string text, AssetBundleData voice)
        {
            gameObject.SetActive(true);
            timer = 0f;
            Text.text = text;
            if (voice != null)
            {
                Utils.Voice.Setting setting = new Utils.Voice.Setting();
                setting.assetBundleName = voice.bundle;
                setting.assetName = voice.asset;
                SaveData.Heroine heroine = chara as SaveData.Heroine;
                if (heroine != null)
                {
                    setting.no = heroine.FixCharaIDOrPersonality;
                }
                else
                {
                    setting.no = chara.personality;
                }
                Utils.Voice.Play(setting);
            }
        }

        private void Start()
        {
        }

        private void Update()
        {
            if (LookTransform != null)
            {
                base.transform.LookAt(LookTransform);
                Transform transform = base.transform;
                Vector3 eulerAngles = base.transform.eulerAngles;
                transform.eulerAngles = new Vector3(0f, eulerAngles.y + 180f, 0f);
            }
            timer = Mathf.Min(timer + Time.deltaTime, Manager.Config.TextData.AutoWaitTime);
            if (timer >= Manager.Config.TextData.AutoWaitTime)
            {
                gameObject.SetActive(false);
            }
        }
    }
}
