using UnityEngine;

public class CameraEffectorColorMask : MonoBehaviour
{
    private Camera myCamera;

    private CameraEffector effector;

    private Camera effectorCamera;

    public bool Enabled
    {
        get
        {
            return enabled;
        }
        set
        {
            myCamera.enabled = value;
            enabled = value;
            effector.amplifyColor.MaskTexture = value ? myCamera.targetTexture : null;
        }
    }

    private void Awake()
    {
        myCamera = GetComponent<Camera>();
        if (myCamera == null)
        {
            Destroy(this);
        }
        effector = transform.parent.GetComponent<CameraEffector>();
        if (effector == null)
        {
            Destroy(gameObject);
        }
        effectorCamera = effector.GetComponent<Camera>();
        myCamera.CopyFrom(effectorCamera);
        myCamera.clearFlags = CameraClearFlags.Color;
        myCamera.backgroundColor = Color.black;
        myCamera.targetTexture = new RenderTexture(Screen.width, Screen.height, 24, RenderTextureFormat.ARGB32, RenderTextureReadWrite.Default);
        Enabled = false;
    }

    private void Update()
    {
        myCamera.fieldOfView = effectorCamera.fieldOfView;
    }
}
