using System;
using UniRx;
using UniRx.Triggers;
using UnityEngine;
using UnityEngine.UI;

namespace ChaCustom
{
    public class CustomAcsDragValue : MonoBehaviour
    {
        [SerializeField]
        private CustomAcsMoveWindow customAcsMoveWin;

        [SerializeField]
        private int type;

        [SerializeField]
        private int xyz;

        private Image imgCol;

        private void Awake()
        {
            imgCol = GetComponent<Image>();
        }

        private void Start()
        {
            float backMousePos = 0f;
            ObservableEventTrigger observableEventTrigger = gameObject.AddComponent<ObservableEventTrigger>();
            this.UpdateAsObservable().SkipUntil(observableEventTrigger.OnPointerDownAsObservable().Do(delegate
            {
                Vector3 mousePosition3 = Input.mousePosition;
                backMousePos = mousePosition3.x;
                if ((bool)imgCol)
                {
                    Image image2 = imgCol;
                    Color color4 = imgCol.color;
                    float r2 = color4.r;
                    Color color5 = imgCol.color;
                    float g2 = color5.g;
                    Color color6 = imgCol.color;
                    image2.color = new Color(r2, g2, color6.b, 1f);
                }
            })).TakeUntil(observableEventTrigger.OnPointerUpAsObservable().Do(delegate
            {
                if ((bool)imgCol)
                {
                    Image image = imgCol;
                    Color color = imgCol.color;
                    float r = color.r;
                    Color color2 = imgCol.color;
                    float g = color2.g;
                    Color color3 = imgCol.color;
                    image.color = new Color(r, g, color3.b, 0f);
                }
            }))
                .RepeatUntilDestroy(this)
                .Select((Func<Unit, float>)delegate
                {
                    Vector3 mousePosition2 = Input.mousePosition;
                    return mousePosition2.x - backMousePos;
                })
                .Subscribe(delegate (float move)
                {
                    Vector3 mousePosition = Input.mousePosition;
                    backMousePos = mousePosition.x;
                    if (type == 0 && xyz == 0)
                    {
                        move *= -1f;
                    }
                    customAcsMoveWin.UpdateDragValue(type, xyz, move);
                })
                .AddTo(this);
        }
    }
}
