using Illusion.Extensions;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using TMPro;
using UniRx;
using UnityEngine;
using UnityEngine.UI;

namespace ChaCustom
{
    public class CustomSelectWindow : MonoBehaviour
    {
        public enum SelectWindowType
        {
            FaceDetail,
            Eyebrow,
            EyelineUp,
            EyelineLow,
            EyeWhite,
            EyeHiUp,
            EyeHiLow,
            Pupil,
            PupilGrad,
            Nose,
            LipLine,
            Mole,
            EyeShadow,
            Cheek,
            Lip,
            FacePaint01,
            FacePaint02,
            BodyDetail,
            Nip,
            UnderHair,
            SunBurn,
            BodyPaint01,
            BodyPaint02,
            BodyPaint01Layout,
            BodyPaint02Layout,
            HairFront,
            HairBack,
            HairSide,
            HairOption,
            CosTop,
            CosSailorA,
            CosSailorB,
            CosSailorC,
            CosJacketA,
            CosJacketB,
            CosJacketC,
            CosPattern,
            Emblem,
            CosBot,
            CosBra,
            CosShorts,
            CosGloves,
            CosPanst,
            CosSocks,
            CosShoes,
            AcsHair,
            AcsHead,
            AcsFace,
            AcsNeck,
            AcsBody,
            AcsWaist,
            AcsLeg,
            AcsArm,
            AcsHand,
            AcsKokan,
            HairGloss,
            HeadType
        }

        [Serializable]
        public class TypeReactiveProperty : ReactiveProperty<SelectWindowType>
        {
            public TypeReactiveProperty()
            {
            }

            public TypeReactiveProperty(SelectWindowType initialValue)
                : base(initialValue)
            {
            }
        }

        [SerializeField]
        private TypeReactiveProperty _swType = new TypeReactiveProperty(SelectWindowType.FaceDetail);

        [SerializeField]
        private TextMeshProUGUI textTitle;

        [SerializeField]
        private Button btnClose;

        public Toggle tglReference;

        [SerializeField]
        private GameObject objTglCategory;

        [SerializeField]
        private GameObject objTglTemp;

        [HideInInspector]
        public Toggle[] tglCategory;

        public SelectWindowType swType
        {
            get
            {
                return _swType.Value;
            }
            set
            {
                _swType.Value = value;
            }
        }

        public void Awake()
        {
        }

        public IEnumerator Start()
        {
            yield return new WaitUntil(() => null != Singleton<CustomBase>.Instance.lstSelectList);
            _swType.TakeUntilDestroy(this).Subscribe(delegate
            {
                UpdateWindow();
            });
            if ((bool)btnClose)
            {
                btnClose.OnClickAsObservable().Subscribe(delegate
                {
                    if ((bool)tglReference)
                    {
                        tglReference.isOn = false;
                    }
                });
            }
        }

        public void UpdateWindow()
        {
            List<ExcelData.Param> lstSelectList = Singleton<CustomBase>.Instance.lstSelectList;
            ExcelData.Param param = lstSelectList.FirstOrDefault(x => swType.ToString() == x.list[1]);
            if (param == null)
            {
                return;
            }
            if (null != textTitle)
            {
                textTitle.text = param.list[2];
            }
            if ((bool)objTglCategory)
            {
                objTglCategory.SetActiveIfDifferent("1" == param.list[3]);
            }
            List<Toggle> list = new List<Toggle>();
            int num = param.list.Count - 4;
            for (int i = 0; i < num && !("0" == param.list[4 + i]); i++)
            {
                GameObject gameObject = Instantiate(objTglTemp, objTglCategory.transform, false);
                if (null == gameObject)
                {
                    break;
                }
                Transform transform = gameObject.transform.Find("textCate");
                if (null == transform)
                {
                    break;
                }
                TextMeshProUGUI component = transform.GetComponent<TextMeshProUGUI>();
                if ((bool)component)
                {
                    component.text = param.list[4 + i];
                }
                Toggle component2 = gameObject.GetComponent<Toggle>();
                gameObject.SetActiveIfDifferent(true);
                list.Add(component2);
            }
            if (list.Count != 0)
            {
                tglCategory = list.ToArray();
            }
        }
    }
}
