using System.Linq;
using UniRx;
using UnityEngine;
using UnityEngine.UI;

namespace ChaCustom
{
    public class CvsAttribute : MonoBehaviour
    {
        [SerializeField]
        private Toggle[] tglAttribute;

        [SerializeField]
        private Button btnRandom;

        [SerializeField]
        private Button btnAllOn;

        [SerializeField]
        private Button btnAllOff;

        private CustomBase customBase
        {
            get
            {
                return Singleton<CustomBase>.Instance;
            }
        }

        private ChaControl chaCtrl
        {
            get
            {
                return customBase.chaCtrl;
            }
        }

        private ChaFileParameter param
        {
            get
            {
                return chaCtrl.chaFile.parameter;
            }
        }

        public void CalculateUI()
        {
            bool[] attribute = chaCtrl.GetAttribute();
            for (int i = 0; i < tglAttribute.Length; i++)
            {
                tglAttribute[i].isOn = attribute[i];
            }
        }

        public virtual void UpdateCustomUI()
        {
            CalculateUI();
        }

        public void SetAttribute(int idx, bool flag)
        {
            switch (idx)
            {
                case 0:
                    param.attribute.hinnyo = flag;
                    break;
                case 1:
                    param.attribute.harapeko = flag;
                    break;
                case 2:
                    param.attribute.donkan = flag;
                    break;
                case 3:
                    param.attribute.choroi = flag;
                    break;
                case 4:
                    param.attribute.bitch = flag;
                    break;
                case 5:
                    param.attribute.mutturi = flag;
                    break;
                case 6:
                    param.attribute.dokusyo = flag;
                    break;
                case 7:
                    param.attribute.ongaku = flag;
                    break;
                case 8:
                    param.attribute.kappatu = flag;
                    break;
                case 9:
                    param.attribute.ukemi = flag;
                    break;
                case 10:
                    param.attribute.friendly = flag;
                    break;
                case 11:
                    param.attribute.kireizuki = flag;
                    break;
                case 12:
                    param.attribute.taida = flag;
                    break;
                case 13:
                    param.attribute.sinsyutu = flag;
                    break;
                case 14:
                    param.attribute.hitori = flag;
                    break;
                case 15:
                    param.attribute.undo = flag;
                    break;
                case 16:
                    param.attribute.majime = flag;
                    break;
                case 17:
                    param.attribute.likeGirls = flag;
                    break;
            }
        }

        protected virtual void Awake()
        {
        }

        protected virtual void Start()
        {
            customBase.actUpdateCvsAttribute += UpdateCustomUI;
            tglAttribute.Select((p, idx) => new
            {
                toggle = p,
                index = (byte)idx
            }).ToList().ForEach(p =>
            {
                CvsAttribute cvsAttribute = this;
                p.toggle.OnValueChangedAsObservable().Subscribe(delegate (bool isOn)
                {
                    if (!cvsAttribute.customBase.updateCustomUI)
                    {
                        bool attribute = cvsAttribute.chaCtrl.GetAttribute(p.index);
                        if (attribute != isOn)
                        {
                            cvsAttribute.SetAttribute(p.index, isOn);
                        }
                    }
                });
            });
            btnRandom.OnClickAsObservable().Subscribe(delegate
            {
                for (int k = 0; k < tglAttribute.Length; k++)
                {
                    tglAttribute[k].isOn = Random.Range(0, 2) != 0;
                }
            });
            btnAllOn.OnClickAsObservable().Subscribe(delegate
            {
                for (int j = 0; j < tglAttribute.Length; j++)
                {
                    tglAttribute[j].isOn = true;
                }
            });
            btnAllOff.OnClickAsObservable().Subscribe(delegate
            {
                for (int i = 0; i < tglAttribute.Length; i++)
                {
                    tglAttribute[i].isOn = false;
                }
            });
        }
    }
}
