using System.Collections;
using System.Linq;
using TMPro;
using UniRx;
using UniRx.Triggers;
using UnityEngine;
using UnityEngine.EventSystems;
using UnityEngine.UI;

namespace ChaCustom
{
    public class CvsBodyLower : MonoBehaviour
    {
        [SerializeField]
        private Slider sldWaistY;

        [SerializeField]
        private TMP_InputField inpWaistY;

        [SerializeField]
        private Button btnWaistY;

        [SerializeField]
        private Slider sldBelly;

        [SerializeField]
        private TMP_InputField inpBelly;

        [SerializeField]
        private Button btnBelly;

        [SerializeField]
        private Slider sldWaistUpW;

        [SerializeField]
        private TMP_InputField inpWaistUpW;

        [SerializeField]
        private Button btnWaistUpW;

        [SerializeField]
        private Slider sldWaistUpZ;

        [SerializeField]
        private TMP_InputField inpWaistUpZ;

        [SerializeField]
        private Button btnWaistUpZ;

        [SerializeField]
        private Slider sldWaistLowW;

        [SerializeField]
        private TMP_InputField inpWaistLowW;

        [SerializeField]
        private Button btnWaistLowW;

        [SerializeField]
        private Slider sldWaistLowZ;

        [SerializeField]
        private TMP_InputField inpWaistLowZ;

        [SerializeField]
        private Button btnWaistLowZ;

        [SerializeField]
        private Slider sldHip;

        [SerializeField]
        private TMP_InputField inpHip;

        [SerializeField]
        private Button btnHip;

        [SerializeField]
        private Slider sldHipRotX;

        [SerializeField]
        private TMP_InputField inpHipRotX;

        [SerializeField]
        private Button btnHipRotX;

        private Slider[] sliders;

        private TMP_InputField[] inputs;

        private Button[] buttons;

        private readonly int[] arrIndex = new int[8]
        {
            20,
            21,
            22,
            23,
            24,
            25,
            26,
            27
        };

        private ChaControl chaCtrl
        {
            get
            {
                return Singleton<CustomBase>.Instance.chaCtrl;
            }
        }

        private ChaFileBody body
        {
            get
            {
                return chaCtrl.chaFile.custom.body;
            }
        }

        public void CalculateUI()
        {
            float[] shapeValueBody = body.shapeValueBody;
            for (int i = 0; i < sliders.Length; i++)
            {
                if (!(null == sliders[i]))
                {
                    sliders[i].value = shapeValueBody[arrIndex[i]];
                }
            }
        }

        public virtual void UpdateCustomUI()
        {
            CalculateUI();
        }

        public IEnumerator SetInputText()
        {
            yield return new WaitUntil(() => null != chaCtrl);
            float[] shape = body.shapeValueBody;
            for (int i = 0; i < inputs.Length; i++)
            {
                if (!(null == inputs[i]))
                {
                    inputs[i].text = CustomBase.ConvertTextFromRate(0, 100, shape[arrIndex[i]]);
                }
            }
        }

        protected virtual void Awake()
        {
            sliders = new Slider[8]
            {
                sldWaistY,
                sldBelly,
                sldWaistUpW,
                sldWaistUpZ,
                sldWaistLowW,
                sldWaistLowZ,
                sldHip,
                sldHipRotX
            };
            inputs = new TMP_InputField[8]
            {
                inpWaistY,
                inpBelly,
                inpWaistUpW,
                inpWaistUpZ,
                inpWaistLowW,
                inpWaistLowZ,
                inpHip,
                inpHipRotX
            };
            buttons = new Button[8]
            {
                btnWaistY,
                btnBelly,
                btnWaistUpW,
                btnWaistUpZ,
                btnWaistLowW,
                btnWaistLowZ,
                btnHip,
                btnHipRotX
            };
        }

        protected virtual void Start()
        {
            TMP_InputField[] array = inputs;
            foreach (TMP_InputField item in array)
            {
                Singleton<CustomBase>.Instance.lstTmpInputField.Add(item);
            }
            Singleton<CustomBase>.Instance.actUpdateCvsBodyLower += UpdateCustomUI;
            sliders.Select((p, index) => new
            {
                slider = p, index
            }).ToList().ForEach(p =>
            {
                CvsBodyLower cvsBodyLower3 = this;
                p.slider.onValueChanged.AsObservable().Subscribe(delegate (float value)
                {
                    cvsBodyLower3.chaCtrl.SetShapeBodyValue(cvsBodyLower3.arrIndex[p.index], p.slider.value);
                    cvsBodyLower3.inputs[p.index].text = CustomBase.ConvertTextFromRate(0, 100, value);
                });
                p.slider.OnScrollAsObservable().Subscribe(delegate (PointerEventData scl)
                {
                    Slider slider = p.slider;
                    float value3 = p.slider.value;
                    Vector2 scrollDelta = scl.scrollDelta;
                    slider.value = Mathf.Clamp(value3 + scrollDelta.y * Singleton<CustomBase>.Instance.sliderWheelSensitive, 0f, 100f);
                    cvsBodyLower3.inputs[p.index].text = CustomBase.ConvertTextFromRate(0, 100, p.slider.value);
                });
            });
            inputs.Select((p, index) => new
            {
                input = p, index
            }).ToList().ForEach(p =>
            {
                CvsBodyLower cvsBodyLower2 = this;
                p.input.onEndEdit.AsObservable().Subscribe(delegate (string value)
                {
                    cvsBodyLower2.sliders[p.index].value = CustomBase.ConvertRateFromText(0, 100, value);
                });
            });
            buttons.Select((p, index) => new
            {
                button = p, index
            }).ToList().ForEach(p =>
            {
                CvsBodyLower cvsBodyLower = this;
                p.button.onClick.AsObservable().Subscribe(delegate
                {
                    float value2 = Singleton<CustomBase>.Instance.defChaInfo.custom.body.shapeValueBody[cvsBodyLower.arrIndex[p.index]];
                    cvsBodyLower.chaCtrl.SetShapeBodyValue(cvsBodyLower.arrIndex[p.index], value2);
                    cvsBodyLower.inputs[p.index].text = CustomBase.ConvertTextFromRate(0, 100, value2);
                    cvsBodyLower.sliders[p.index].value = value2;
                });
            });
            StartCoroutine(SetInputText());
        }
    }
}
