using Illusion.Extensions;
using System.Collections;
using System.Linq;
using TMPro;
using UniRx;
using UniRx.Triggers;
using UnityEngine;
using UnityEngine.EventSystems;
using UnityEngine.UI;

namespace ChaCustom
{
    public class CvsBreast : MonoBehaviour
    {
        [SerializeField]
        private Slider sldBustSize;

        [SerializeField]
        private TMP_InputField inpBustSize;

        [SerializeField]
        private Button btnBustSize;

        [SerializeField]
        private Slider sldBustY;

        [SerializeField]
        private TMP_InputField inpBustY;

        [SerializeField]
        private Button btnBustY;

        [SerializeField]
        private Slider sldBustRotX;

        [SerializeField]
        private TMP_InputField inpBustRotX;

        [SerializeField]
        private Button btnBustRotX;

        [SerializeField]
        private Slider sldBustX;

        [SerializeField]
        private TMP_InputField inpBustX;

        [SerializeField]
        private Button btnBustX;

        [SerializeField]
        private Slider sldBustRotY;

        [SerializeField]
        private TMP_InputField inpBustRotY;

        [SerializeField]
        private Button btnBustRotY;

        [SerializeField]
        private Slider sldBustSharp;

        [SerializeField]
        private TMP_InputField inpBustSharp;

        [SerializeField]
        private Button btnBustSharp;

        [SerializeField]
        private Slider sldBustForm;

        [SerializeField]
        private TMP_InputField inpBustForm;

        [SerializeField]
        private Button btnBustForm;

        [Header("胸の柔らかさ")]
        [SerializeField]
        private Slider sldBustSoftness;

        [SerializeField]
        private TMP_InputField inpBustSoftness;

        [SerializeField]
        private Button btnBustSoftness;

        [SerializeField]
        [Header("胸の重さ")]
        private Slider sldBustWeight;

        [SerializeField]
        private TMP_InputField inpBustWeight;

        [SerializeField]
        private Button btnBustWeight;

        [SerializeField]
        [Header("")]
        private Slider sldAreolaBulge;

        [SerializeField]
        private TMP_InputField inpAreolaBulge;

        [SerializeField]
        private Button btnAreolaBulge;

        [SerializeField]
        private Slider sldNipWeight;

        [SerializeField]
        private TMP_InputField inpNipWeight;

        [SerializeField]
        private Button btnNipWeight;

        [SerializeField]
        private Slider sldNipStand;

        [SerializeField]
        private TMP_InputField inpNipStand;

        [SerializeField]
        private Button btnNipStand;

        [SerializeField]
        [Header("乳輪の大きさ")]
        private Slider sldAreolaSize;

        [SerializeField]
        private TMP_InputField inpAreolaSize;

        [SerializeField]
        private Button btnAreolaSize;

        [Header("")]
        [SerializeField]
        private Toggle tglNipKind;

        [SerializeField]
        private Image imgNipKind;

        [SerializeField]
        private TextMeshProUGUI textNipKind;

        [SerializeField]
        private CustomSelectKind customNip;

        [SerializeField]
        private CanvasGroup cgNipWin;

        [SerializeField]
        private CvsColor cvsColor;

        [SerializeField]
        private Button btnNipColor;

        [SerializeField]
        private Image imgNipColor;

        [SerializeField]
        private Slider sldGlossPow;

        [SerializeField]
        private TMP_InputField inpGlossPow;

        [SerializeField]
        private Button btnGlossPow;

        private Slider[] sliders;

        private TMP_InputField[] inputs;

        private Button[] buttons;

        private readonly int[] arrIndex = new int[10]
        {
            4,
            5,
            6,
            7,
            8,
            9,
            10,
            11,
            12,
            13
        };

        private ChaControl chaCtrl
        {
            get
            {
                return Singleton<CustomBase>.Instance.chaCtrl;
            }
        }

        private ChaFileBody body
        {
            get
            {
                return chaCtrl.chaFile.custom.body;
            }
        }

        public void CalculateUI()
        {
            float[] shapeValueBody = body.shapeValueBody;
            for (int i = 0; i < sliders.Length; i++)
            {
                if (!(null == sliders[i]))
                {
                    sliders[i].value = shapeValueBody[arrIndex[i]];
                }
            }
            sldBustSoftness.value = body.bustSoftness;
            sldBustWeight.value = body.bustWeight;
            sldAreolaSize.value = body.areolaSize;
            imgNipColor.color = body.nipColor;
            sldGlossPow.value = body.nipGlossPower;
        }

        public virtual void UpdateCustomUI()
        {
            CalculateUI();
            if (null != customNip)
            {
                customNip.UpdateCustomUI();
            }
            if (cvsColor.CheckConnectKind(CvsColor.ConnectColorKind.Nip))
            {
                cvsColor.SetColor(body.nipColor);
            }
        }

        public IEnumerator SetInputText()
        {
            yield return new WaitUntil(() => null != chaCtrl);
            float[] shape = body.shapeValueBody;
            for (int i = 0; i < inputs.Length; i++)
            {
                if (!(null == inputs[i]))
                {
                    inputs[i].text = CustomBase.ConvertTextFromRate(0, 100, shape[arrIndex[i]]);
                }
            }
            inpBustSoftness.text = CustomBase.ConvertTextFromRate(0, 100, body.bustSoftness);
            inpBustWeight.text = CustomBase.ConvertTextFromRate(0, 100, body.bustWeight);
            inpAreolaSize.text = CustomBase.ConvertTextFromRate(0, 100, body.areolaSize);
            inpGlossPow.text = CustomBase.ConvertTextFromRate(0, 100, body.nipGlossPower);
        }

        public void UpdateSelectNipKind(string name, Sprite sp, int index)
        {
            if ((bool)textNipKind)
            {
                textNipKind.text = name;
            }
            if ((bool)imgNipKind)
            {
                imgNipKind.sprite = sp;
            }
            if (body.nipId != index)
            {
                body.nipId = index;
                chaCtrl.ChangeSettingNip();
            }
        }

        public void UpdateNipColor(Color color)
        {
            body.nipColor = color;
            imgNipColor.color = color;
            chaCtrl.ChangeSettingNipColor();
        }

        public void SetDefaultColorWindow()
        {
            cvsColor.Setup("乳首の色", CvsColor.ConnectColorKind.Nip, body.nipColor, UpdateNipColor, true);
        }

        protected virtual void Awake()
        {
            sliders = new Slider[10]
            {
                sldBustSize,
                sldBustY,
                sldBustRotX,
                sldBustX,
                sldBustRotY,
                sldBustSharp,
                sldBustForm,
                sldAreolaBulge,
                sldNipWeight,
                sldNipStand
            };
            inputs = new TMP_InputField[10]
            {
                inpBustSize,
                inpBustY,
                inpBustRotX,
                inpBustX,
                inpBustRotY,
                inpBustSharp,
                inpBustForm,
                inpAreolaBulge,
                inpNipWeight,
                inpNipStand
            };
            buttons = new Button[10]
            {
                btnBustSize,
                btnBustY,
                btnBustRotX,
                btnBustX,
                btnBustRotY,
                btnBustSharp,
                btnBustForm,
                btnAreolaBulge,
                btnNipWeight,
                btnNipStand
            };
        }

        protected virtual void Start()
        {
            if (chaCtrl.sex == 0)
            {
                if ((bool)sldBustForm)
                {
                    sldBustForm.transform.parent.gameObject.SetActiveIfDifferent(false);
                }
                if ((bool)sldAreolaBulge)
                {
                    sldAreolaBulge.transform.parent.gameObject.SetActiveIfDifferent(false);
                }
                if ((bool)sldNipWeight)
                {
                    sldNipWeight.transform.parent.gameObject.SetActiveIfDifferent(false);
                }
                if ((bool)sldNipStand)
                {
                    sldNipStand.transform.parent.gameObject.SetActiveIfDifferent(false);
                }
            }
            TMP_InputField[] array = inputs;
            foreach (TMP_InputField item in array)
            {
                Singleton<CustomBase>.Instance.lstTmpInputField.Add(item);
            }
            Singleton<CustomBase>.Instance.lstTmpInputField.Add(inpBustSoftness);
            Singleton<CustomBase>.Instance.lstTmpInputField.Add(inpBustWeight);
            Singleton<CustomBase>.Instance.lstTmpInputField.Add(inpAreolaSize);
            Singleton<CustomBase>.Instance.lstTmpInputField.Add(inpGlossPow);
            Singleton<CustomBase>.Instance.actUpdateCvsBreast += UpdateCustomUI;
            sliders.Select((p, index) => new
            {
                slider = p, index
            }).ToList().ForEach(p =>
            {
                CvsBreast cvsBreast3 = this;
                p.slider.onValueChanged.AsObservable().Subscribe(delegate (float value)
                {
                    cvsBreast3.chaCtrl.SetShapeBodyValue(cvsBreast3.arrIndex[p.index], p.slider.value);
                    cvsBreast3.inputs[p.index].text = CustomBase.ConvertTextFromRate(0, 100, value);
                });
                p.slider.OnScrollAsObservable().Subscribe(delegate (PointerEventData scl)
                {
                    Slider slider5 = p.slider;
                    float value7 = p.slider.value;
                    Vector2 scrollDelta5 = scl.scrollDelta;
                    slider5.value = Mathf.Clamp(value7 + scrollDelta5.y * Singleton<CustomBase>.Instance.sliderWheelSensitive, 0f, 100f);
                    cvsBreast3.inputs[p.index].text = CustomBase.ConvertTextFromRate(0, 100, p.slider.value);
                });
            });
            inputs.Select((p, index) => new
            {
                input = p, index
            }).ToList().ForEach(p =>
            {
                CvsBreast cvsBreast2 = this;
                p.input.onEndEdit.AsObservable().Subscribe(delegate (string value)
                {
                    cvsBreast2.sliders[p.index].value = CustomBase.ConvertRateFromText(0, 100, value);
                });
            });
            buttons.Select((p, index) => new
            {
                button = p, index
            }).ToList().ForEach(p =>
            {
                CvsBreast cvsBreast = this;
                p.button.onClick.AsObservable().Subscribe(delegate
                {
                    float value6 = Singleton<CustomBase>.Instance.defChaInfo.custom.body.shapeValueBody[cvsBreast.arrIndex[p.index]];
                    cvsBreast.chaCtrl.SetShapeBodyValue(cvsBreast.arrIndex[p.index], value6);
                    cvsBreast.inputs[p.index].text = CustomBase.ConvertTextFromRate(0, 100, value6);
                    cvsBreast.sliders[p.index].value = value6;
                });
            });
            sldBustSoftness.onValueChanged.AsObservable().Subscribe(delegate (float value)
            {
                body.bustSoftness = value;
                chaCtrl.UpdateBustSoftness();
                inpBustSoftness.text = CustomBase.ConvertTextFromRate(0, 100, value);
            });
            sldBustSoftness.OnScrollAsObservable().Subscribe(delegate (PointerEventData scl)
            {
                Slider slider4 = sldBustSoftness;
                float value5 = sldBustSoftness.value;
                Vector2 scrollDelta4 = scl.scrollDelta;
                slider4.value = Mathf.Clamp(value5 + scrollDelta4.y * Singleton<CustomBase>.Instance.sliderWheelSensitive, 0f, 100f);
                inpBustSoftness.text = CustomBase.ConvertTextFromRate(0, 100, sldBustSoftness.value);
            });
            inpBustSoftness.onEndEdit.AsObservable().Subscribe(delegate (string value)
            {
                sldBustSoftness.value = CustomBase.ConvertRateFromText(0, 100, value);
            });
            btnBustSoftness.onClick.AsObservable().Subscribe(delegate
            {
                float bustSoftness = Singleton<CustomBase>.Instance.defChaInfo.custom.body.bustSoftness;
                body.bustSoftness = bustSoftness;
                chaCtrl.UpdateBustSoftness();
                inpBustSoftness.text = CustomBase.ConvertTextFromRate(0, 100, bustSoftness);
                sldBustSoftness.value = bustSoftness;
            });
            sldBustWeight.onValueChanged.AsObservable().Subscribe(delegate (float value)
            {
                body.bustWeight = value;
                chaCtrl.UpdateBustGravity();
                inpBustWeight.text = CustomBase.ConvertTextFromRate(0, 100, value);
            });
            sldBustWeight.OnScrollAsObservable().Subscribe(delegate (PointerEventData scl)
            {
                Slider slider3 = sldBustWeight;
                float value4 = sldBustWeight.value;
                Vector2 scrollDelta3 = scl.scrollDelta;
                slider3.value = Mathf.Clamp(value4 + scrollDelta3.y * Singleton<CustomBase>.Instance.sliderWheelSensitive, 0f, 100f);
                inpBustWeight.text = CustomBase.ConvertTextFromRate(0, 100, sldBustWeight.value);
            });
            inpBustWeight.onEndEdit.AsObservable().Subscribe(delegate (string value)
            {
                sldBustWeight.value = CustomBase.ConvertRateFromText(0, 100, value);
            });
            btnBustWeight.onClick.AsObservable().Subscribe(delegate
            {
                float bustWeight = Singleton<CustomBase>.Instance.defChaInfo.custom.body.bustWeight;
                body.bustWeight = bustWeight;
                chaCtrl.UpdateBustGravity();
                inpBustWeight.text = CustomBase.ConvertTextFromRate(0, 100, bustWeight);
                sldBustWeight.value = bustWeight;
            });
            sldAreolaSize.onValueChanged.AsObservable().Subscribe(delegate (float value)
            {
                body.areolaSize = value;
                chaCtrl.ChangeSettingAreolaSize();
                inpAreolaSize.text = CustomBase.ConvertTextFromRate(0, 100, value);
            });
            sldAreolaSize.OnScrollAsObservable().Subscribe(delegate (PointerEventData scl)
            {
                Slider slider2 = sldAreolaSize;
                float value3 = sldAreolaSize.value;
                Vector2 scrollDelta2 = scl.scrollDelta;
                slider2.value = Mathf.Clamp(value3 + scrollDelta2.y * Singleton<CustomBase>.Instance.sliderWheelSensitive, 0f, 100f);
                inpAreolaSize.text = CustomBase.ConvertTextFromRate(0, 100, sldAreolaSize.value);
            });
            inpAreolaSize.onEndEdit.AsObservable().Subscribe(delegate (string value)
            {
                sldAreolaSize.value = CustomBase.ConvertRateFromText(0, 100, value);
            });
            btnAreolaSize.onClick.AsObservable().Subscribe(delegate
            {
                float areolaSize = Singleton<CustomBase>.Instance.defChaInfo.custom.body.areolaSize;
                body.areolaSize = areolaSize;
                chaCtrl.ChangeSettingAreolaSize();
                inpAreolaSize.text = CustomBase.ConvertTextFromRate(0, 100, areolaSize);
                sldAreolaSize.value = areolaSize;
            });
            tglNipKind.OnValueChangedAsObservable().Subscribe(delegate (bool isOn)
            {
                if ((bool)cgNipWin)
                {
                    bool flag = cgNipWin.alpha != 0f;
                    if (flag != isOn)
                    {
                        cgNipWin.Enable(isOn);
                    }
                }
            });
            btnNipColor.OnClickAsObservable().Subscribe(delegate
            {
                if (cvsColor.isOpen && cvsColor.connectColorKind == CvsColor.ConnectColorKind.Nip)
                {
                    cvsColor.Close();
                }
                else
                {
                    SetDefaultColorWindow();
                }
            });
            sldGlossPow.onValueChanged.AsObservable().Subscribe(delegate (float value)
            {
                body.nipGlossPower = value;
                chaCtrl.ChangeSettingNipGlossPower();
                inpGlossPow.text = CustomBase.ConvertTextFromRate(0, 100, value);
            });
            sldGlossPow.OnScrollAsObservable().Subscribe(delegate (PointerEventData scl)
            {
                Slider slider = sldGlossPow;
                float value2 = sldGlossPow.value;
                Vector2 scrollDelta = scl.scrollDelta;
                slider.value = Mathf.Clamp(value2 + scrollDelta.y * Singleton<CustomBase>.Instance.sliderWheelSensitive, 0f, 100f);
                inpGlossPow.text = CustomBase.ConvertTextFromRate(0, 100, sldGlossPow.value);
            });
            inpGlossPow.onEndEdit.AsObservable().Subscribe(delegate (string value)
            {
                sldGlossPow.value = CustomBase.ConvertRateFromText(0, 100, value);
            });
            btnGlossPow.onClick.AsObservable().Subscribe(delegate
            {
                float nipGlossPower = Singleton<CustomBase>.Instance.defChaInfo.custom.body.nipGlossPower;
                body.nipGlossPower = nipGlossPower;
                chaCtrl.ChangeSettingNipGlossPower();
                inpGlossPow.text = CustomBase.ConvertTextFromRate(0, 100, nipGlossPower);
                sldGlossPow.value = nipGlossPower;
            });
            StartCoroutine(SetInputText());
        }
    }
}
