using Manager;
using System;
using System.Linq;
using TMPro;
using UnityEngine;
using UnityEngine.UI;

namespace ChaCustom
{
    public class CvsCharaEx : MonoBehaviour
    {
        [SerializeField]
        private Text textName;

        [SerializeField]
        private Text textNickName;

        [SerializeField]
        private TextMeshProUGUI textPersonality;

        [SerializeField]
        private TextMeshProUGUI textBloodType;

        [SerializeField]
        private TextMeshProUGUI textBirthDay;

        [SerializeField]
        private TextMeshProUGUI textClubActivity;

        private CustomBase customBase
        {
            get
            {
                return Singleton<CustomBase>.Instance;
            }
        }

        private ChaControl chaCtrl
        {
            get
            {
                return customBase.chaCtrl;
            }
        }

        private ChaFileParameter param
        {
            get
            {
                return chaCtrl.chaFile.parameter;
            }
        }

        public void CalculateUI()
        {
            textName.text = ":　" + param.fullname;
            textNickName.text = ":　" + param.nickname;
            int[] array = customBase.dictPersonality.Keys.ToArray();
            string[] array2 = customBase.dictPersonality.Values.ToArray();
            int num = Array.IndexOf(array, param.personality);
            if (num == -1)
            {
                textPersonality.text = ":　" + array2[0];
            }
            else
            {
                textPersonality.text = ":　" + array2[num];
            }
            textBloodType.text = ":　" + ChaFileDefine.GetBloodTypeStr(param.bloodType);
            textBirthDay.text = ":　" + param.strBirthDay;
            ClubInfo.Param value;
            if (!Game.ClubInfos.TryGetValue(param.clubActivities, out value))
            {
                Game.ClubInfos.TryGetValue(0, out value);
            }
            if (value == null)
            {
                textClubActivity.text = ":　不明";
            }
            else
            {
                textClubActivity.text = ":　" + value.Name;
            }
        }

        public virtual void UpdateCustomUI()
        {
            CalculateUI();
        }

        protected virtual void Start()
        {
            customBase.actUpdateCvsChara += UpdateCustomUI;
        }
    }
}
