using System.Collections;
using System.Linq;
using TMPro;
using UniRx;
using UniRx.Triggers;
using UnityEngine;
using UnityEngine.EventSystems;
using UnityEngine.UI;

namespace ChaCustom
{
    public class CvsCheek : MonoBehaviour
    {
        [SerializeField]
        private Slider sldCheekBoneW;

        [SerializeField]
        private TMP_InputField inpCheekBoneW;

        [SerializeField]
        private Button btnCheekBoneW;

        [SerializeField]
        private Slider sldCheekBoneZ;

        [SerializeField]
        private TMP_InputField inpCheekBoneZ;

        [SerializeField]
        private Button btnCheekBoneZ;

        [SerializeField]
        private Slider sldCheekW;

        [SerializeField]
        private TMP_InputField inpCheekW;

        [SerializeField]
        private Button btnCheekW;

        [SerializeField]
        private Slider sldCheekZ;

        [SerializeField]
        private TMP_InputField inpCheekZ;

        [SerializeField]
        private Button btnCheekZ;

        [SerializeField]
        private Slider sldCheekY;

        [SerializeField]
        private TMP_InputField inpCheekY;

        [SerializeField]
        private Button btnCheekY;

        [SerializeField]
        private Slider sldGlossPow;

        [SerializeField]
        private TMP_InputField inpGlossPow;

        [SerializeField]
        private Button btnGlossPow;

        private Slider[] sliders;

        private TMP_InputField[] inputs;

        private Button[] buttons;

        private readonly int[] arrIndex = new int[5]
        {
            14,
            15,
            16,
            17,
            18
        };

        private ChaControl chaCtrl
        {
            get
            {
                return Singleton<CustomBase>.Instance.chaCtrl;
            }
        }

        private ChaFileFace face
        {
            get
            {
                return chaCtrl.chaFile.custom.face;
            }
        }

        public void CalculateUI()
        {
            float[] shapeValueFace = face.shapeValueFace;
            for (int i = 0; i < sliders.Length; i++)
            {
                if (!(null == sliders[i]))
                {
                    sliders[i].value = shapeValueFace[arrIndex[i]];
                }
            }
            sldGlossPow.value = face.cheekGlossPower;
        }

        public virtual void UpdateCustomUI()
        {
            CalculateUI();
        }

        public IEnumerator SetInputText()
        {
            yield return new WaitUntil(() => null != chaCtrl);
            float[] shape = face.shapeValueFace;
            for (int i = 0; i < inputs.Length; i++)
            {
                if (!(null == inputs[i]))
                {
                    inputs[i].text = CustomBase.ConvertTextFromRate(0, 100, shape[arrIndex[i]]);
                }
            }
            inpGlossPow.text = CustomBase.ConvertTextFromRate(0, 100, face.cheekGlossPower);
        }

        protected virtual void Awake()
        {
            sliders = new Slider[5]
            {
                sldCheekBoneW,
                sldCheekBoneZ,
                sldCheekW,
                sldCheekZ,
                sldCheekY
            };
            inputs = new TMP_InputField[5]
            {
                inpCheekBoneW,
                inpCheekBoneZ,
                inpCheekW,
                inpCheekZ,
                inpCheekY
            };
            buttons = new Button[5]
            {
                btnCheekBoneW,
                btnCheekBoneZ,
                btnCheekW,
                btnCheekZ,
                btnCheekY
            };
        }

        protected virtual void Start()
        {
            TMP_InputField[] array = inputs;
            foreach (TMP_InputField item in array)
            {
                Singleton<CustomBase>.Instance.lstTmpInputField.Add(item);
            }
            Singleton<CustomBase>.Instance.lstTmpInputField.Add(inpGlossPow);
            Singleton<CustomBase>.Instance.actUpdateCvsCheek += UpdateCustomUI;
            sliders.Select((p, index) => new
            {
                slider = p, index
            }).ToList().ForEach(p =>
            {
                CvsCheek cvsCheek3 = this;
                p.slider.onValueChanged.AsObservable().Subscribe(delegate (float value)
                {
                    cvsCheek3.chaCtrl.SetShapeFaceValue(cvsCheek3.arrIndex[p.index], p.slider.value);
                    cvsCheek3.inputs[p.index].text = CustomBase.ConvertTextFromRate(0, 100, value);
                });
                p.slider.OnScrollAsObservable().Subscribe(delegate (PointerEventData scl)
                {
                    Slider slider2 = p.slider;
                    float value4 = p.slider.value;
                    Vector2 scrollDelta2 = scl.scrollDelta;
                    slider2.value = Mathf.Clamp(value4 + scrollDelta2.y * Singleton<CustomBase>.Instance.sliderWheelSensitive, 0f, 100f);
                    cvsCheek3.inputs[p.index].text = CustomBase.ConvertTextFromRate(0, 100, p.slider.value);
                });
            });
            inputs.Select((p, index) => new
            {
                input = p, index
            }).ToList().ForEach(p =>
            {
                CvsCheek cvsCheek2 = this;
                p.input.onEndEdit.AsObservable().Subscribe(delegate (string value)
                {
                    cvsCheek2.sliders[p.index].value = CustomBase.ConvertRateFromText(0, 100, value);
                });
            });
            buttons.Select((p, index) => new
            {
                button = p, index
            }).ToList().ForEach(p =>
            {
                CvsCheek cvsCheek = this;
                p.button.onClick.AsObservable().Subscribe(delegate
                {
                    float value3 = Singleton<CustomBase>.Instance.defChaInfo.custom.face.shapeValueFace[cvsCheek.arrIndex[p.index]];
                    cvsCheek.chaCtrl.SetShapeFaceValue(cvsCheek.arrIndex[p.index], value3);
                    cvsCheek.inputs[p.index].text = CustomBase.ConvertTextFromRate(0, 100, value3);
                    cvsCheek.sliders[p.index].value = value3;
                });
            });
            sldGlossPow.onValueChanged.AsObservable().Subscribe(delegate (float value)
            {
                face.cheekGlossPower = value;
                chaCtrl.ChangeSettingCheekGlossPower();
                inpGlossPow.text = CustomBase.ConvertTextFromRate(0, 100, value);
            });
            sldGlossPow.OnScrollAsObservable().Subscribe(delegate (PointerEventData scl)
            {
                Slider slider = sldGlossPow;
                float value2 = sldGlossPow.value;
                Vector2 scrollDelta = scl.scrollDelta;
                slider.value = Mathf.Clamp(value2 + scrollDelta.y * Singleton<CustomBase>.Instance.sliderWheelSensitive, 0f, 100f);
                inpGlossPow.text = CustomBase.ConvertTextFromRate(0, 100, sldGlossPow.value);
            });
            inpGlossPow.onEndEdit.AsObservable().Subscribe(delegate (string value)
            {
                sldGlossPow.value = CustomBase.ConvertRateFromText(0, 100, value);
            });
            btnGlossPow.onClick.AsObservable().Subscribe(delegate
            {
                float cheekGlossPower = Singleton<CustomBase>.Instance.defChaInfo.custom.face.cheekGlossPower;
                face.cheekGlossPower = cheekGlossPower;
                chaCtrl.ChangeSettingCheekGlossPower();
                inpGlossPow.text = CustomBase.ConvertTextFromRate(0, 100, cheekGlossPower);
                sldGlossPow.value = cheekGlossPower;
            });
            StartCoroutine(SetInputText());
        }
    }
}
