using System.Collections;
using System.Linq;
using TMPro;
using UniRx;
using UniRx.Triggers;
using UnityEngine;
using UnityEngine.EventSystems;
using UnityEngine.UI;

namespace ChaCustom
{
    public class CvsChin : MonoBehaviour
    {
        [SerializeField]
        private Slider sldChinLowY;

        [SerializeField]
        private TMP_InputField inpChinLowY;

        [SerializeField]
        private Button btnChinLowY;

        [SerializeField]
        private Slider sldChinLowZ;

        [SerializeField]
        private TMP_InputField inpChinLowZ;

        [SerializeField]
        private Button btnChinLowZ;

        [SerializeField]
        private Slider sldChinY;

        [SerializeField]
        private TMP_InputField inpChinY;

        [SerializeField]
        private Button btnChinY;

        [SerializeField]
        private Slider sldChinW;

        [SerializeField]
        private TMP_InputField inpChinW;

        [SerializeField]
        private Button btnChinW;

        [SerializeField]
        private Slider sldChinZ;

        [SerializeField]
        private TMP_InputField inpChinZ;

        [SerializeField]
        private Button btnChinZ;

        [SerializeField]
        private Slider sldChinTipY;

        [SerializeField]
        private TMP_InputField inpChinTipY;

        [SerializeField]
        private Button btnChinTipY;

        [SerializeField]
        private Slider sldChinTipZ;

        [SerializeField]
        private TMP_InputField inpChinTipZ;

        [SerializeField]
        private Button btnChinTipZ;

        [SerializeField]
        private Slider sldChinTipW;

        [SerializeField]
        private TMP_InputField inpChinTipW;

        [SerializeField]
        private Button btnChinTipW;

        private Slider[] sliders;

        private TMP_InputField[] inputs;

        private Button[] buttons;

        private readonly int[] arrIndex = new int[8]
        {
            6,
            7,
            8,
            9,
            10,
            11,
            12,
            13
        };

        private ChaControl chaCtrl
        {
            get
            {
                return Singleton<CustomBase>.Instance.chaCtrl;
            }
        }

        private ChaFileFace face
        {
            get
            {
                return chaCtrl.chaFile.custom.face;
            }
        }

        public void CalculateUI()
        {
            float[] shapeValueFace = face.shapeValueFace;
            for (int i = 0; i < sliders.Length; i++)
            {
                if (!(null == sliders[i]))
                {
                    sliders[i].value = shapeValueFace[arrIndex[i]];
                }
            }
        }

        public virtual void UpdateCustomUI()
        {
            CalculateUI();
        }

        public IEnumerator SetInputText()
        {
            yield return new WaitUntil(() => null != chaCtrl);
            float[] shape = face.shapeValueFace;
            for (int i = 0; i < inputs.Length; i++)
            {
                if (!(null == inputs[i]))
                {
                    inputs[i].text = CustomBase.ConvertTextFromRate(0, 100, shape[arrIndex[i]]);
                }
            }
        }

        protected virtual void Awake()
        {
            sliders = new Slider[8]
            {
                sldChinLowY,
                sldChinLowZ,
                sldChinY,
                sldChinW,
                sldChinZ,
                sldChinTipY,
                sldChinTipZ,
                sldChinTipW
            };
            inputs = new TMP_InputField[8]
            {
                inpChinLowY,
                inpChinLowZ,
                inpChinY,
                inpChinW,
                inpChinZ,
                inpChinTipY,
                inpChinTipZ,
                inpChinTipW
            };
            buttons = new Button[8]
            {
                btnChinLowY,
                btnChinLowZ,
                btnChinY,
                btnChinW,
                btnChinZ,
                btnChinTipY,
                btnChinTipZ,
                btnChinTipW
            };
        }

        protected virtual void Start()
        {
            TMP_InputField[] array = inputs;
            foreach (TMP_InputField item in array)
            {
                Singleton<CustomBase>.Instance.lstTmpInputField.Add(item);
            }
            Singleton<CustomBase>.Instance.actUpdateCvsChin += UpdateCustomUI;
            sliders.Select((p, index) => new
            {
                slider = p, index
            }).ToList().ForEach(p =>
            {
                CvsChin cvsChin3 = this;
                p.slider.onValueChanged.AsObservable().Subscribe(delegate (float value)
                {
                    cvsChin3.chaCtrl.SetShapeFaceValue(cvsChin3.arrIndex[p.index], p.slider.value);
                    cvsChin3.inputs[p.index].text = CustomBase.ConvertTextFromRate(0, 100, value);
                });
                p.slider.OnScrollAsObservable().Subscribe(delegate (PointerEventData scl)
                {
                    Slider slider = p.slider;
                    float value3 = p.slider.value;
                    Vector2 scrollDelta = scl.scrollDelta;
                    slider.value = Mathf.Clamp(value3 + scrollDelta.y * Singleton<CustomBase>.Instance.sliderWheelSensitive, 0f, 100f);
                    cvsChin3.inputs[p.index].text = CustomBase.ConvertTextFromRate(0, 100, p.slider.value);
                });
            });
            inputs.Select((p, index) => new
            {
                input = p, index
            }).ToList().ForEach(p =>
            {
                CvsChin cvsChin2 = this;
                p.input.onEndEdit.AsObservable().Subscribe(delegate (string value)
                {
                    cvsChin2.sliders[p.index].value = CustomBase.ConvertRateFromText(0, 100, value);
                });
            });
            buttons.Select((p, index) => new
            {
                button = p, index
            }).ToList().ForEach(p =>
            {
                CvsChin cvsChin = this;
                p.button.onClick.AsObservable().Subscribe(delegate
                {
                    float value2 = Singleton<CustomBase>.Instance.defChaInfo.custom.face.shapeValueFace[cvsChin.arrIndex[p.index]];
                    cvsChin.chaCtrl.SetShapeFaceValue(cvsChin.arrIndex[p.index], value2);
                    cvsChin.inputs[p.index].text = CustomBase.ConvertTextFromRate(0, 100, value2);
                    cvsChin.sliders[p.index].value = value2;
                });
            });
            StartCoroutine(SetInputText());
        }
    }
}
