using Illusion.Component.UI.ColorPicker;
using Illusion.Extensions;
using System;
using TMPro;
using UniRx;
using UnityEngine;
using UnityEngine.UI;

namespace ChaCustom
{
    public class CvsColor : Singleton<CvsColor>
    {
        public enum ConnectColorKind
        {
            None,
            Eyebrow,
            Eyeline,
            EyeW01,
            EyeW02,
            EyeHLUp,
            EyeHLDown,
            Pupil01,
            Pupil02,
            Lipline,
            Mole,
            BaseEyeShadow,
            BaseCheek,
            BaseLip,
            BaseFacePaint01,
            BaseFacePaint02,
            SkinMain,
            SkinSub,
            Nip,
            Nail,
            Underhair,
            Sunburn,
            BodyPaint01,
            BodyPaint02,
            HairF_Base,
            HairF_Start,
            HairF_End,
            HairF_Acs01,
            HairF_Acs02,
            HairF_Acs03,
            HairF_Outline,
            HairB_Base,
            HairB_Start,
            HairB_End,
            HairB_Acs01,
            HairB_Acs02,
            HairB_Acs03,
            HairB_Outline,
            HairS_Base,
            HairS_Start,
            HairS_End,
            HairS_Acs01,
            HairS_Acs02,
            HairS_Acs03,
            HairS_Outline,
            HairO_Base,
            HairO_Start,
            HairO_End,
            HairO_Acs01,
            HairO_Acs02,
            HairO_Acs03,
            HairO_Outline,
            CosTop01,
            CosTop02,
            CosTop03,
            CosTop04,
            CosTopPtn01,
            CosTopPtn02,
            CosTopPtn03,
            CosTopPtn04,
            CosBot01,
            CosBot02,
            CosBot03,
            CosBot04,
            CosBotPtn01,
            CosBotPtn02,
            CosBotPtn03,
            CosBotPtn04,
            CosBra01,
            CosBra02,
            CosBra03,
            CosBra04,
            CosBraPtn01,
            CosBraPtn02,
            CosBraPtn03,
            CosBraPtn04,
            CosShorts01,
            CosShorts02,
            CosShorts03,
            CosShorts04,
            CosShortsPtn01,
            CosShortsPtn02,
            CosShortsPtn03,
            CosShortsPtn04,
            CosGloves01,
            CosGloves02,
            CosGloves03,
            CosGloves04,
            CosGlovesPtn01,
            CosGlovesPtn02,
            CosGlovesPtn03,
            CosGlovesPtn04,
            CosPanst01,
            CosPanst02,
            CosPanst03,
            CosPanst04,
            CosPanstPtn01,
            CosPanstPtn02,
            CosPanstPtn03,
            CosPanstPtn04,
            CosSocks01,
            CosSocks02,
            CosSocks03,
            CosSocks04,
            CosSocksPtn01,
            CosSocksPtn02,
            CosSocksPtn03,
            CosSocksPtn04,
            CosInnerShoes01,
            CosInnerShoes02,
            CosInnerShoes03,
            CosInnerShoes04,
            CosInnerShoesPtn01,
            CosInnerShoesPtn02,
            CosInnerShoesPtn03,
            CosInnerShoesPtn04,
            CosOuterShoes01,
            CosOuterShoes02,
            CosOuterShoes03,
            CosOuterShoes04,
            CosOuterShoesPtn01,
            CosOuterShoesPtn02,
            CosOuterShoesPtn03,
            CosOuterShoesPtn04,
            AcsSlot01_01,
            AcsSlot01_02,
            AcsSlot01_03,
            AcsSlot01_04,
            AcsSlot02_01,
            AcsSlot02_02,
            AcsSlot02_03,
            AcsSlot02_04,
            AcsSlot03_01,
            AcsSlot03_02,
            AcsSlot03_03,
            AcsSlot03_04,
            AcsSlot04_01,
            AcsSlot04_02,
            AcsSlot04_03,
            AcsSlot04_04,
            AcsSlot05_01,
            AcsSlot05_02,
            AcsSlot05_03,
            AcsSlot05_04,
            AcsSlot06_01,
            AcsSlot06_02,
            AcsSlot06_03,
            AcsSlot06_04,
            AcsSlot07_01,
            AcsSlot07_02,
            AcsSlot07_03,
            AcsSlot07_04,
            AcsSlot08_01,
            AcsSlot08_02,
            AcsSlot08_03,
            AcsSlot08_04,
            AcsSlot09_01,
            AcsSlot09_02,
            AcsSlot09_03,
            AcsSlot09_04,
            AcsSlot10_01,
            AcsSlot10_02,
            AcsSlot10_03,
            AcsSlot10_04,
            AcsSlot11_01,
            AcsSlot11_02,
            AcsSlot11_03,
            AcsSlot11_04,
            AcsSlot12_01,
            AcsSlot12_02,
            AcsSlot12_03,
            AcsSlot12_04,
            AcsSlot13_01,
            AcsSlot13_02,
            AcsSlot13_03,
            AcsSlot13_04,
            AcsSlot14_01,
            AcsSlot14_02,
            AcsSlot14_03,
            AcsSlot14_04,
            AcsSlot15_01,
            AcsSlot15_02,
            AcsSlot15_03,
            AcsSlot15_04,
            AcsSlot16_01,
            AcsSlot16_02,
            AcsSlot16_03,
            AcsSlot16_04,
            AcsSlot17_01,
            AcsSlot17_02,
            AcsSlot17_03,
            AcsSlot17_04,
            AcsSlot18_01,
            AcsSlot18_02,
            AcsSlot18_03,
            AcsSlot18_04,
            AcsSlot19_01,
            AcsSlot19_02,
            AcsSlot19_03,
            AcsSlot19_04,
            AcsSlot20_01,
            AcsSlot20_02,
            AcsSlot20_03,
            AcsSlot20_04
        }

        [Tooltip("このキャンバスグループ")]
        [SerializeField]
        private CanvasGroup cgWindow;

        [SerializeField]
        [Tooltip("ウィンドウタイトル")]
        private TextMeshProUGUI textWinTitle;

        [SerializeField]
        [Tooltip("閉じるボタン")]
        private Button btnClose;

        [SerializeField]
        [Tooltip("サンプルカラーScript")]
        private UI_SampleColor sampleColor;

        [SerializeField]
        [Tooltip("PickerのRect")]
        private PickerRectA cmpPickerRect;

        [Tooltip("PickerのSlider")]
        [SerializeField]
        private PickerSliderInput cmpPickerSliderI;

        [Tooltip("PickerのPreset")]
        [SerializeField]
        private UI_ColorPresets cmpPickerPreset;

        [Tooltip("PickerのSlider")]
        [SerializeField]
        private Slider pickerSlider;

        [Tooltip("PickerのSliderA")]
        [SerializeField]
        private Slider pickerSliderA;

        [Tooltip("SliderのSlider01")]
        [SerializeField]
        private Slider sliderSlider01;

        [SerializeField]
        [Tooltip("SliderのSlider02")]
        private Slider sliderSlider02;

        [Tooltip("SliderのSlider03")]
        [SerializeField]
        private Slider sliderSlider03;

        [SerializeField]
        [Tooltip("SliderのSlider04")]
        private Slider sliderSlider04;

        [SerializeField]
        [Tooltip("SliderのInput01")]
        private TMP_InputField sliderInput01;

        [Tooltip("SliderのInput02")]
        [SerializeField]
        private TMP_InputField sliderInput02;

        [SerializeField]
        [Tooltip("SliderのInput03")]
        private TMP_InputField sliderInput03;

        [SerializeField]
        [Tooltip("SliderのInput04")]
        private TMP_InputField sliderInput04;

        private bool useAlpha;

        public ConnectColorKind connectColorKind
        {
            get;
            private set;
        }

        public bool isOpen
        {
            get
            {
                return cgWindow.alpha != 0f;
            }
        }

        public void Setup(string winTitle, ConnectColorKind kind, Color color, Action<Color> _actUpdateColor, bool _useAlpha)
        {
            connectColorKind = kind;
            if ((bool)textWinTitle)
            {
                textWinTitle.text = winTitle;
            }
            if (null != sampleColor)
            {
                sampleColor.SetColor(color);
                sampleColor.actUpdateColor = _actUpdateColor;
            }
            if ((bool)cgWindow)
            {
                cgWindow.Enable(true);
            }
            useAlpha = _useAlpha;
            cmpPickerRect.isAlpha.Value = _useAlpha;
            cmpPickerSliderI.useAlpha.Value = _useAlpha;
        }

        public void SetColor(Color color)
        {
            if (null != sampleColor)
            {
                sampleColor.SetColor(color);
            }
        }

        public void Close()
        {
            connectColorKind = ConnectColorKind.None;
            if ((bool)textWinTitle)
            {
                textWinTitle.text = string.Empty;
            }
            if (null != sampleColor)
            {
                sampleColor.actUpdateColor = null;
            }
            if ((bool)cgWindow)
            {
                cgWindow.Enable(false);
            }
        }

        public bool CheckConnectKind(ConnectColorKind kind)
        {
            return connectColorKind == kind;
        }

        protected override void Awake()
        {
            connectColorKind = ConnectColorKind.None;
        }

        private void Start()
        {
            Singleton<CustomBase>.Instance.lstTmpInputField.Add(sliderInput01);
            Singleton<CustomBase>.Instance.lstTmpInputField.Add(sliderInput02);
            Singleton<CustomBase>.Instance.lstTmpInputField.Add(sliderInput03);
            Singleton<CustomBase>.Instance.lstTmpInputField.Add(sliderInput04);
            if ((bool)btnClose)
            {
                btnClose.OnClickAsObservable().Subscribe(delegate
                {
                    Close();
                });
            }
        }

        private void Update()
        {
        }
    }
}
