using Illusion.Extensions;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using TMPro;
using UniRx;
using UniRx.Triggers;
using UnityEngine;
using UnityEngine.EventSystems;
using UnityEngine.UI;

namespace ChaCustom
{
    public class CvsDrawCtrl : MonoBehaviour
    {
        [SerializeField]
        private GameObject objLight;

        [SerializeField]
        private Camera backGroundCamera;

        [SerializeField]
        private GameObject cvsBackGroundImage;

        [SerializeField]
        private RawImage imgBackground;

        [SerializeField]
        private Toggle[] tglClothesState;

        private int capBackClothesStateNo;

        public Toggle[] tglShoesType;

        [SerializeField]
        private Toggle[] tglShowAccessory;

        [SerializeField]
        private TMP_Dropdown ddEyebrowPtn;

        [SerializeField]
        private Button[] btnEyebrowPtn;

        [SerializeField]
        private TMP_Dropdown ddEyesPtn;

        [SerializeField]
        private Button[] btnEyesPtn;

        [SerializeField]
        private Slider sldEyesOpen;

        [SerializeField]
        private Toggle tglBlink;

        [SerializeField]
        private TMP_Dropdown ddMouthPtn;

        [SerializeField]
        private Button[] btnMouthPtn;

        [SerializeField]
        private Slider sldMouthOpen;

        [SerializeField]
        private TMP_Dropdown ddEyesLook;

        [SerializeField]
        private Button[] btnEyesLookPtn;

        [SerializeField]
        private GameObject objEyesLookRate;

        [SerializeField]
        private Slider sldEyesLookRate;

        [SerializeField]
        private TMP_Dropdown ddNeckLook;

        [SerializeField]
        private Button[] btnNeckLookPtn;

        [SerializeField]
        private GameObject objNeckLookRate;

        [SerializeField]
        private Slider sldNeckLookRate;

        public TMP_Dropdown ddPose;

        [SerializeField]
        private Button[] btnPose;

        [SerializeField]
        private TMP_Dropdown[] ddHandPtn;

        [SerializeField]
        private Button[] btnHandPtn;

        [SerializeField]
        private Slider sldLightingX;

        [SerializeField]
        private Slider sldLightingY;

        [SerializeField]
        private Button btnLightingInit;

        [SerializeField]
        private Toggle[] tglBackType;

        [SerializeField]
        private Button btnBackImageWin;

        [SerializeField]
        private Button[] btnBackImage;

        [SerializeField]
        private TextMeshProUGUI textBackImage;

        [SerializeField]
        private BackColorCtrl backColorCtrl;

        [SerializeField]
        private Button btnBackColor;

        [SerializeField]
        private Image imgBackColor;

        public GameObject objFrameTop;

        [SerializeField]
        private Toggle tglFrontFrame;

        [SerializeField]
        private Button btnFrontFrameWin;

        [SerializeField]
        private Button[] btnFrontFrame;

        [SerializeField]
        private TextMeshProUGUI textFrontFrame;

        [SerializeField]
        private Toggle tglBackFrame;

        [SerializeField]
        private Button btnBackFrameWin;

        [SerializeField]
        private Button[] btnBackFrame;

        [SerializeField]
        private TextMeshProUGUI textBackFrame;

        private FolderAssist faBackground = new FolderAssist();

        private int backgroundNo;

        private CustomBase customBase
        {
            get
            {
                return Singleton<CustomBase>.Instance;
            }
        }

        private ChaControl chaCtrl
        {
            get
            {
                return customBase.chaCtrl;
            }
        }

        private IEnumerator Start()
        {
            yield return new WaitUntil(() => null != chaCtrl);
            string pathBG = UserData.Path + "bg";
            string[] key = new string[1]
            {
                "*.png"
            };
            faBackground.CreateFolderInfoEx(pathBG, key);
            if (faBackground.GetFileCount() != 0)
            {
                ChangeBackgroundNo(0);
            }
            if (tglClothesState.Any())
            {
                (from item in tglClothesState.Select((tgl, idx) => new
                {
                    tgl,
                    idx
                })
                 where item.tgl != null
                 select item).ToList().ForEach(item =>
             {
                 CvsDrawCtrl cvsDrawCtrl4 = (CvsDrawCtrl)(object)this;
                 (from isOn in item.tgl.OnValueChangedAsObservable()
                  where isOn
                  select isOn).Subscribe(delegate
                 {
                     cvsDrawCtrl4.customBase.ChangeClothesState(item.idx);
                 });
             });
            }
            if (tglShoesType.Any())
            {
                (from item in tglShoesType.Select((tgl, idx) => new
                {
                    tgl,
                    type = (byte)idx
                })
                 where item.tgl != null
                 select item).ToList().ForEach(item =>
             {
                 CvsDrawCtrl cvsDrawCtrl3 = (CvsDrawCtrl)(object)this;
                 (from isOn in item.tgl.OnValueChangedAsObservable()
                  where isOn
                  select isOn).Subscribe(delegate
                 {
                     if ((bool)cvsDrawCtrl3.chaCtrl)
                     {
                         cvsDrawCtrl3.chaCtrl.fileStatus.shoesType = item.type;
                     }
                 });
             });
            }
            if (tglShowAccessory.Any())
            {
                (from item in tglShowAccessory.Select((tgl, idx) => new
                {
                    tgl,
                    idx
                })
                 where item.tgl != null
                 select item).ToList().ForEach(item =>
             {
                 CvsDrawCtrl cvsDrawCtrl2 = (CvsDrawCtrl)(object)this;
                 item.tgl.OnValueChangedAsObservable().Subscribe(delegate (bool isOn)
                 {
                     if ((bool)cvsDrawCtrl2.chaCtrl)
                     {
                         if (item.idx == 0)
                         {
                             cvsDrawCtrl2.chaCtrl.SetAccessoryStateCategory(0, isOn);
                         }
                         else
                         {
                             cvsDrawCtrl2.chaCtrl.SetAccessoryStateCategory(1, isOn);
                         }
                     }
                 });
             });
            }
            List<ExcelData.Param> lstEyebrow = customBase.lstEyebrow;
            List<string> options = lstEyebrow.Select(x => x.list[1]).ToList();
            List<int> lstIndex6 = lstEyebrow.Select(x => int.Parse(x.list[0])).ToList();
            ddEyebrowPtn.ClearOptions();
            ddEyebrowPtn.AddOptions(options);
            ddEyebrowPtn.onValueChanged.AddListener(delegate (int idx)
            {
                chaCtrl.ChangeEyebrowPtn(lstIndex6[idx]);
            });
            btnEyebrowPtn[0].OnClickAsObservable().Subscribe(delegate
            {
                int value21 = ddEyebrowPtn.value;
                int count12 = lstIndex6.Count;
                value21 = (value21 + count12 - 1) % count12;
                ddEyebrowPtn.value = value21;
            });
            btnEyebrowPtn[1].OnClickAsObservable().Subscribe(delegate
            {
                int value20 = ddEyebrowPtn.value;
                int count11 = lstIndex6.Count;
                value20 = (value20 + 1) % count11;
                ddEyebrowPtn.value = value20;
            });
            List<ExcelData.Param> lstEye = customBase.lstEye;
            List<string> options2 = lstEye.Select(x => x.list[1]).ToList();
            List<int> lstIndex5 = lstEye.Select(x => int.Parse(x.list[0])).ToList();
            ddEyesPtn.ClearOptions();
            ddEyesPtn.AddOptions(options2);
            ddEyesPtn.onValueChanged.AddListener(delegate (int idx)
            {
                chaCtrl.ChangeEyesPtn(lstIndex5[idx]);
            });
            btnEyesPtn[0].OnClickAsObservable().Subscribe(delegate
            {
                int value19 = ddEyesPtn.value;
                int count10 = lstIndex5.Count;
                value19 = (value19 + count10 - 1) % count10;
                ddEyesPtn.value = value19;
            });
            btnEyesPtn[1].OnClickAsObservable().Subscribe(delegate
            {
                int value18 = ddEyesPtn.value;
                int count9 = lstIndex5.Count;
                value18 = (value18 + 1) % count9;
                ddEyesPtn.value = value18;
            });
            tglBlink.OnValueChangedAsObservable().Subscribe(delegate (bool isOn)
            {
                chaCtrl.ChangeEyesBlinkFlag(!isOn);
            });
            sldEyesOpen.OnValueChangedAsObservable().Subscribe(delegate (float v)
            {
                chaCtrl.ChangeEyesOpenMax(v);
            });
            sldEyesOpen.OnScrollAsObservable().Subscribe(delegate (PointerEventData scl)
            {
                Slider slider6 = sldEyesOpen;
                float value17 = sldEyesOpen.value;
                Vector2 scrollDelta6 = scl.scrollDelta;
                slider6.value = Mathf.Clamp(value17 + scrollDelta6.y * customBase.sliderWheelSensitive, 0f, 100f);
            });
            List<ExcelData.Param> lstMouth = customBase.lstMouth;
            List<string> options3 = lstMouth.Select(x => x.list[1]).ToList();
            List<int> lstIndex4 = lstMouth.Select(x => int.Parse(x.list[0])).ToList();
            ddMouthPtn.ClearOptions();
            ddMouthPtn.AddOptions(options3);
            ddMouthPtn.onValueChanged.AddListener(delegate (int idx)
            {
                chaCtrl.ChangeMouthPtn(lstIndex4[idx]);
            });
            btnMouthPtn[0].OnClickAsObservable().Subscribe(delegate
            {
                int value16 = ddMouthPtn.value;
                int count8 = lstIndex4.Count;
                value16 = (value16 + count8 - 1) % count8;
                ddMouthPtn.value = value16;
            });
            btnMouthPtn[1].OnClickAsObservable().Subscribe(delegate
            {
                int value15 = ddMouthPtn.value;
                int count7 = lstIndex4.Count;
                value15 = (value15 + 1) % count7;
                ddMouthPtn.value = value15;
            });
            sldMouthOpen.OnValueChangedAsObservable().Subscribe(delegate (float v)
            {
                chaCtrl.fileStatus.mouthFixed = true;
                chaCtrl.ChangeMouthOpenMax(v);
            });
            sldMouthOpen.OnScrollAsObservable().Subscribe(delegate (PointerEventData scl)
            {
                Slider slider5 = sldMouthOpen;
                float value14 = sldMouthOpen.value;
                Vector2 scrollDelta5 = scl.scrollDelta;
                slider5.value = Mathf.Clamp(value14 + scrollDelta5.y * customBase.sliderWheelSensitive, 0f, 100f);
            });
            List<ExcelData.Param> lstEyesLook = customBase.lstEyesLook;
            List<string> options4 = lstEyesLook.Select(x => x.list[1]).ToList();
            List<int> lstIndex3 = lstEyesLook.Select(x => int.Parse(x.list[0])).ToList();
            ddEyesLook.ClearOptions();
            ddEyesLook.AddOptions(options4);
            int ptn = int.Parse(lstEyesLook[0].list[2]);
            int targetType = int.Parse(lstEyesLook[0].list[3]);
            bool active = 1 == int.Parse(lstEyesLook[0].list[4]);
            chaCtrl.ChangeLookEyesPtn(ptn);
            chaCtrl.ChangeLookEyesTarget(targetType, null, sldEyesLookRate.value);
            objEyesLookRate.SetActiveIfDifferent(active);
            ddEyesLook.onValueChanged.AddListener(delegate (int idx)
            {
                int ptn4 = int.Parse(lstEyesLook[idx].list[2]);
                int targetType4 = int.Parse(lstEyesLook[idx].list[3]);
                bool active4 = 1 == int.Parse(lstEyesLook[idx].list[4]);
                chaCtrl.ChangeLookEyesPtn(ptn4);
                chaCtrl.ChangeLookEyesTarget(targetType4, null, sldEyesLookRate.value);
                objEyesLookRate.SetActiveIfDifferent(active4);
            });
            btnEyesLookPtn[0].OnClickAsObservable().Subscribe(delegate
            {
                int value13 = ddEyesLook.value;
                int count6 = lstIndex3.Count;
                value13 = (value13 + count6 - 1) % count6;
                ddEyesLook.value = value13;
            });
            btnEyesLookPtn[1].OnClickAsObservable().Subscribe(delegate
            {
                int value12 = ddEyesLook.value;
                int count5 = lstIndex3.Count;
                value12 = (value12 + 1) % count5;
                ddEyesLook.value = value12;
            });
            sldEyesLookRate.OnValueChangedAsObservable().Subscribe(delegate
            {
                chaCtrl.ChangeLookEyesTarget(-1, null, sldEyesLookRate.value);
            });
            sldEyesLookRate.OnScrollAsObservable().Subscribe(delegate (PointerEventData scl)
            {
                Slider slider4 = sldEyesLookRate;
                float value11 = sldEyesLookRate.value;
                Vector2 scrollDelta4 = scl.scrollDelta;
                slider4.value = Mathf.Clamp(value11 + scrollDelta4.y * customBase.sliderWheelSensitive, 0f, 100f);
            });
            List<ExcelData.Param> lstNeckLook = customBase.lstNeckLook;
            List<string> options5 = lstNeckLook.Select(x => x.list[1]).ToList();
            List<int> lstIndex2 = lstNeckLook.Select(x => int.Parse(x.list[0])).ToList();
            ddNeckLook.ClearOptions();
            ddNeckLook.AddOptions(options5);
            int ptn2 = int.Parse(lstNeckLook[0].list[2]);
            int targetType2 = int.Parse(lstNeckLook[0].list[3]);
            bool active2 = 1 == int.Parse(lstNeckLook[0].list[4]);
            chaCtrl.ChangeLookNeckPtn(ptn2);
            chaCtrl.ChangeLookNeckTarget(targetType2, null, sldNeckLookRate.value);
            objNeckLookRate.SetActiveIfDifferent(active2);
            ddNeckLook.onValueChanged.AddListener(delegate (int idx)
            {
                int ptn3 = int.Parse(lstNeckLook[idx].list[2]);
                int targetType3 = int.Parse(lstNeckLook[idx].list[3]);
                bool active3 = 1 == int.Parse(lstNeckLook[idx].list[4]);
                chaCtrl.ChangeLookNeckPtn(ptn3);
                chaCtrl.ChangeLookNeckTarget(targetType3, null, sldNeckLookRate.value);
                objNeckLookRate.SetActiveIfDifferent(active3);
            });
            btnNeckLookPtn[0].OnClickAsObservable().Subscribe(delegate
            {
                int value10 = ddNeckLook.value;
                int count4 = lstIndex2.Count;
                value10 = (value10 + count4 - 1) % count4;
                ddNeckLook.value = value10;
            });
            btnNeckLookPtn[1].OnClickAsObservable().Subscribe(delegate
            {
                int value9 = ddNeckLook.value;
                int count3 = lstIndex2.Count;
                value9 = (value9 + 1) % count3;
                ddNeckLook.value = value9;
            });
            sldNeckLookRate.OnValueChangedAsObservable().Subscribe(delegate
            {
                chaCtrl.ChangeLookNeckTarget(-1, null, sldNeckLookRate.value);
            });
            sldNeckLookRate.OnScrollAsObservable().Subscribe(delegate (PointerEventData scl)
            {
                Slider slider3 = sldNeckLookRate;
                float value8 = sldNeckLookRate.value;
                Vector2 scrollDelta3 = scl.scrollDelta;
                slider3.value = Mathf.Clamp(value8 + scrollDelta3.y * customBase.sliderWheelSensitive, 0f, 100f);
            });
            List<string> options6 = customBase.lstPose.Select(x => x.list[3]).ToList();
            List<int> lstIndex = customBase.lstPose.Select(x => int.Parse(x.list[0])).ToList();
            ddPose.ClearOptions();
            ddPose.AddOptions(options6);
            ddPose.onValueChanged.AddListener(delegate (int idx)
            {
                if (customBase.animeAssetBundleName != customBase.lstPose[idx].list[1] || customBase.animeAssetName != customBase.lstPose[idx].list[2])
                {
                    customBase.animeAssetBundleName = customBase.lstPose[idx].list[1];
                    customBase.animeAssetName = customBase.lstPose[idx].list[2];
                    customBase.LoadAnimation(customBase.animeAssetBundleName, customBase.animeAssetName);
                }
                customBase.PlayAnimation(customBase.lstPose[idx].list[4], -1f);
            });
            btnPose[0].OnClickAsObservable().Subscribe(delegate
            {
                int value7 = ddPose.value;
                int count2 = lstIndex.Count;
                value7 = (value7 + count2 - 1) % count2;
                ddPose.value = value7;
            });
            btnPose[1].OnClickAsObservable().Subscribe(delegate
            {
                int value6 = ddPose.value;
                int count = lstIndex.Count;
                value6 = (value6 + 1) % count;
                ddPose.value = value6;
            });
            int fig = chaCtrl.GetShapeIndexCount() + 1;
            List<string> lst = new List<string>();
            lst.Add("アニメ");
            for (int i = 1; i < fig; i++)
            {
                lst.Add(string.Format("パターン{0:00}", i));
            }
            if (ddHandPtn.Any())
            {
                (from item in ddHandPtn.Select((dd, idx) => new
                {
                    dd,
                    idx
                })
                 where item.dd != null
                 select item).ToList().ForEach(item =>
             {
                 item.dd.ClearOptions();
                 item.dd.AddOptions(lst);
                 item.dd.onValueChanged.AddListener(delegate (int no)
                 {
                     if (no == 0)
                     {
                         chaCtrl.SetEnableShapeHand(item.idx, false);
                     }
                     else
                     {
                         chaCtrl.SetEnableShapeHand(item.idx, true);
                         chaCtrl.SetShapeHandIndex(item.idx, no - 1);
                     }
                 });
                 btnHandPtn[item.idx * 2].OnClickAsObservable().Subscribe(delegate
                 {
                     int value5 = ddHandPtn[item.idx].value;
                     value5 = (value5 + fig - 1) % fig;
                     ddHandPtn[item.idx].value = value5;
                 });
                 btnHandPtn[item.idx * 2 + 1].OnClickAsObservable().Subscribe(delegate
                 {
                     int value4 = ddHandPtn[item.idx].value;
                     value4 = (value4 + 1) % fig;
                     ddHandPtn[item.idx].value = value4;
                 });
             });
            }
            sldLightingX.OnValueChangedAsObservable().Subscribe(delegate (float value)
            {
                if ((bool)objLight)
                {
                    Transform transform2 = objLight.transform;
                    float x2 = Mathf.Lerp(-89f, 89f, value);
                    Vector3 localEulerAngles2 = objLight.transform.localEulerAngles;
                    transform2.localEulerAngles = new Vector3(x2, localEulerAngles2.y, 0f);
                }
            });
            sldLightingX.OnScrollAsObservable().Subscribe(delegate (PointerEventData scl)
            {
                Slider slider2 = sldLightingX;
                float value3 = sldLightingX.value;
                Vector2 scrollDelta2 = scl.scrollDelta;
                slider2.value = Mathf.Clamp(value3 + scrollDelta2.y * customBase.sliderWheelSensitive, 0f, 100f);
            });
            sldLightingY.OnValueChangedAsObservable().Subscribe(delegate (float value)
            {
                if ((bool)objLight)
                {
                    Transform transform = objLight.transform;
                    Vector3 localEulerAngles = objLight.transform.localEulerAngles;
                    transform.localEulerAngles = new Vector3(localEulerAngles.x, Mathf.Lerp(-180f, 180f, value), 0f);
                }
            });
            sldLightingY.OnScrollAsObservable().Subscribe(delegate (PointerEventData scl)
            {
                Slider slider = sldLightingY;
                float value2 = sldLightingY.value;
                Vector2 scrollDelta = scl.scrollDelta;
                slider.value = Mathf.Clamp(value2 + scrollDelta.y * customBase.sliderWheelSensitive, 0f, 100f);
            });
            btnLightingInit.OnClickAsObservable().Subscribe(delegate
            {
                sldLightingX.value = 0.5f;
                sldLightingY.value = 0.5f;
                if ((bool)objLight)
                {
                    objLight.transform.localEulerAngles = new Vector3(0f, 0f, 0f);
                }
            });
            (from item in tglBackType.Select((tgl, idx) => new
            {
                tgl,
                idx
            })
             where item.tgl != null
             select item).ToList().ForEach(item =>
         {
             CvsDrawCtrl cvsDrawCtrl = (CvsDrawCtrl)(object)this;
             (from isOn in item.tgl.OnValueChangedAsObservable()
              where isOn
              select isOn).Subscribe(delegate
             {
                 bool flag = 0 == item.idx;
                 cvsDrawCtrl.btnBackImageWin.transform.parent.gameObject.SetActiveIfDifferent(flag);
                 cvsDrawCtrl.btnBackColor.transform.parent.gameObject.SetActiveIfDifferent(!flag);
                 cvsDrawCtrl.cvsBackGroundImage.SetActiveIfDifferent(flag);
                 if (flag && cvsDrawCtrl.backColorCtrl.isOpen)
                 {
                     cvsDrawCtrl.backColorCtrl.Close();
                 }
             });
         });
            if ((bool)backGroundCamera)
            {
                backGroundCamera.backgroundColor = customBase.customSettingSave.backColor;
            }
            imgBackColor.color = customBase.customSettingSave.backColor;
            btnBackColor.OnClickAsObservable().Subscribe(delegate
            {
                if (backColorCtrl.isOpen)
                {
                    backColorCtrl.Close();
                }
                else
                {
                    backColorCtrl.Setup(customBase.customSettingSave.backColor, UpdateBackColor);
                }
            });
            btnBackImage[0].OnClickAsObservable().Subscribe(delegate
            {
                ChangeBackgroundImagePrev();
            });
            btnBackImage[1].OnClickAsObservable().Subscribe(delegate
            {
                ChangeBackgroundImageNext();
            });
            textBackFrame.text = customBase.saveFrameAssist.GetNowPositionStringBack();
            tglBackFrame.OnValueChangedAsObservable().Subscribe(delegate (bool isOn)
            {
                customBase.drawSaveFrameBack = isOn;
            });
            btnBackFrame[0].OnClickAsObservable().Subscribe(delegate
            {
                customBase.saveFrameAssist.ChangeSaveFrameBack(1);
                textBackFrame.text = customBase.saveFrameAssist.GetNowPositionStringBack();
            });
            btnBackFrame[1].OnClickAsObservable().Subscribe(delegate
            {
                customBase.saveFrameAssist.ChangeSaveFrameBack(0);
                textBackFrame.text = customBase.saveFrameAssist.GetNowPositionStringBack();
            });
            textFrontFrame.text = customBase.saveFrameAssist.GetNowPositionStringFront();
            tglFrontFrame.OnValueChangedAsObservable().Subscribe(delegate (bool isOn)
            {
                customBase.drawSaveFrameFront = isOn;
            });
            btnFrontFrame[0].OnClickAsObservable().Subscribe(delegate
            {
                customBase.saveFrameAssist.ChangeSaveFrameFront(1);
                textFrontFrame.text = customBase.saveFrameAssist.GetNowPositionStringFront();
            });
            btnFrontFrame[1].OnClickAsObservable().Subscribe(delegate
            {
                customBase.saveFrameAssist.ChangeSaveFrameFront(0);
                textFrontFrame.text = customBase.saveFrameAssist.GetNowPositionStringFront();
            });
            yield return null;
        }

        public void UpdateAccessoryDraw()
        {
            if (!(null == chaCtrl))
            {
                for (int i = 0; i < tglShowAccessory.Length; i++)
                {
                    chaCtrl.SetAccessoryStateCategory(0, tglShowAccessory[0].isOn);
                    chaCtrl.SetAccessoryStateCategory(1, tglShowAccessory[1].isOn);
                }
            }
        }

        public void ChangeClothesStateForCapture(bool capture)
        {
            if (capture)
            {
                capBackClothesStateNo = customBase.clothesStateNo;
                tglClothesState[1].isOn = false;
                tglClothesState[2].isOn = false;
                tglClothesState[0].isOn = true;
                return;
            }
            for (int i = 0; i < tglClothesState.Length; i++)
            {
                if (i != capBackClothesStateNo)
                {
                    tglClothesState[i].isOn = false;
                }
            }
            tglClothesState[capBackClothesStateNo].isOn = true;
        }

        public void ChangePoseDefault()
        {
            ddPose.value = 0;
        }

        public void ChangeEyesPtnDefault()
        {
            ddEyesPtn.value = 0;
        }

        public void ChangeAnimationForce(int idx, float posTime)
        {
            if (customBase.animeAssetBundleName != customBase.lstPose[idx].list[1] || customBase.animeAssetName != customBase.lstPose[idx].list[2])
            {
                customBase.animeAssetBundleName = customBase.lstPose[idx].list[1];
                customBase.animeAssetName = customBase.lstPose[idx].list[2];
                customBase.LoadAnimation(customBase.animeAssetBundleName, customBase.animeAssetName);
            }
            customBase.PlayAnimation(customBase.lstPose[idx].list[4], posTime);
        }

        public void UpdateBackColor(Color color)
        {
            customBase.customSettingSave.backColor = color;
            imgBackColor.color = color;
            if ((bool)backGroundCamera)
            {
                backGroundCamera.backgroundColor = color;
            }
        }

        public void SetShoesType(int type)
        {
            if (tglShoesType != null && tglShoesType.Length == 2)
            {
                tglShoesType[0].isOn = 0 == type;
                tglShoesType[1].isOn = 1 == type;
            }
        }

        public byte GetShoesType()
        {
            if (tglShoesType.Any())
            {
                var anon = (from item in tglShoesType.Select((tgl, idx) => new
                {
                    tgl,
                    type = (byte)idx
                })
                            where null != item.tgl && item.tgl.isOn
                            select item).FirstOrDefault();
                if (anon != null)
                {
                    return anon.type;
                }
            }
            return 0;
        }

        public bool GetShowAccessory(int index)
        {
            if (tglShowAccessory == null || tglShowAccessory.Length != 2)
            {
                return true;
            }
            return tglShowAccessory[index].isOn;
        }

        public void ChangeBackgroundImagePrev()
        {
            int fileCount = faBackground.GetFileCount();
            backgroundNo = (backgroundNo + fileCount - 1) % fileCount;
            ChangeBackgroundNo(backgroundNo);
        }

        public void ChangeBackgroundImageNext()
        {
            int fileCount = faBackground.GetFileCount();
            backgroundNo = (backgroundNo + 1) % fileCount;
            ChangeBackgroundNo(backgroundNo);
        }

        public void ChangeBackgroundNo(int index)
        {
            int fileCount = faBackground.GetFileCount();
            if (fileCount == 0)
            {
                textBackImage.text = "ファイルがありません";
                return;
            }
            textBackImage.text = string.Format("{0:000} / {1:000}", index + 1, fileCount);
            Texture2D texture = PngAssist.LoadTexture(faBackground.lstFile[index].FullPath);
            if ((bool)imgBackground)
            {
                if ((bool)imgBackground.texture)
                {
                    Destroy(imgBackground.texture);
                }
                imgBackground.texture = texture;
            }
        }
    }
}
