using Illusion.CustomAttributes;
using System.Linq;
using UnityEngine;

public class ChaCustomHairComponent : MonoBehaviour
{
    public Renderer[] rendHair;

    public Renderer[] rendAccessory;

    public Transform[] trfLength;

    public float[] baseLength;

    public float addLength;

    [Range(0f, 1f)]
    public float lengthRate;

    public Color[] acsDefColor;

    [Space]
    [Button("Initialize", "設定の初期化", new object[]
    {

    })]
    public int initialize;

    [Button("SetColor", "アクセサリの初期色を設定", new object[]
    {

    })]
    public int setcolor;

    public void Initialize()
    {
        FindAssist findAssist = new FindAssist();
        findAssist.Initialize(transform);
        rendHair = (from s in findAssist.dictObjName
                    where s.Key.StartsWith("cf_hair")
                    select s into x
                    select GetRenderer(x.Value) into r
                    where null != r
                    select r).ToArray();
        rendAccessory = (from s in findAssist.dictObjName
                         where s.Key.StartsWith("cf_acs")
                         select s into x
                         select GetRenderer(x.Value) into r
                         where null != r
                         select r).ToArray();
        SetColor();
        trfLength = (from s in findAssist.dictObjName
                     where s.Key.EndsWith("_s")
                     select s into x
                     where x.Value.transform != null
                     select x.Value.transform).ToArray();
        baseLength = new float[trfLength.Length];
        for (int i = 0; i < trfLength.Length; i++)
        {
            float[] array = baseLength;
            int num = i;
            Vector3 localPosition = trfLength[i].localPosition;
            array[num] = localPosition.y;
        }
    }

    public void SetColor()
    {
        if (rendAccessory.Length == 0)
        {
            return;
        }
        Material sharedMaterial = rendAccessory[0].sharedMaterial;
        if (null != sharedMaterial)
        {
            acsDefColor = new Color[3];
            if (sharedMaterial.HasProperty("_Color"))
            {
                acsDefColor[0] = sharedMaterial.GetColor("_Color");
            }
            if (sharedMaterial.HasProperty("_Color2"))
            {
                acsDefColor[1] = sharedMaterial.GetColor("_Color2");
            }
            if (sharedMaterial.HasProperty("_Color3"))
            {
                acsDefColor[2] = sharedMaterial.GetColor("_Color3");
            }
        }
    }

    public Renderer GetRenderer(GameObject obj)
    {
        Renderer result = null;
        if (null == obj)
        {
            return result;
        }
        return obj.GetComponent<Renderer>();
    }

    private void Reset()
    {
        Initialize();
    }

    private void Update()
    {
        if (trfLength != null)
        {
            int num = trfLength.Length;
            for (int i = 0; i < num; i++)
            {
                float y = baseLength[i] + Mathf.Lerp(0f, addLength, lengthRate);
                Transform obj = trfLength[i];
#if FIX
                //Null check
                if (obj == null) continue;
#endif
                Vector3 localPosition = trfLength[i].localPosition;
                float x = localPosition.x;
                Vector3 localPosition2 = trfLength[i].localPosition;
                obj.localPosition = new Vector3(x, y, localPosition2.z);
            }
        }
    }
}
