using System;

public static class ChaListDefine
{
    public enum CategoryNo
    {
        cha_sample_f = 0,
        cha_sample_m = 1,
        cha_eyeset = 2,
        bodypaint_layout = 3,
        cha_default_cos_f = 4,
        cha_default_cos_m = 5,
        cha_sample_voice = 6,
        facepaint_layout = 7,
        mole_layout = 8,
        cha_sample_m_ex = 9,
        bo_head = 100,
        bo_hair_b = 101,
        bo_hair_f = 102,
        bo_hair_s = 103,
        bo_hair_o = 104,
        co_top = 105,
        co_bot = 106,
        co_bra = 107,
        co_shorts = 108,
        co_gloves = 109,
        co_panst = 110,
        co_socks = 111,
        co_shoes = 112,
        ao_none = 120,
        ao_hair = 121,
        ao_head = 122,
        ao_face = 123,
        ao_neck = 124,
        ao_body = 125,
        ao_waist = 126,
        ao_leg = 0x7F,
        ao_arm = 0x80,
        ao_hand = 129,
        ao_kokan = 130,
        cpo_sailor_a = 200,
        cpo_sailor_b = 201,
        cpo_sailor_c = 202,
        cpo_jacket_a = 210,
        cpo_jacket_b = 211,
        cpo_jacket_c = 212,
        mt_face_detail = 400,
        mt_eyeshadow = 401,
        mt_cheek = 402,
        mt_lip = 403,
        mt_lipline = 404,
        mt_face_paint = 405,
        mt_eyebrow = 406,
        mt_eye_white = 407,
        mt_eye = 408,
        mt_eye_gradation = 409,
        mt_eye_hi_up = 410,
        mt_eye_hi_down = 411,
        mt_eyeline_up = 412,
        mt_eyeline_down = 413,
        mt_nose = 414,
        mt_mole = 415,
        face_preset = 416,
        mt_body_detail = 420,
        mt_body_paint = 421,
        mt_sunburn = 422,
        mt_nip = 423,
        mt_underhair = 424,
        mt_pattern = 430,
        mt_emblem = 431,
        mt_ramp = 432,
        mt_hairgloss = 433,
        ex_bo_body = 500,
        ex_bo_head = 501,
        ex_bo_hair = 502,
        ex_co_clothes = 503,
        ex_co_shoes = 504
    }

    public enum KeyType
    {
        Category,
        DistributionNo,
        AngleSpeed,
        CheekTex,
        ColorMask02AB,
        ColorMask02Tex,
        ColorMaskAB,
        ColorMaskTex,
        Coordinate,
        EpsTex,
        EpsTexAB,
        EyeBase,
        EyebrowTex,
        EyeHiDownTex,
        EyeHitomi,
        EyeHiUpTex,
        EyelineDownTex,
        EyelineShadowTex,
        EyelineUpTex,
        EyeObjNo,
        EyeshadowTex,
        EyesPtn,
        EyeTex,
        EyeWhiteTex,
        HideHair,
        ID,
        Kind,
        LineMask,
        LiplineTex,
        LipTex,
        MainAB,
        MainData,
        MainManifest,
        MainTex,
        MainTex02,
        MainTex02AB,
        MainTexAB,
        MatAB,
        MatData,
        MatManifest,
        MoleTex,
        Name,
        NipTex,
        NormalData,
        NormallMapDetail,
        NoseTex,
        NotBra,
        OverBodyMask,
        OverBodyMaskAB,
        OverBraMask,
        OverBraMaskAB,
        OverInnerMask,
        OverInnerMaskAB,
        PaintTex,
        Parent,
        Possess,
        SetHair,
        Sex,
        ShapeAnime,
        SizeSpeed,
        SizeWidth,
        StateType,
        SunburnTex,
        TileAnim,
        UnderhairTex,
        Yurayura,
        KokanHide,
        ThumbAB,
        ThumbTex,
        PosX,
        PosY,
        Rot,
        Scale,
        CenterX,
        MoveX,
        CenterY,
        MoveY,
        CenterScale,
        AddScale,
        DefCoorde01,
        DefCoorde02,
        DefCoorde03,
        DefCoorde04,
        DefCoorde05,
        DefCoorde06,
        DefCoorde07,
        Data01,
        Data02,
        Data03,
        Eyebrow01,
        Eyebrow02,
        Eyebrow03,
        Eye01,
        Eye02,
        Eye03,
        Mouth01,
        Mouth02,
        Mouth03,
        EyeHiLight01,
        EyeHiLight02,
        EyeHiLight03,
        ColorMask03AB,
        ColorMask03Tex,
        MainTex03AB,
        MainTex03,
        MabUV,
        HideShorts
    }

    public static readonly Version CheckItemVersion = new Version("0.0.0");

    public static string GetCategoryName(int no)
    {
        switch (no)
        {
            case 0:
                return "キャラサンプル女";
            case 1:
                return "キャラサンプル男";
            case 2:
                return "目のパターン設定";
            case 3:
                return "ボディーペイントの配置設定";
            case 4:
                return "女キャラ服装デフォルト";
            case 5:
                return "男キャラ服装デフォルト";
            case 6:
                return "サンプル音声";
            case 7:
                return "フェイスペイントの配置設定";
            case 8:
                return "ホクロの配置設定";
            case 9:
                return "キャラサンプル男(特殊)";
            case 100:
                return "頭";
            case 101:
                return "後ろ髪";
            case 102:
                return "前髪";
            case 103:
                return "横髪";
            case 104:
                return "付け毛";
            case 105:
                return "服上";
            case 106:
                return "服下";
            case 107:
                return "ブラ・水着(上)";
            case 108:
                return "ショーツ・水着(下)";
            case 109:
                return "手袋";
            case 110:
                return "パンスト";
            case 111:
                return "靴下";
            case 112:
                return "靴";
            case 120:
                return "アクセサリ(なし)";
            case 121:
                return "アクセサリ髪";
            case 122:
                return "アクセサリ頭";
            case 123:
                return "アクセサリ顔";
            case 124:
                return "アクセサリ首";
            case 125:
                return "アクセサリ胴";
            case 126:
                return "アクセサリ腰";
            case 127:
                return "アクセサリ脚";
            case 128:
                return "アクセサリ腕";
            case 129:
                return "アクセサリ手";
            case 130:
                return "アクセサリ股間周り";
            case 200:
                return "セーラーパーツ（胴）";
            case 201:
                return "セーラーパーツ（襟）";
            case 202:
                return "セーラーパーツ（装飾）";
            case 210:
                return "ジャケットパーツ（インナー）";
            case 211:
                return "ジャケットパーツ（アウター）";
            case 212:
                return "ジャケットパーツ（装飾）";
            case 400:
                return "顔のシワ";
            case 401:
                return "アイシャドウテクスチャ";
            case 402:
                return "チークテクスチャ";
            case 403:
                return "唇テクスチャ";
            case 404:
                return "唇ラインテクスチャ";
            case 405:
                return "顔ペイントテクスチャ";
            case 406:
                return "眉毛テクスチャ";
            case 407:
                return "瞳白目作成テクスチャ";
            case 408:
                return "瞳テクスチャ";
            case 409:
                return "瞳グラデーションマスクテクスチャ";
            case 410:
                return "瞳ハイライト上テクスチャ";
            case 411:
                return "瞳ハイライト下テクスチャ";
            case 412:
                return "アイライン上テクスチャ";
            case 413:
                return "アイライン下テクスチャ";
            case 414:
                return "鼻テクスチャ";
            case 415:
                return "ホクロテクスチャ";
            case 416:
                return "顔のプリセット情報";
            case 420:
                return "体の肉感";
            case 421:
                return "体ペイントテクスチャ";
            case 422:
                return "日焼けテクスチャ";
            case 423:
                return "乳首テクスチャ";
            case 424:
                return "ヘアテクスチャ";
            case 430:
                return "パターンテクスチャ";
            case 431:
                return "エンブレムテクスチャ";
            case 432:
                return "ランプテクスチャ";
            case 433:
                return "髪の毛ツヤテクスチャ";
            case 500:
                return "男特殊体";
            case 501:
                return "男特殊頭";
            case 502:
                return "男特殊髪";
            case 503:
                return "男特殊服";
            case 504:
                return "男特殊靴";
            default:
                return string.Empty;
        }
    }
}
