using Illusion.CustomAttributes;
using Manager;
using System;
using System.Linq;
using TMPro;
using UnityEngine;
using UnityEngine.UI;

[ExecuteInEditMode]
public class CharaHInfoComponent : MonoBehaviour
{
    private const float drawH = 272f;

    private readonly string[] strWeakPoint = new string[7]
    {
        "なし",
        "唇",
        "胸",
        "股間",
        "アナル",
        "尻",
        "乳首"
    };

    [SerializeField]
    private RectTransform rtfResize;

    [SerializeField]
    private float drawHeight = 272f;

    [SerializeField]
    private bool updateSize = true;

    [SerializeField]
    private Image baseImage;

    [SerializeField]
    private RawImage riChara;

    [SerializeField]
    private Text textName;

    [SerializeField]
    private TextMeshProUGUI textPersonality;

    [SerializeField]
    private TextMeshProUGUI textWeakPoint;

    [SerializeField]
    private TextMeshProUGUI[] textDenial = new TextMeshProUGUI[5];

    [Button("Initialize", "設定の初期化(男)", new object[]
    {
        0
    })]
    [Space]
    public int initializeM;

    [Button("Initialize", "設定の初期化(女)", new object[]
    {
        1
    })]
    public int initializeF;

    public Image BaseImage
    {
        get
        {
            return baseImage;
        }
    }

    public void SetDrawSize(float height = 272f)
    {
        drawHeight = height;
        updateSize = true;
    }

    public void Clear()
    {
        if ((bool)riChara)
        {
            if ((bool)riChara.texture)
            {
                Destroy(riChara.texture);
            }
            riChara.texture = null;
            riChara.enabled = false;
        }
        if ((bool)textName)
        {
            textName.text = string.Empty;
        }
        if ((bool)textPersonality)
        {
            textPersonality.text = string.Empty;
        }
        if ((bool)textWeakPoint)
        {
            textWeakPoint.text = string.Empty;
        }
        if (textDenial == null)
        {
            return;
        }
        for (int i = 0; i < textDenial.Length; i++)
        {
            if (null != textDenial[i])
            {
                textDenial[i].text = string.Empty;
            }
        }
    }

    public void SetCharaInfo(ChaFileControl chaFileCtrl)
    {
        if (chaFileCtrl == null)
        {
            return;
        }
        if ((bool)riChara)
        {
            if (!riChara.enabled)
            {
                riChara.enabled = true;
            }
            if ((bool)riChara.texture)
            {
                Destroy(riChara.texture);
            }
            riChara.texture = null;
            riChara.enabled = false;
            if (chaFileCtrl.pngData != null)
            {
                Texture2D texture2D = new Texture2D(240, 320);
                texture2D.LoadImage(chaFileCtrl.pngData);
                riChara.texture = texture2D;
                riChara.enabled = true;
            }
        }
        ChaFileParameter parameter = chaFileCtrl.parameter;
        if ((bool)textName)
        {
            textName.text = parameter.fullname;
        }
        if (parameter.sex == 0)
        {
            return;
        }
        if ((bool)textPersonality)
        {
            VoiceInfo.Param[] source = Singleton<Voice>.Instance.voiceInfoDic.Values.Where(x => 0 <= x.No).ToArray();
            int[] array = source.Select(x => x.No).ToArray();
            string[] array2 = source.Select(x => x.Personality).ToArray();
            int personality = parameter.personality;
            VoiceInfo.Param value;
            if (!Singleton<Voice>.Instance.voiceInfoDic.TryGetValue(personality, out value))
            {
                Singleton<Voice>.Instance.voiceInfoDic.TryGetValue(0, out value);
            }
            int num = Array.IndexOf(array, value.No);
            if (num != -1)
            {
                textPersonality.text = array2[num];
            }
        }
        if ((bool)textWeakPoint)
        {
            textWeakPoint.text = strWeakPoint[parameter.weakPoint + 1];
        }
        if ((bool)textDenial[0])
        {
            textDenial[0].text = !parameter.denial.kiss ? "NO" : "YES";
        }
        if ((bool)textDenial[1])
        {
            textDenial[1].text = !parameter.denial.aibu ? "NO" : "YES";
        }
        if ((bool)textDenial[2])
        {
            textDenial[2].text = !parameter.denial.anal ? "NO" : "YES";
        }
        if ((bool)textDenial[3])
        {
            textDenial[3].text = !parameter.denial.massage ? "NO" : "YES";
        }
        if ((bool)textDenial[4])
        {
            textDenial[4].text = !parameter.denial.notCondom ? "NO" : "YES";
        }
    }

    public void Initialize(int sex)
    {
        Transform transform = base.transform.Find("resize");
        if ((bool)transform)
        {
            rtfResize = transform as RectTransform;
        }
        transform = base.transform.Find("resize/image/base");
        if ((bool)transform)
        {
            baseImage = transform.GetComponent<Image>();
        }
        transform = base.transform.Find("resize/image/chara");
        if ((bool)transform)
        {
            riChara = transform.GetComponent<RawImage>();
        }
        textName = transform.GetComponent<Text>();
        transform = base.transform.Find("resize/text/name");
        if ((bool)transform)
        {
            textName = transform.GetComponent<Text>();
        }
        if (sex == 0)
        {
            textPersonality = null;
            textWeakPoint = null;
            textDenial = null;
            return;
        }
        transform = base.transform.Find("resize/text/personality");
        if ((bool)transform)
        {
            textPersonality = transform.GetComponent<TextMeshProUGUI>();
        }
        transform = base.transform.Find("resize/text/weakPoint");
        if ((bool)transform)
        {
            textWeakPoint = transform.GetComponent<TextMeshProUGUI>();
        }
        textDenial = new TextMeshProUGUI[5];
        transform = base.transform.Find("resize/text/denial01");
        if ((bool)transform)
        {
            textDenial[0] = transform.GetComponent<TextMeshProUGUI>();
        }
        transform = base.transform.Find("resize/text/denial02");
        if ((bool)transform)
        {
            textDenial[1] = transform.GetComponent<TextMeshProUGUI>();
        }
        transform = base.transform.Find("resize/text/denial03");
        if ((bool)transform)
        {
            textDenial[2] = transform.GetComponent<TextMeshProUGUI>();
        }
        transform = base.transform.Find("resize/text/denial04");
        if ((bool)transform)
        {
            textDenial[3] = transform.GetComponent<TextMeshProUGUI>();
        }
        transform = base.transform.Find("resize/text/denial05");
        if ((bool)transform)
        {
            textDenial[4] = transform.GetComponent<TextMeshProUGUI>();
        }
    }

    private void Reset()
    {
        Initialize(1);
    }

    private void Update()
    {
        if (updateSize && null != rtfResize)
        {
            float num = drawHeight / 272f;
            rtfResize.localScale = new Vector3(num, num, 1f);
            updateSize = false;
        }
    }
}
