using Illusion.Game;
using Manager;
using System;
using System.Collections;
using UniRx;
using UnityEngine;
using UnityEngine.UI;

public class ClassScheduleScene : BaseLoader
{
    [SerializeField]
    private Canvas canvas;

    [SerializeField]
    private Button returnButton;

    private IEnumerator Start()
    {
        enabled = false;
        CanvasGroup canvasGroup = canvas.GetComponent<CanvasGroup>();
        if (canvasGroup != null)
        {
            this.ObserveEveryValueChanged(_ => !Singleton<Scene>.Instance.IsNowLoadingFade).Subscribe(delegate (bool isOn)
            {
                canvasGroup.interactable = isOn;
            });
        }
        Action returnProc = delegate
        {
            Observable.NextFrame().Subscribe(delegate
            {
                Singleton<Scene>.Instance.UnLoad();
            });
        };
        returnButton.OnClickAsObservable().Subscribe(delegate
        {
            Utils.Sound.Play(SystemSE.cancel);
            returnProc();
        });
        enabled = true;
        yield break;
    }
}
