using SkinnedMetaballBuilder;
using System;
using UnityEngine;

public class FPControl2 : MonoBehaviour
{
    public Camera myCamera;

    public CharacterController cc;

    public float walkSpeed = 3f;

    private float _theta;

    private float _phi;

    public float rotSpeed = 1f;

    private float _mx;

    private float _my;

    private int _currentWeaponIdx = -1;

    private Weapon _currentWeapon;

    public Weapon[] weapons;

    private void ChangeWeapon()
    {
        if (_currentWeapon != null)
        {
            _currentWeapon.OnRemove();
        }
        _currentWeaponIdx = (_currentWeaponIdx + 1) % weapons.Length;
        _currentWeapon = weapons[_currentWeaponIdx];
        _currentWeapon.OnEquip();
    }

    private void Start()
    {
        Vector3 forward = myCamera.transform.forward;
        _phi = Mathf.Asin(forward.y);
        _theta = Mathf.Atan2(forward.x, forward.z);
        Vector3 mousePosition = Input.mousePosition;
        _mx = mousePosition.x;
        Vector3 mousePosition2 = Input.mousePosition;
        _my = mousePosition2.y;
        ChangeWeapon();
    }

    private void Update()
    {
        float axis = Input.GetAxis("Horizontal");
        float axis2 = Input.GetAxis("Vertical");
        Vector3 mousePosition = Input.mousePosition;
        float x = mousePosition.x;
        Vector3 mousePosition2 = Input.mousePosition;
        float y = mousePosition2.y;
        float num = x - _mx;
        float num2 = y - _my;
        _mx = x;
        _my = y;
        Vector3 forward = myCamera.transform.forward;
        forward.y = 0f;
        forward.Normalize();
        Vector3 a = Vector3.Cross(Vector3.up, forward);
        Vector3 a2 = walkSpeed * (forward * axis2 + a * axis) + Vector3.down * 3f;
        cc.Move(a2 * Time.deltaTime);
        _theta -= num * rotSpeed;
        if (_theta > (float)Math.PI)
        {
            _theta -= (float)Math.PI * 2f;
        }
        else if (_theta <= -(float)Math.PI)
        {
            _theta += (float)Math.PI * 2f;
        }
        _phi += num2 * rotSpeed;
        if (_phi > 1f)
        {
            _phi = 1f;
        }
        else if (_phi < -1f)
        {
            _phi = -1f;
        }
        Vector3 b = new Vector3(Mathf.Cos(_phi) * Mathf.Cos(_theta), Mathf.Sin(_phi), Mathf.Cos(_phi) * Mathf.Sin(_theta));
        myCamera.transform.LookAt(myCamera.transform.position + b, Vector3.up);
        if (Input.GetKeyDown(KeyCode.Space))
        {
            Shoot();
        }
        if (Input.GetKeyDown(KeyCode.LeftShift) || Input.GetKeyDown(KeyCode.RightShift))
        {
            ChangeWeapon();
        }
    }

    public void Shoot()
    {
        Ray ray = myCamera.ScreenPointToRay(new Vector3(myCamera.pixelWidth * 0.5f, myCamera.pixelHeight * 0.5f, 0f));
        RaycastHit hitInfo;
        if (Physics.Raycast(ray, out hitInfo))
        {
            Transform transform = hitInfo.collider.transform;
            DungeonControl2 dungeonControl = Utils.FindComponentInParents<DungeonControl2>(transform);
            if (dungeonControl != null)
            {
                _currentWeapon.Shoot(dungeonControl, myCamera.transform.position, hitInfo.point);
            }
        }
    }
}
