using System;
using System.Collections.Generic;
using System.IO;

public class FolderAssist
{
    public class FileInfo
    {
        public string FullPath = string.Empty;

        public string FileName = string.Empty;

        public DateTime time;

        public FileInfo()
        {
        }

        public FileInfo(FileInfo src)
        {
            FullPath = src.FullPath;
            FileName = src.FileName;
            time = src.time;
        }

        public void Copy(FileInfo src)
        {
            FullPath = src.FullPath;
            FileName = src.FileName;
            time = src.time;
        }
    }

    public List<FileInfo> lstFile = new List<FileInfo>();

    public int GetFileCount()
    {
        return lstFile.Count;
    }

    public bool CreateFolderInfo(string folder, string searchPattern, bool getFiles = true, bool clear = true)
    {
        if (clear)
        {
            lstFile.Clear();
        }
        if (!Directory.Exists(folder))
        {
            return false;
        }
        string[] array = !getFiles ? Directory.GetDirectories(folder) : Directory.GetFiles(folder, searchPattern);
        if (array.Length == 0)
        {
            return false;
        }
        string[] array2 = array;
        foreach (string text in array2)
        {
            FileInfo fileInfo = new FileInfo();
            fileInfo.FullPath = text;
            if (getFiles)
            {
                fileInfo.FileName = Path.GetFileNameWithoutExtension(text);
            }
            fileInfo.time = File.GetLastWriteTime(text);
            lstFile.Add(fileInfo);
        }
        return true;
    }

    public bool CreateFolderInfoEx(string folder, string[] searchPattern, bool clear = true)
    {
        if (clear)
        {
            lstFile.Clear();
        }
        if (!Directory.Exists(folder))
        {
            return false;
        }
        List<string> list = new List<string>();
        foreach (string searchPattern2 in searchPattern)
        {
            list.AddRange(Directory.GetFiles(folder, searchPattern2));
        }
        string[] array = list.ToArray();
        if (array.Length == 0)
        {
            return false;
        }
        string[] array2 = array;
        foreach (string text in array2)
        {
            FileInfo fileInfo = new FileInfo();
            fileInfo.FullPath = text;
            fileInfo.FileName = Path.GetFileNameWithoutExtension(text);
            fileInfo.time = File.GetLastWriteTime(text);
            lstFile.Add(fileInfo);
        }
        return true;
    }

    public int GetIndexFromFileName(string filename)
    {
        int num = 0;
        foreach (FileInfo item in lstFile)
        {
            if (item.FileName == filename)
            {
                return num;
            }
            num++;
        }
        return -1;
    }

    public void SortName(bool ascend = true)
    {
        if (lstFile.Count != 0)
        {
            if (ascend)
            {
                lstFile.Sort((a, b) => a.FileName.CompareTo(b.FileName));
            }
            else
            {
                lstFile.Sort((a, b) => b.FileName.CompareTo(a.FileName));
            }
        }
    }

    public void SortDate(bool ascend = true)
    {
        if (lstFile.Count != 0)
        {
            if (ascend)
            {
                lstFile.Sort((a, b) => a.time.CompareTo(b.time));
            }
            else
            {
                lstFile.Sort((a, b) => b.time.CompareTo(a.time));
            }
        }
    }
}
