using ActionGame;
using ChaCustom;
using Illusion.CustomAttributes;
using Illusion.Game;
using Manager;
using System;
using System.Collections.Generic;
using System.Linq;
using UniRx;
using UnityEngine;
using UnityEngine.UI;

namespace FreeH
{
    public class FreeHClassRoomCharaFile : MonoBehaviour
    {
        [SerializeField]
        private ClassRoomFileListCtrl listCtrl;

        [Label("決定ボタン")]
        [SerializeField]
        private Button enterButton;

        public int sex;

        public int findKind = -1;

        private ReactiveProperty<ChaFileControl> info = new ReactiveProperty<ChaFileControl>();

        public event Action<ChaFileControl> onEnter = delegate
        {
        };

        private void Start()
        {
            FolderAssist folderAssist = new FolderAssist();
            folderAssist.CreateFolderInfoEx(UserData.Path + (sex != 0 ? "chara/female/" : "chara/male/"), new string[1]
            {
                "*.png"
            });
            listCtrl.ClearList();
            int fileCount = folderAssist.GetFileCount();
            int num = 0;
            Dictionary<int, ChaFileControl> chaFileDic = new Dictionary<int, ChaFileControl>();
            for (int i = 0; i < fileCount; i++)
            {
                FolderAssist.FileInfo fileInfo = folderAssist.lstFile[i];
                ChaFileControl chaFileControl = new ChaFileControl();
                if (!chaFileControl.LoadCharaFile(fileInfo.FullPath) || chaFileControl.parameter.sex != sex)
                {
                    continue;
                }
                string club = string.Empty;
                string personality = string.Empty;
                if (sex != 0)
                {
                    VoiceInfo.Param value;
                    personality = Singleton<Voice>.Instance.voiceInfoDic.TryGetValue(chaFileControl.parameter.personality, out value) ? value.Personality : "不明";
                    ClubInfo.Param value2;
                    club = Game.ClubInfos.TryGetValue(chaFileControl.parameter.clubActivities, out value2) ? value2.Name : "不明";
                    if (findKind != -1)
                    {
                        List<int> list = new List<int>();
                        list.Add(21);
                        list.Add(29);
                        List<int> list2 = list;
                        if (findKind >= 1)
                        {
                            list2.AddRange(new List<int>
                            {
                                1,
                                20
                            });
                        }
                        if (findKind >= 2)
                        {
                            list2.AddRange(new List<int>
                            {
                                8,
                                30
                            });
                        }
                        if (!list2.Contains(chaFileControl.parameter.personality))
                        {
                            continue;
                        }
                    }
                }
                else
                {
                    listCtrl.DisableAddInfo();
                }
                listCtrl.AddList(num, chaFileControl.parameter.fullname, club, personality, fileInfo.FullPath, fileInfo.FileName, fileInfo.time);
                chaFileDic.Add(num, chaFileControl);
                num++;
            }
            listCtrl.OnPointerClick += delegate (CustomFileInfo info)
            {
                this.info.Value = info != null ? chaFileDic[info.index] : null;
                Utils.Sound.Play(SystemSE.sel);
            };
            listCtrl.Create(delegate (CustomFileInfoComponent fic)
            {
                if (!(fic == null))
                {
                    fic.transform.GetChild(0).GetOrAddComponent<PreviewDataComponent>().SetChaFile(chaFileDic[fic.info.index]);
                }
            });
            info.Select(p => p != null).SubscribeToInteractable(enterButton);
            enterButton.OnClickAsObservable().Subscribe(delegate
            {
                onEnter(info.Value);
            });
            Button[] source = new Button[1]
            {
                enterButton
            };
            source.ToList().ForEach(delegate (Button bt)
            {
                bt.OnClickAsObservable().Subscribe(delegate
                {
                    Utils.Sound.Play(SystemSE.ok_s);
                });
            });
        }
    }
}
