using Illusion.Game;
using Manager;
using System;
using UniRx;
using UniRx.Triggers;
using UnityEngine;
using UnityEngine.UI;

namespace FreeH
{
    public class FreeHPreviewCharaList : BaseLoader
    {
        [SerializeField]
        private FreeHClassRoomCharaFile charFile;

        [SerializeField]
        private Button cancel;

        [SerializeField]
        private Button cancel2;

        public event Action<ChaFileControl> onEnter = delegate
        {
        };

        public event Action onCancel = delegate
        {
        };

        private void Start()
        {
            Canvas canvas = GetComponent<Canvas>();
            CanvasGroup canvasGroup = GetComponent<CanvasGroup>();
            this.ObserveEveryValueChanged(_ => !Singleton<Scene>.Instance.IsNowLoadingFade).Subscribe(delegate (bool isOn)
            {
                canvasGroup.interactable = isOn;
            });
            charFile.onEnter += delegate (ChaFileControl file)
            {
                onEnter(file);
            };
            cancel.OnClickAsObservable().Subscribe(delegate
            {
                Utils.Sound.Play(SystemSE.cancel);
                onCancel();
            });
            cancel2.OnClickAsObservable().Subscribe(delegate
            {
                Utils.Sound.Play(SystemSE.cancel);
                onCancel();
            });
            (from _ in this.UpdateAsObservable()
             where canvas.enabled
             where Singleton<Scene>.Instance.NowSceneNames[0].ContainsAny("FreeHCharaSelectFemale", "FreeHCharaSelectMale", "LiveCharaSelectFemale", "FreeHCharaSelectFemaleAdd54", "FreeHCharaSelectFemaleAdd55", "FreeHCharaSelectFemaleAdd56")
             where Input.GetMouseButtonDown(1)
             select _).Subscribe(delegate
         {
             Utils.Sound.Play(SystemSE.cancel);
             onCancel();
         });
        }
    }
}
