using System;
using System.Collections;
using UnityEngine;

namespace Illusion.Component.Correct
{
    public class FingerCorrect : MonoBehaviour
    {
        [Serializable]
        private class Info
        {
            public bool enable;

            public Transform trfBone;

            public Vector3 position = Vector3.zero;

            public Vector3 rotation = Vector3.zero;
        }

        [SerializeField]
        private bool enableAll = true;

        [SerializeField]
        private Info[] info;

        private void LateUpdate()
        {
            if (!enableAll || info == null)
            {
                return;
            }
            Info[] array = info;
            foreach (Info info in array)
            {
                if (info.enable && !(null == info.trfBone))
                {
                    Vector3 position = info.trfBone.position;
                    Transform trfBone = info.trfBone;
                    Vector3 position2 = info.trfBone.position;
                    float x = position2.x + info.position.x;
                    Vector3 position3 = info.trfBone.position;
                    float y = position3.y + info.position.y;
                    Vector3 position4 = info.trfBone.position;
                    trfBone.position = new Vector3(x, y, position4.z + info.position.z);
                    Vector3 eulerAngles = info.trfBone.rotation.eulerAngles;
                    Transform trfBone2 = info.trfBone;
                    Vector3 eulerAngles2 = info.trfBone.rotation.eulerAngles;
                    float x2 = eulerAngles2.x + info.rotation.x;
                    Vector3 eulerAngles3 = info.trfBone.rotation.eulerAngles;
                    float y2 = eulerAngles3.y + info.rotation.y;
                    Vector3 eulerAngles4 = info.trfBone.rotation.eulerAngles;
                    trfBone2.rotation = Quaternion.Euler(x2, y2, eulerAngles4.z + info.rotation.z);
                    StartCoroutine(RestoreTransform(info.trfBone, position, eulerAngles));
                }
            }
        }

        private IEnumerator RestoreTransform(Transform trfTarget, Vector3 pos, Vector3 rot)
        {
            yield return new WaitForEndOfFrame();
            trfTarget.position = pos;
            trfTarget.rotation = Quaternion.Euler(rot);
        }
    }
}
