using System;
using System.Collections;
using UnityEngine;

namespace IllusionUtility.GetUtility
{
    public static class AnimationEx
    {
        public static AnimationClip GetPlayingClip(this Animation animation)
        {
            AnimationClip result = null;
            float num = 0f;
            IEnumerator enumerator = animation.GetEnumerator();
            try
            {
                while (enumerator.MoveNext())
                {
                    AnimationState animationState = (AnimationState)enumerator.Current;
                    if (animationState.enabled && num < animationState.weight)
                    {
                        num = animationState.weight;
                        result = animationState.clip;
                    }
                }
                return result;
            }
            finally
            {
                IDisposable disposable;
                if ((disposable = enumerator as IDisposable) != null)
                {
                    disposable.Dispose();
                }
            }
        }
    }
}
