using Manager;
using System.Collections;
using System.Collections.Generic;
using System.IO;
using System.Xml;
using System.Xml.Linq;
using UnityEngine;

public class InitScene : BaseLoader
{
    private XElement dataXml;

    private int width = 1280;

    private int height = 720;

    private int quality = 2;

    private bool full;

    private IEnumerator Start()
    {
        yield return new WaitUntil(Singleton<Manager.Config>.IsInstance);
        if (SystemInfo.graphicsShaderLevel < 30)
        {
            print("shaders Non support");
        }
        if (File.Exists("UserData/setup.xml"))
        {
            xmlRead();
        }
        string uid = CommonLib.GetUUID();
        if (string.Empty == uid)
        {
            string registryInfoFrom = YS_Assist.GetRegistryInfoFrom("Software\\illusion\\Koikatu\\KoikatuTrial", "INSTALLDIR");
            string text = registryInfoFrom + "UserData/save/netUID.dat";
            if (File.Exists(text))
            {
                string text2 = Path.GetDirectoryName(Application.dataPath) + "/UserData/save/";
                string destFileName = text2 + "netUID.dat";
                if (!Directory.Exists(text2))
                {
                    Directory.CreateDirectory(text2);
                }
                File.Copy(text, destFileName);
            }
            else
            {
                CommonLib.CreateUUID();
            }
        }
        Scene.Data data = new Scene.Data
        {
            levelName = "Logo"
        };
        Singleton<Scene>.Instance.LoadReserve(data, false);
        yield return null;
    }

    private void xmlRead()
    {
        try
        {
            dataXml = XElement.Load("UserData/setup.xml");
            if (dataXml != null)
            {
                IEnumerable<XElement> enumerable = dataXml.Elements();
                foreach (XElement item in enumerable)
                {
                    switch (item.Name.ToString())
                    {
                        case "Width":
                            width = int.Parse(item.Value);
                            break;
                        case "Height":
                            height = int.Parse(item.Value);
                            break;
                        case "FullScreen":
                            full = bool.Parse(item.Value);
                            break;
                        case "Quality":
                            quality = int.Parse(item.Value);
                            break;
                    }
                }
                Screen.SetResolution(width, height, full);
                switch (quality)
                {
                    case 0:
                        QualitySettings.SetQualityLevel(!Manager.Config.EtcData.SelfShadow ? 1 : 0);
                        break;
                    case 1:
                        QualitySettings.SetQualityLevel(!Manager.Config.EtcData.SelfShadow ? 3 : 2);
                        break;
                    case 2:
                        QualitySettings.SetQualityLevel(!Manager.Config.EtcData.SelfShadow ? 5 : 4);
                        break;
                }
            }
        }
        catch (XmlException)
        {
            File.Delete("UserData/setup.xml");
        }
    }
}
