using System;
using System.Collections;
using UnityEngine;

public class LegacyAnimationSpeedSet : MonoBehaviour
{
    public float[] AnmSpeed;

    private Animation anim;

    private string[] name_a;

    private int AnmCount;

    private void Awake()
    {
        anim = transform.GetComponent<Animation>();
        AnmCount = anim.GetClipCount();
        name_a = new string[AnmCount];
        int num = 0;
        IEnumerator enumerator = anim.GetEnumerator();
        try
        {
            while (enumerator.MoveNext())
            {
                AnimationState animationState = (AnimationState)enumerator.Current;
                name_a[num++] = animationState.name;
            }
        }
        finally
        {
            IDisposable disposable;
            if ((disposable = enumerator as IDisposable) != null)
            {
                disposable.Dispose();
            }
        }
    }

    private void Update()
    {
        for (int i = 0; i < AnmCount && AnmSpeed.Length > i; i++)
        {
            anim[name_a[i]].speed = AnmSpeed[i];
        }
    }
}
