using System.Collections;
using UnityEngine;

public class LoadSound : LoadAudioBase
{
    public Manager.Sound.Type type = Manager.Sound.Type.GameSE2D;

    public bool isAssetEqualPlay = true;

    public override IEnumerator _Init()
    {
        if (initialized)
        {
            yield break;
        }
        if (!isAssetEqualPlay && Singleton<Manager.Sound>.Instance.FindAsset(type, assetName, assetBundleName) != null)
        {
            Transform parent = transform.parent;
            if (parent != null)
            {
                if (parent.GetComponent<AudioSource>() != null)
                {
                    isReleaseClip = false;
                    Destroy(parent.gameObject);
                    initialized = true;
                    yield break;
                }
            }
            else if (transform.GetComponent<LoadAudioBase>() != null)
            {
                isReleaseClip = false;
                Destroy(gameObject);
                initialized = true;
                yield break;
            }
        }
        if (isAsync)
        {
            yield return StartCoroutine(base._Init());
        }
        else
        {
            StartCoroutine(base._Init());
        }
        if (!(clip == null))
        {
            Singleton<Manager.Sound>.Instance.Bind(this);
            name = "Sound LoadEnd";
        }
    }

    protected override IEnumerator Start()
    {
        enabled = false;
        if (audioSource == null)
        {
            yield return StartCoroutine(_Init());
        }
        while (!isLoadEnd)
        {
            yield return null;
        }
        if (!(clip == null))
        {
            GameObject fadeOut = null;
            if (type == Manager.Sound.Type.BGM)
            {
                fadeTime = Mathf.Max(fadeTime, 0.01f);
                fadeOut = Singleton<Manager.Sound>.Instance.currentBGM;
                Singleton<Manager.Sound>.Instance.currentBGM = audioSource.gameObject;
            }
            StartCoroutine(Play(fadeOut));
            enabled = true;
        }
    }
}
