using Manager;
using System.Collections;
using UniRx;
using UniRx.Triggers;
using UnityEngine;

public class LoadVoice : LoadAudioBase
{
    public int no;

    public Transform voiceTrans;

    public Voice.Type type;

    public bool isPlayEndDelete = true;

    public float pitch = 1f;

    public bool is2D;

    public override IEnumerator _Init()
    {
        if (initialized)
        {
            yield break;
        }
        if (isAsync)
        {
            yield return StartCoroutine(base._Init());
        }
        else
        {
            StartCoroutine(base._Init());
        }
        if (clip == null)
        {
            yield break;
        }
        Singleton<Voice>.Instance.Bind(this);
        name = "Voice LoadEnd";
        if (audioSource == null)
        {
            Destroy(gameObject);
            yield break;
        }
        if (settingNo < 0)
        {
            audioSource.loop = !isPlayEndDelete;
            if (!is2D)
            {
                audioSource.spatialBlend = voiceTrans != null ? 1 : 0;
            }
            else
            {
                audioSource.spatialBlend = 0f;
            }
        }
        audioSource.pitch = pitch;
    }

    protected override IEnumerator Start()
    {
        enabled = false;
        if (audioSource == null)
        {
            yield return StartCoroutine(_Init());
        }
        while (!isLoadEnd)
        {
            yield return null;
        }
        if (!(clip == null))
        {
            StartCoroutine(Play(null));
            this.UpdateAsObservable().TakeUntilDestroy(audioSource).Subscribe(delegate
            {
                audioSource.volume = Singleton<Voice>.Instance.GetVolume(no);
            });
            if (!(voiceTrans == null))
            {
                Transform audioTrans = audioSource.transform;
                this.UpdateAsObservable().TakeUntilDestroy(voiceTrans).TakeUntilDestroy(audioSource)
                    .Subscribe(delegate
                    {
                        audioTrans.SetPositionAndRotation(voiceTrans.position, voiceTrans.rotation);
                    });
                enabled = true;
            }
        }
    }
}
