using Illusion.Extensions;
using Manager;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using UnityEngine;

public class LogoScene : BaseLoader
{
    [SerializeField]
    private float waitTime = 2f;

    private IEnumerator Start()
    {
        enabled = false;
        List<AudioClip> clipList = new List<AudioClip>();
        AssetBundleData.GetAssetBundleNameListFromPath("sound/data/systemse/brandcall/", true).ForEach(delegate (string file)
        {
            clipList.AddRange(AssetBundleManager.LoadAllAsset(file, typeof(AudioClip)).GetAllAssets<AudioClip>());
            AssetBundleManager.UnloadAssetBundle(file, true);
        });
        yield return new WaitWhile(() => Singleton<Scene>.Instance.sceneFade.IsFadeNow);
        clipList.RemoveAll(p => p == null);
        AudioClip clip2 = clipList.Shuffle().FirstOrDefault();
        AudioSource source = null;
        if (clip2 != null)
        {
            source = Singleton<Manager.Sound>.Instance.Play(Manager.Sound.Type.SystemSE, clip2);
        }
        yield return new WaitForSecondsRealtime(waitTime);
        if (source != null)
        {
            yield return new WaitWhile(() => source.isPlaying);
            Destroy(source.gameObject);
        }
        clipList.ForEach(Resources.UnloadAsset);
        clipList.Clear();
        clip2 = null;
        Singleton<Scene>.Instance.LoadReserve(new Scene.Data
        {
            levelName = "Title",
            isFade = true
        }, false);
        enabled = true;
    }
}
