using Illusion.CustomAttributes;
using IllusionUtility.GetUtility;
using Manager;
using System;
using System.IO;
using UnityEngine;

public class MainCGChara : MonoBehaviour
{
    public class ItemInfo
    {
        public Vector3 pos = Vector3.zero;

        public Vector3 rot = Vector3.zero;

        public Vector3 scl = Vector3.one;

        public string parentName = string.Empty;
    }

    private string[] chaSaveFile = new string[7]
    {
        "/WorkSpace/chaNo01.dat",
        "/WorkSpace/chaNo02.dat",
        "/WorkSpace/chaNo03.dat",
        "/WorkSpace/chaNo04.dat",
        "/WorkSpace/chaNo05.dat",
        "/WorkSpace/chaNo06.dat",
        "/WorkSpace/chaNo07.dat"
    };

    private string[] chaPngFile = new string[7]
    {
        "櫻井　野乃花.png",
        "姫川　舞.png",
        "結城　桜.png",
        "柊　このみ.png",
        "水瀬　亜依.png",
        "白鳥　葵.png",
        "リナ　ロベール.png"
    };

    [SerializeField]
    private CameraControl_Ver2 camCtrl;

    public string anmCtrlName = string.Empty;

    public string itemName01 = string.Empty;

    public string itemName02 = string.Empty;

    public ItemInfo itemInfo01 = new ItemInfo();

    public ItemInfo itemInfo02 = new ItemInfo();

    private ChaControl chaCtrl;

    private GameObject objItem01;

    private GameObject objItem02;

    [Header("保存-------------------------------------")]
    [Button("SaveSetting", "櫻井　野乃花", new object[]
    {
        0
    })]
    public int savesetting0;

    [Button("SaveSetting", "姫川　舞", new object[]
    {
        1
    })]
    public int savesetting1;

    [Button("SaveSetting", "結城　桜", new object[]
    {
        2
    })]
    public int savesetting2;

    [Button("SaveSetting", "柊　このみ", new object[]
    {
        3
    })]
    public int savesetting3;

    [Button("SaveSetting", "水瀬　亜依", new object[]
    {
        4
    })]
    public int savesetting4;

    [Button("SaveSetting", "白鳥　葵", new object[]
    {
        5
    })]
    public int savesetting5;

    [Button("SaveSetting", "リナ　ロベール", new object[]
    {
        6
    })]
    public int savesetting6;

    [Button("ReLoad", "櫻井　野乃花", new object[]
    {
        0
    })]
    [Header("読み込み---------------------------------")]
    public int loadsetting0;

    [Button("ReLoad", "姫川　舞", new object[]
    {
        1
    })]
    public int loadsetting1;

    [Button("ReLoad", "結城　桜", new object[]
    {
        2
    })]
    public int loadsetting2;

    [Button("ReLoad", "柊　このみ", new object[]
    {
        3
    })]
    public int loadsetting3;

    [Button("ReLoad", "水瀬　亜依", new object[]
    {
        4
    })]
    public int loadsetting4;

    [Button("ReLoad", "白鳥　葵", new object[]
    {
        5
    })]
    public int loadsetting5;

    [Button("ReLoad", "リナ　ロベール", new object[]
    {
        6
    })]
    public int loadsetting6;

    public void Start()
    {
        Singleton<Character>.Instance.enableCorrectArmSize = true;
        Singleton<Character>.Instance.enableCorrectHandSize = true;
        chaCtrl = Singleton<Character>.Instance.CreateFemale(null, 0);
    }

    public void ReLoad(int chaNo)
    {
        if ((bool)objItem01)
        {
            Destroy(objItem01);
        }
        if ((bool)objItem02)
        {
            Destroy(objItem02);
        }
        chaCtrl.chaFile.LoadCharaFile(chaPngFile[chaNo], 1);
        chaCtrl.ChangeCoordinateType(ChaFileDefine.CoordinateType.Club);
        chaCtrl.Load();
        LoadSetting(chaNo);
        LoadAnimation(chaCtrl, anmCtrlName);
        chaCtrl.SetAccessoryStateCategory(0, true);
        chaCtrl.SetAccessoryStateCategory(1, true);
        objItem01 = LoadItem(itemName01);
        objItem02 = LoadItem(itemName02);
        if (objItem01 && string.Empty != itemInfo01.parentName)
        {
            GameObject gameObject = chaCtrl.objTop.transform.FindLoop(itemInfo01.parentName);
            if (null != gameObject)
            {
                objItem01.transform.SetParent(gameObject.transform, false);
                objItem01.transform.localPosition = itemInfo01.pos;
                objItem01.transform.localEulerAngles = itemInfo01.rot;
                objItem01.transform.localScale = itemInfo01.scl;
            }
        }
        if (objItem02 && string.Empty != itemInfo02.parentName)
        {
            GameObject gameObject2 = chaCtrl.objTop.transform.FindLoop(itemInfo02.parentName);
            if (null != gameObject2)
            {
                objItem02.transform.SetParent(gameObject2.transform, false);
                objItem02.transform.localPosition = itemInfo02.pos;
                objItem02.transform.localEulerAngles = itemInfo02.rot;
                objItem02.transform.localScale = itemInfo02.scl;
            }
        }
        ChaFileStatus status = chaCtrl.chaFile.status;
        chaCtrl.ChangeEyebrowPtn(status.eyebrowPtn);
        chaCtrl.ChangeEyebrowOpenMax(status.eyebrowOpenMax);
        chaCtrl.ChangeEyesPtn(status.eyesPtn);
        chaCtrl.ChangeEyesOpenMax(status.eyesOpenMax);
        chaCtrl.ChangeEyesBlinkFlag(false);
        chaCtrl.ChangeMouthPtn(status.mouthPtn);
        chaCtrl.ChangeMouthOpenMax(status.mouthOpenMax);
        chaCtrl.ChangeMouthFixed(status.mouthFixed);
        chaCtrl.ChangeLookEyesPtn(status.eyesLookPtn);
        if (chaCtrl.chaFile.status.eyesTargetType == 0 || 1 == 0)
        {
            chaCtrl.ChangeLookEyesTarget(0);
        }
        else
        {
            chaCtrl.ChangeLookEyesTarget(999, null, chaCtrl.chaFile.status.eyesTargetRate, chaCtrl.chaFile.status.eyesTargetAngle, chaCtrl.chaFile.status.eyesTargetRange);
        }
        chaCtrl.ChangeLookNeckPtn(status.neckLookPtn);
        if (chaCtrl.chaFile.status.neckTargetType == 0 || 1 == 0)
        {
            chaCtrl.ChangeLookNeckTarget(0);
        }
        else
        {
            chaCtrl.ChangeLookNeckTarget(999, null, chaCtrl.chaFile.status.neckTargetRate, chaCtrl.chaFile.status.neckTargetAngle, chaCtrl.chaFile.status.neckTargetRange);
        }
        chaCtrl.ChangeHohoAkaRate(status.hohoAkaRate);
        chaCtrl.ChangeSettingSkinGlossPower();
        Resources.UnloadUnusedAssets();
        GC.Collect();
    }

    public void LoadAnimation(ChaControl cha, string path)
    {
        if (!(null == cha.animBody))
        {
            cha.animBody.runtimeAnimatorController = (RuntimeAnimatorController)Resources.Load(path);
        }
    }

    public GameObject LoadItem(string path)
    {
        UnityEngine.Object @object = Resources.Load(path);
        if (null == @object)
        {
            return null;
        }
        return (GameObject)Instantiate(@object);
    }

    private void Update()
    {
    }

    private void SaveSetting(int chaNo)
    {
        byte[] statusBytes = chaCtrl.chaFile.GetStatusBytes();
        string path = Application.dataPath + "/.." + chaSaveFile[chaNo];
        string directoryName = Path.GetDirectoryName(path);
        if (!Directory.Exists(directoryName))
        {
            Directory.CreateDirectory(directoryName);
        }
        using (FileStream output = new FileStream(path, FileMode.Create, FileAccess.Write))
        {
            using (BinaryWriter binaryWriter = new BinaryWriter(output))
            {
                binaryWriter.Write(statusBytes.Length);
                binaryWriter.Write(statusBytes);
                Vector3 position = chaCtrl.GetPosition();
                binaryWriter.Write(position.x);
                binaryWriter.Write(position.y);
                binaryWriter.Write(position.z);
                Vector3 rotation = chaCtrl.GetRotation();
                binaryWriter.Write(rotation.x);
                binaryWriter.Write(rotation.y);
                binaryWriter.Write(rotation.z);
                binaryWriter.Write(anmCtrlName);
                itemInfo01 = new ItemInfo();
                if ((bool)objItem01)
                {
                    if ((bool)objItem01.transform.parent)
                    {
                        itemInfo01.parentName = objItem01.transform.parent.name;
                    }
                    Vector3 localPosition = objItem01.transform.localPosition;
                    itemInfo01.pos.x = localPosition.x;
                    Vector3 localPosition2 = objItem01.transform.localPosition;
                    itemInfo01.pos.y = localPosition2.y;
                    Vector3 localPosition3 = objItem01.transform.localPosition;
                    itemInfo01.pos.z = localPosition3.z;
                    Vector3 localEulerAngles = objItem01.transform.localEulerAngles;
                    itemInfo01.rot.x = localEulerAngles.x;
                    Vector3 localEulerAngles2 = objItem01.transform.localEulerAngles;
                    itemInfo01.rot.y = localEulerAngles2.y;
                    Vector3 localEulerAngles3 = objItem01.transform.localEulerAngles;
                    itemInfo01.rot.z = localEulerAngles3.z;
                    Vector3 localScale = objItem01.transform.localScale;
                    itemInfo01.scl.x = localScale.x;
                    Vector3 localScale2 = objItem01.transform.localScale;
                    itemInfo01.scl.y = localScale2.y;
                    Vector3 localScale3 = objItem01.transform.localScale;
                    itemInfo01.scl.z = localScale3.z;
                }
                binaryWriter.Write(itemName01);
                binaryWriter.Write(itemInfo01.parentName);
                binaryWriter.Write(itemInfo01.pos.x);
                binaryWriter.Write(itemInfo01.pos.y);
                binaryWriter.Write(itemInfo01.pos.z);
                binaryWriter.Write(itemInfo01.rot.x);
                binaryWriter.Write(itemInfo01.rot.y);
                binaryWriter.Write(itemInfo01.rot.z);
                binaryWriter.Write(itemInfo01.scl.x);
                binaryWriter.Write(itemInfo01.scl.y);
                binaryWriter.Write(itemInfo01.scl.z);
                itemInfo02 = new ItemInfo();
                if ((bool)objItem02)
                {
                    if ((bool)objItem02.transform.parent)
                    {
                        itemInfo02.parentName = objItem02.transform.parent.name;
                    }
                    Vector3 localPosition4 = objItem02.transform.localPosition;
                    itemInfo02.pos.x = localPosition4.x;
                    Vector3 localPosition5 = objItem02.transform.localPosition;
                    itemInfo02.pos.y = localPosition5.y;
                    Vector3 localPosition6 = objItem02.transform.localPosition;
                    itemInfo02.pos.z = localPosition6.z;
                    Vector3 localEulerAngles4 = objItem02.transform.localEulerAngles;
                    itemInfo02.rot.x = localEulerAngles4.x;
                    Vector3 localEulerAngles5 = objItem02.transform.localEulerAngles;
                    itemInfo02.rot.y = localEulerAngles5.y;
                    Vector3 localEulerAngles6 = objItem02.transform.localEulerAngles;
                    itemInfo02.rot.z = localEulerAngles6.z;
                    Vector3 localScale4 = objItem02.transform.localScale;
                    itemInfo02.scl.x = localScale4.x;
                    Vector3 localScale5 = objItem02.transform.localScale;
                    itemInfo02.scl.y = localScale5.y;
                    Vector3 localScale6 = objItem02.transform.localScale;
                    itemInfo02.scl.z = localScale6.z;
                }
                binaryWriter.Write(itemName02);
                binaryWriter.Write(itemInfo02.parentName);
                binaryWriter.Write(itemInfo02.pos.x);
                binaryWriter.Write(itemInfo02.pos.y);
                binaryWriter.Write(itemInfo02.pos.z);
                binaryWriter.Write(itemInfo02.rot.x);
                binaryWriter.Write(itemInfo02.rot.y);
                binaryWriter.Write(itemInfo02.rot.z);
                binaryWriter.Write(itemInfo02.scl.x);
                binaryWriter.Write(itemInfo02.scl.y);
                binaryWriter.Write(itemInfo02.scl.z);
                camCtrl.CameraDataSaveBinary(binaryWriter);
            }
        }
    }

    private void LoadSetting(int chaNo)
    {
        string path = Application.dataPath + "/.." + chaSaveFile[chaNo];
        if (!File.Exists(path))
        {
            itemName01 = string.Empty;
            itemName02 = string.Empty;
            anmCtrlName = string.Empty;
        }
        else
        {
            using (FileStream input = new FileStream(path, FileMode.Open, FileAccess.Read))
            {
                using (BinaryReader binaryReader = new BinaryReader(input))
                {
                    int count = binaryReader.ReadInt32();
                    byte[] statusBytes = binaryReader.ReadBytes(count);
                    chaCtrl.chaFile.SetStatusBytes(statusBytes);
                    Vector3 zero = Vector3.zero;
                    zero.x = binaryReader.ReadSingle();
                    zero.y = binaryReader.ReadSingle();
                    zero.z = binaryReader.ReadSingle();
                    chaCtrl.SetPosition(zero);
                    Vector3 zero2 = Vector3.zero;
                    zero2.x = binaryReader.ReadSingle();
                    zero2.y = binaryReader.ReadSingle();
                    zero2.z = binaryReader.ReadSingle();
                    chaCtrl.SetPosition(zero2);
                    anmCtrlName = binaryReader.ReadString();
                    itemName01 = binaryReader.ReadString();
                    itemInfo01 = new ItemInfo();
                    itemInfo01.parentName = binaryReader.ReadString();
                    itemInfo01.pos.x = binaryReader.ReadSingle();
                    itemInfo01.pos.y = binaryReader.ReadSingle();
                    itemInfo01.pos.z = binaryReader.ReadSingle();
                    itemInfo01.rot.x = binaryReader.ReadSingle();
                    itemInfo01.rot.y = binaryReader.ReadSingle();
                    itemInfo01.rot.z = binaryReader.ReadSingle();
                    itemInfo01.scl.x = binaryReader.ReadSingle();
                    itemInfo01.scl.y = binaryReader.ReadSingle();
                    itemInfo01.scl.z = binaryReader.ReadSingle();
                    itemName02 = binaryReader.ReadString();
                    itemInfo02 = new ItemInfo();
                    itemInfo02.parentName = binaryReader.ReadString();
                    itemInfo02.pos.x = binaryReader.ReadSingle();
                    itemInfo02.pos.y = binaryReader.ReadSingle();
                    itemInfo02.pos.z = binaryReader.ReadSingle();
                    itemInfo02.rot.x = binaryReader.ReadSingle();
                    itemInfo02.rot.y = binaryReader.ReadSingle();
                    itemInfo02.rot.z = binaryReader.ReadSingle();
                    itemInfo02.scl.x = binaryReader.ReadSingle();
                    itemInfo02.scl.y = binaryReader.ReadSingle();
                    itemInfo02.scl.z = binaryReader.ReadSingle();
                    camCtrl.CameraDataLoadBinary(binaryReader, true);
                }
            }
        }
    }
}
