using IllusionUtility.GetUtility;
using System.Linq;
using UnityEngine;

public class MatAnmFrame : MonoBehaviour
{
    public bool Usage = true;

    public Animation Anm;

    public MatAnmPtnInfo[] PtnInfo;

    private Renderer rendererData;

    private int _Color;

    private void Awake()
    {
        _Color = Shader.PropertyToID("_Color");
    }

    private void Start()
    {
        rendererData = GetComponent<Renderer>();
        if (null == rendererData)
        {
            enabled = false;
        }
    }

    private void Update()
    {
        if (!Usage)
        {
            return;
        }
        AnimationClip playingClip = Anm.GetPlayingClip();
        int num = -1;
        foreach (var item in PtnInfo.Select((value, index) => new
        {
            value,
            index
        }))
        {
            if (!(item.value.PtnName != playingClip.name))
            {
                num = item.index;
                break;
            }
        }
        if (num == -1)
        {
            return;
        }
        MatAnmPtnInfo matAnmPtnInfo = PtnInfo[num];
        AnimationState animationState = Anm[playingClip.name];
        float num2 = animationState.time;
        while (playingClip.length < num2)
        {
            num2 -= playingClip.length;
        }
        int num3 = (int)Mathf.Lerp(0f, playingClip.frameRate * playingClip.length, Mathf.InverseLerp(0f, playingClip.length, num2));
        bool flag = false;
        Color32 c = default(Color32);
        for (int i = 0; i < matAnmPtnInfo.Param.Length - 1; i++)
        {
            if (matAnmPtnInfo.Param[i].Frame <= num3 && matAnmPtnInfo.Param[i + 1].Frame >= num3)
            {
                float t = Mathf.InverseLerp(matAnmPtnInfo.Param[i].Frame, matAnmPtnInfo.Param[i + 1].Frame, num3);
                c.r = (byte)Mathf.Lerp(matAnmPtnInfo.Param[i].ColorVal.r, matAnmPtnInfo.Param[i + 1].ColorVal.r, t);
                c.g = (byte)Mathf.Lerp(matAnmPtnInfo.Param[i].ColorVal.g, matAnmPtnInfo.Param[i + 1].ColorVal.g, t);
                c.b = (byte)Mathf.Lerp(matAnmPtnInfo.Param[i].ColorVal.b, matAnmPtnInfo.Param[i + 1].ColorVal.b, t);
                c.a = (byte)Mathf.Lerp(matAnmPtnInfo.Param[i].ColorVal.a, matAnmPtnInfo.Param[i + 1].ColorVal.a, t);
                rendererData.material.SetColor(_Color, c);
                flag = true;
                break;
            }
        }
        if (flag)
        {
        }
    }
}
