using IllusionUtility.GetUtility;
using System.Linq;
using UnityEngine;

public class MatAnmFrameEx : MonoBehaviour
{
    public bool Usage = true;

    public Animation Anm;

    public MatAnmPtnInfoEx[] PtnInfo;

    private Renderer rendererData;

    private int _Color;

    private void Awake()
    {
        _Color = Shader.PropertyToID("_Color");
    }

    private void Start()
    {
        rendererData = GetComponent<Renderer>();
        if (null == rendererData)
        {
            enabled = false;
        }
    }

    private void Update()
    {
        if (!Usage)
        {
            return;
        }
        AnimationClip playingClip = Anm.GetPlayingClip();
        int num = -1;
        foreach (var item in PtnInfo.Select((value, index) => new
        {
            value,
            index
        }))
        {
            if (!(item.value.PtnName != playingClip.name))
            {
                num = item.index;
                break;
            }
        }
        if (num != -1)
        {
            MatAnmPtnInfoEx matAnmPtnInfoEx = PtnInfo[num];
            AnimationState animationState = Anm[playingClip.name];
            float num2 = animationState.time;
            while (playingClip.length < num2)
            {
                num2 -= playingClip.length;
            }
            float time = Mathf.InverseLerp(0f, playingClip.length, num2);
            Color color = matAnmPtnInfoEx.Value.Evaluate(time);
            Color value2 = default(Color);
            value2.r = color.r;
            Color color2 = matAnmPtnInfoEx.Value.Evaluate(time);
            value2.g = color2.g;
            Color color3 = matAnmPtnInfoEx.Value.Evaluate(time);
            value2.b = color3.b;
            Color color4 = matAnmPtnInfoEx.Value.Evaluate(time);
            value2.a = color4.a;
            rendererData.material.SetColor(_Color, value2);
        }
    }
}
