using UnityEngine;
using UnityEngine.Audio;

public static class MixerVolume
{
    public enum Names
    {
        MasterVolume,
        BGMVolume,
        PCMVolume,
        ENVVolume,
        GameSEVolume,
        SystemSEVolume
    }

    public static void Set(AudioMixer mixer, Names name, float volume)
    {
        float value = 20f * Mathf.Log10(Mathf.Clamp(volume, 0.0001f, 1f));
        mixer.SetFloat(name.ToString(), Mathf.Clamp(value, -80f, 0f));
    }

    public static float Get(AudioMixer mixer, Names name)
    {
        float value;
        if (!mixer.GetFloat(name.ToString(), out value))
        {
            return 0f;
        }
        return Mathf.InverseLerp(-80f, 0f, value);
    }
}
