using System;
using UnityEngine;

[Serializable]
public class NeckTypeStateVer2
{
    public string name;

    [Tooltip("各骨のパラメーター")]
    public NeckLimitParameter[] aParam;

    [Tooltip("補間速度")]
    [Range(0f, 100f)]
    public float leapSpeed = 2.5f;

    [Tooltip("視野角(正面からどの範囲までターゲットを追うか)水色線")]
    [Range(0f, 180f)]
    public float hAngleLimit = 110f;

    [Tooltip("視野角(正面からどの範囲までターゲットを追うか)水色線")]
    [Range(0f, 180f)]
    public float vAngleLimit = 80f;

    [Tooltip("視野角から離脱するまでの補正値(黄色線 黄色線を超えると離脱する)")]
    [Range(0f, 180f)]
    public float limitBreakCorrectionValue;

    [Range(0f, 180f)]
    [Tooltip("逸らすときに逆を向くための範囲\n[首が向ける最大角度からの]\n紫線")]
    public float limitAway = 20f;

    [Tooltip("デバッグ用表示")]
    [SerializeField]
    internal bool isLimitBreakBackup;

    public NECK_LOOK_TYPE_VER2 lookType = NECK_LOOK_TYPE_VER2.TARGET;
}
