using NodeCanvas.Framework;
using UnityEngine;

namespace NodeCanvas.BehaviourTrees
{
    [AddComponentMenu("NodeCanvas/Behaviour Tree Owner")]
    public class BehaviourTreeOwner : GraphOwner<BehaviourTree>
    {
        public bool repeat
        {
            get
            {
                return !(behaviour != null) || behaviour.repeat;
            }
            set
            {
                if (behaviour != null)
                {
                    behaviour.repeat = value;
                }
            }
        }

        public float updateInterval
        {
            get
            {
                return !(behaviour != null) ? 0f : behaviour.updateInterval;
            }
            set
            {
                if (behaviour != null)
                {
                    behaviour.updateInterval = value;
                }
            }
        }

        public Status rootStatus
        {
            get
            {
                return !(behaviour != null) ? Status.Resting : behaviour.rootStatus;
            }
        }

        public Status Tick()
        {
            if (behaviour == null)
            {
                return Status.Resting;
            }
            return behaviour.Tick(this, blackboard);
        }
    }
}
