using NodeCanvas.Framework;
using ParadoxNotion.Design;
using UnityEngine;

namespace NodeCanvas.BehaviourTrees
{
    [Icon("Remap", false)]
    [Description("Remap the child node's status to another status. Used to either invert the child's return status or to always return a specific status.")]
    [Name("Remap")]
    [Category("Decorators")]
    public class Remapper : BTDecorator
    {
        public enum RemapStatus
        {
            Failure,
            Success
        }

        public RemapStatus successRemap = RemapStatus.Success;

        public RemapStatus failureRemap;

        protected override Status OnExecute(Component agent, IBlackboard blackboard)
        {
            if (decoratedConnection == null)
            {
                return Status.Resting;
            }
            status = decoratedConnection.Execute(agent, blackboard);
            switch (status)
            {
                case Status.Success:
                    return (Status)successRemap;
                case Status.Failure:
                    return (Status)failureRemap;
                default:
                    return status;
            }
        }
    }
}
