using NodeCanvas.Framework;
using UnityEngine;

namespace NodeCanvas.StateMachines
{
    [AddComponentMenu("NodeCanvas/FSM Owner")]
    public class FSMOwner : GraphOwner<FSM>
    {
        public string currentStateName
        {
            get
            {
                return !(behaviour != null) ? null : behaviour.currentStateName;
            }
        }

        public string previousStateName
        {
            get
            {
                return !(behaviour != null) ? null : behaviour.previousStateName;
            }
        }

        public FSMState TriggerState(string stateName)
        {
            if (behaviour != null)
            {
                return behaviour.TriggerState(stateName);
            }
            return null;
        }

        public string[] GetStateNames()
        {
            if (behaviour != null)
            {
                return behaviour.GetStateNames();
            }
            return null;
        }
    }
}
