using NodeCanvas.Framework;
using ParadoxNotion.Design;
using UnityEngine;

namespace NodeCanvas.Tasks.Actions
{
    [Description("Create up to 3 floats from a Vector and save them to blackboard")]
    [Category("✫ Blackboard")]
    public class DecomposeVector : ActionTask
    {
        public BBParameter<Vector3> targetVector;

        [BlackboardOnly]
        public BBParameter<float> x;

        [BlackboardOnly]
        public BBParameter<float> y;

        [BlackboardOnly]
        public BBParameter<float> z;

        protected override string info
        {
            get
            {
                return "Decompose Vector " + targetVector;
            }
        }

        protected override void OnExecute()
        {
            BBParameter<float> bBParameter = x;
            Vector3 value = targetVector.value;
            bBParameter.value = value.x;
            BBParameter<float> bBParameter2 = y;
            Vector3 value2 = targetVector.value;
            bBParameter2.value = value2.y;
            BBParameter<float> bBParameter3 = z;
            Vector3 value3 = targetVector.value;
            bBParameter3.value = value3.z;
            EndAction();
        }
    }
}
