using NodeCanvas.Framework;
using ParadoxNotion.Design;
using System.Collections.Generic;
using System.Linq;
using UnityEngine;

namespace NodeCanvas.Tasks.Actions
{
    [Description("Note that this is very slow")]
    [Category("GameObject")]
    public class FindObjectsOfType<T> : ActionTask where T : Component
    {
        [BlackboardOnly]
        public BBParameter<List<GameObject>> saveGameObjects;

        [BlackboardOnly]
        public BBParameter<List<T>> saveComponents;

        protected override void OnExecute()
        {
            T[] array = Object.FindObjectsOfType<T>();
            if (array != null && array.Length != 0)
            {
                saveGameObjects.value = array.Select(o => o.gameObject).ToList();
                saveComponents.value = array.ToList();
                EndAction(true);
            }
            else
            {
                EndAction(false);
            }
        }
    }
}
