using NodeCanvas.Framework;
using ParadoxNotion.Design;
using UnityEngine;
using UnityEngine.AI;

namespace NodeCanvas.Tasks.Actions
{
    [Description("Flees away from the target")]
    [Category("Movement")]
    public class Flee : ActionTask<NavMeshAgent>
    {
        [RequiredField]
        public BBParameter<GameObject> target;

        public BBParameter<float> speed = 4f;

        public BBParameter<float> fledDistance = 10f;

        public BBParameter<float> lookAheadDistance = 5f;

        protected override void OnExecute()
        {
            agent.speed = speed.value;
            if ((agent.transform.position - target.value.transform.position).magnitude >= fledDistance.value)
            {
                EndAction();
            }
            else
            {
                DoFlee();
            }
        }

        protected override void OnUpdate()
        {
            if (!agent.pathPending && (agent.transform.position - target.value.transform.position).magnitude >= fledDistance.value)
            {
                EndAction();
            }
            else
            {
                DoFlee();
            }
        }

        private void DoFlee()
        {
            Vector3 destination = agent.transform.position + (agent.transform.position - target.value.transform.position).normalized * lookAheadDistance.value;
            agent.SetDestination(destination);
        }

        protected override void OnPause()
        {
            OnStop();
        }

        protected override void OnStop()
        {
            if (agent.gameObject.activeSelf)
            {
                agent.ResetPath();
            }
        }
    }
}
