using NodeCanvas.Framework;
using ParadoxNotion.Design;
using System.Collections;

namespace NodeCanvas.Tasks.Actions
{
    [Name("Control Graph Owner")]
    [Description("Start, Resume, Pause, Stop a GraphOwner's behaviour")]
    [Category("✫ Utility")]
    public class GraphOwnerControl : ActionTask<GraphOwner>
    {
        public enum Control
        {
            StartBehaviour,
            StopBehaviour,
            PauseBehaviour
        }

        public Control control;

        public bool waitActionFinish = true;

        protected override string info
        {
            get
            {
                return agentInfo + "." + control.ToString();
            }
        }

        protected override void OnExecute()
        {
            StartCoroutine(Do());
        }

        private IEnumerator Do()
        {
            yield return null;
            if (control == Control.StartBehaviour)
            {
                if (waitActionFinish)
                {
                    agent.StartBehaviour(delegate (bool s)
                    {
                        EndAction(s);
                    });
                }
                else
                {
                    EndAction();
                    agent.StartBehaviour();
                }
            }
            if (control == Control.StopBehaviour)
            {
                EndAction();
                agent.StopBehaviour();
            }
            if (control == Control.PauseBehaviour)
            {
                EndAction();
                agent.PauseBehaviour();
            }
        }

        protected override void OnStop()
        {
            if (waitActionFinish && control == Control.StartBehaviour)
            {
                agent.StopBehaviour();
            }
        }
    }
}
