using NodeCanvas.Framework;
using ParadoxNotion.Design;
using UnityEngine;

namespace NodeCanvas.Tasks.Actions
{
    [Description("Move & turn the agent based on input values provided ranging from -1 to 1. Per frame and in delta time")]
    [Category("Movement")]
    public class InputMove : ActionTask<Transform>
    {
        [BlackboardOnly]
        public BBParameter<float> strafe;

        [BlackboardOnly]
        public BBParameter<float> turn;

        [BlackboardOnly]
        public BBParameter<float> forward;

        [BlackboardOnly]
        public BBParameter<float> up;

        public BBParameter<float> moveSpeed = 1f;

        public BBParameter<float> rotationSpeed = 1f;

        public bool repeat;

        protected override void OnExecute()
        {
            Move();
        }

        protected override void OnUpdate()
        {
            Move();
        }

        private void Move()
        {
            Quaternion b = agent.rotation * Quaternion.Euler(Vector3.up * turn.value * 10f);
            agent.rotation = Quaternion.Slerp(agent.rotation, b, rotationSpeed.value * Time.deltaTime);
            Vector3 b2 = agent.forward * forward.value * moveSpeed.value * Time.deltaTime;
            Vector3 a = agent.right * strafe.value * moveSpeed.value * Time.deltaTime;
            Vector3 b3 = agent.up * up.value * moveSpeed.value * Time.deltaTime;
            agent.position += a + b2 + b3;
            if (!repeat)
            {
                EndAction();
            }
        }
    }
}
