using NodeCanvas.Framework;
using ParadoxNotion.Design;
using UnityEngine;

namespace NodeCanvas.Tasks.Actions
{
    [Category("GameObject")]
    public class LookAt : ActionTask<Transform>
    {
        [RequiredField]
        public BBParameter<GameObject> lookTarget;

        public bool repeat;

        protected override string info
        {
            get
            {
                return "LookAt " + lookTarget;
            }
        }

        protected override void OnExecute()
        {
            DoLook();
        }

        protected override void OnUpdate()
        {
            DoLook();
        }

        private void DoLook()
        {
            Vector3 position = lookTarget.value.transform.position;
            Vector3 position2 = agent.position;
            position.y = position2.y;
            agent.LookAt(position);
            if (!repeat)
            {
                EndAction(true);
            }
        }
    }
}
