using NodeCanvas.DialogueTrees;
using NodeCanvas.Framework;
using ParadoxNotion.Design;

namespace NodeCanvas.Tasks.Actions
{
    [Icon("Dialogue", false)]
    [Description("You can use a variable inline with the text by using brackets likeso: [myVarName] or [Global/myVarName].\nThe bracket will be replaced with the variable value ToString")]
    [Category("Dialogue")]
    [AgentType(typeof(IDialogueActor))]
    public class Say : ActionTask
    {
        public Statement statement = new Statement("This is a dialogue text...");

        protected override string info
        {
            get
            {
                return string.Format("<i>' {0} '</i>", statement.text.Length <= 30 ? statement.text : statement.text.Substring(0, 30) + "...");
            }
        }

        protected override void OnExecute()
        {
            Statement statement = this.statement.BlackboardReplace(blackboard);
            DialogueTree.RequestSubtitles(new SubtitlesRequestInfo((IDialogueActor)agent, statement, EndAction));
        }
    }
}
