using NodeCanvas.DialogueTrees;
using NodeCanvas.Framework;
using ParadoxNotion.Design;
using System.Collections.Generic;
using UnityEngine;

namespace NodeCanvas.Tasks.Actions
{
    [Description("A random statement will be chosen each time for the actor to say")]
    [AgentType(typeof(IDialogueActor))]
    [Category("Dialogue")]
    [Icon("Dialogue", false)]
    public class SayRandom : ActionTask
    {
        public List<Statement> statements = new List<Statement>();

        protected override void OnExecute()
        {
            int index = Random.Range(0, statements.Count);
            Statement statement = statements[index];
            Statement statement2 = statement.BlackboardReplace(blackboard);
            SubtitlesRequestInfo info = new SubtitlesRequestInfo((IDialogueActor)agent, statement2, EndAction);
            DialogueTree.RequestSubtitles(info);
        }
    }
}
