using NodeCanvas.Framework;
using ParadoxNotion.Design;
using UnityEngine;

namespace NodeCanvas.Tasks.Actions
{
    [Category("GameObject")]
    [Name("Set Visibility")]
    public class SetObjectActive : ActionTask<Transform>
    {
        public enum SetActiveMode
        {
            Deactivate,
            Activate,
            Toggle
        }

        public SetActiveMode setTo = SetActiveMode.Toggle;

        protected override string info
        {
            get
            {
                return string.Format("{0} {1}", setTo, agentInfo);
            }
        }

        protected override void OnExecute()
        {
            bool active = setTo != SetActiveMode.Toggle ? setTo == SetActiveMode.Activate : !agent.gameObject.activeSelf;
            agent.gameObject.SetActive(active);
            EndAction();
        }
    }
}
