using NodeCanvas.Framework;
using ParadoxNotion.Design;
using System.Collections;
using UnityEngine;

namespace NodeCanvas.Tasks.Actions
{
    [Category("✫ Blackboard/Lists")]
    public class ShuffleList : ActionTask
    {
        [BlackboardOnly]
        [RequiredField]
        public BBParameter<IList> targetList;

        protected override void OnExecute()
        {
            IList value = targetList.value;
            for (int num = value.Count - 1; num > 0; num--)
            {
                int index = (int)Mathf.Floor(Random.value * (num + 1));
                object value2 = value[num];
                value[num] = value[index];
                value[index] = value2;
            }
            EndAction();
        }
    }
}
