using NodeCanvas.DialogueTrees;
using NodeCanvas.Framework;
using ParadoxNotion.Design;

namespace NodeCanvas.Tasks.Actions
{
    [Icon("Dialogue", false)]
    [Description("Starts the Dialogue Tree assigned on a Dialogue Tree Controller object with specified agent used for 'Instigator'.")]
    [AgentType(typeof(IDialogueActor))]
    [Category("Dialogue")]
    public class StartDialogueTree : ActionTask
    {
        [RequiredField]
        public BBParameter<DialogueTreeController> dialogueTreeController;

        public bool waitActionFinish = true;

        protected override string info
        {
            get
            {
                return string.Format("Start Dialogue {0}", dialogueTreeController);
            }
        }

        protected override void OnExecute()
        {
            IDialogueActor instigator = (IDialogueActor)agent;
            if (waitActionFinish)
            {
                dialogueTreeController.value.StartDialogue(instigator, delegate (bool success)
                {
                    EndAction(success);
                });
                return;
            }
            dialogueTreeController.value.StartDialogue(instigator);
            EndAction();
        }
    }
}
