using NodeCanvas.Framework;
using ParadoxNotion.Design;
using System.Collections.Generic;

namespace NodeCanvas.Tasks.Conditions
{
    [Description("Check if an element is contained in the target list")]
    [Category("✫ Blackboard/Lists")]
    public class ListContainsElement<T> : ConditionTask
    {
        [BlackboardOnly]
        [RequiredField]
        public BBParameter<List<T>> targetList;

        public BBParameter<T> checkElement;

        protected override string info
        {
            get
            {
                return targetList + " contains " + checkElement;
            }
        }

        protected override bool OnCheck()
        {
            return targetList.value.Contains(checkElement.value);
        }
    }
}
