using System.Collections;
using UnityEngine;

public class ScreenShotCamera : MonoBehaviour
{
    public RenderTexture renderTexture
    {
        get;
        private set;
    }

    private IEnumerator Start()
    {
        enabled = false;
        do
        {
            renderTexture = new RenderTexture(Screen.width, Screen.height, 24, RenderTextureFormat.ARGB32, RenderTextureReadWrite.Default);
            yield return null;
        }
        while (renderTexture == null);
        enabled = true;
    }

    private void OnRenderImage(RenderTexture src, RenderTexture dst)
    {
        Graphics.Blit(src, renderTexture);
        Graphics.Blit(src, dst);
    }

    private void OnDestroy()
    {
        if ((bool)renderTexture)
        {
            renderTexture.Release();
            renderTexture = null;
        }
    }
}
