using IllusionUtility.SetUtility;
using Manager;
using System;
using System.Collections.Generic;
using System.IO;
using UnityEngine;

public class ShapeBodyInfoFemale : ShapeInfoBase
{
    public enum DstName
    {
        cf_n_height,
        cf_s_hand_L,
        cf_s_hand_R,
        cf_s_head,
        cf_s_neck,
        cf_s_spine03,
        cf_s_shoulder02_L,
        cf_s_shoulder02_R,
        cf_s_arm01_L,
        cf_s_arm01_R,
        cf_s_arm02_L,
        cf_s_arm02_R,
        cf_s_arm03_L,
        cf_s_arm03_R,
        cf_s_forearm01_L,
        cf_s_forearm01_R,
        cf_s_forearm02_L,
        cf_s_forearm02_R,
        cf_s_wrist_L,
        cf_s_wrist_R,
        cf_s_spine02,
        cf_s_spine01,
        cf_s_waist01,
        cf_s_waist02,
        cf_s_siri_L,
        cf_s_siri_R,
        cf_s_thigh01_L,
        cf_s_thigh01_R,
        cf_s_thigh02_L,
        cf_s_thigh02_R,
        cf_s_thigh03_L,
        cf_s_thigh03_R,
        cf_s_leg01_L,
        cf_s_leg01_R,
        cf_s_leg02_L,
        cf_s_leg02_R,
        cf_s_leg03_L,
        cf_s_leg03_R,
        cf_d_kokan,
        cf_s_bust00_L,
        cf_d_bust01_L,
        cf_d_bust02_L,
        cf_d_bust03_L,
        cf_s_bust01_L,
        cf_s_bust02_L,
        cf_s_bust03_L,
        cf_hit_bust02_L,
        cf_d_bnip01_L,
        cf_s_bnip01_L,
        cf_s_bnip025_L,
        cf_s_bnip015_L,
        cf_s_bnip02_L,
        cf_s_bnipacc_L,
        cf_s_bust00_R,
        cf_d_bust01_R,
        cf_d_bust02_R,
        cf_d_bust03_R,
        cf_s_bust01_R,
        cf_s_bust02_R,
        cf_s_bust03_R,
        cf_hit_bust02_R,
        cf_d_bnip01_R,
        cf_s_bnip01_R,
        cf_s_bnip025_R,
        cf_s_bnip015_R,
        cf_s_bnip02_R,
        cf_s_bnipacc_R,
        cf_hit_siri_L,
        cf_hit_siri_R,
        cf_hit_waist_L,
        cf_hit_berry,
        cf_hit_spine02_L,
        cf_hit_shoulder_L,
        cf_hit_shoulder_R,
        cf_hit_arm_L,
        cf_hit_arm_R,
        cf_hit_spine01,
        cf_d_sk_top,
        cf_d_sk_00_00,
        cf_d_sk_01_00,
        cf_d_sk_02_00,
        cf_d_sk_03_00,
        cf_d_sk_04_00,
        cf_d_sk_05_00,
        cf_d_sk_06_00,
        cf_d_sk_07_00
    }

    public enum SrcName
    {
        cf_a_height,
        cf_a_height_aid,
        cf_a_head,
        cf_a_neck,
        cf_a_spine03,
        cf_a_shoulder,
        cf_a_shoulder_L_aid03,
        cf_a_shoulder_R_aid03,
        cf_a_arm_L_aid03,
        cf_a_arm_R_aid03,
        cf_a_arm02,
        cf_a_arm03_blend01,
        cf_a_arm03_blend02,
        cf_a_farm01,
        cf_a_farm02_blend01,
        cf_a_farm02_blend03,
        cf_a_farm03,
        cf_a_spine02,
        cf_a_spine02_aid_berry,
        cf_a_spine01,
        cf_a_berry,
        cf_a_waist01,
        cf_a_waist02,
        cf_a_siri,
        cf_a_thigh01_L,
        cf_a_thigh01_L_aid,
        cf_a_thigh01_R,
        cf_a_thigh01_R_aid,
        cf_a_thigh02_L_blend01,
        cf_a_thigh02_L_blend03,
        cf_a_thigh02_R_blend01,
        cf_a_thigh02_R_blend03,
        cf_a_thigh03_L,
        cf_a_thigh03_R,
        cf_a_leg01_L,
        cf_a_leg01_R,
        cf_a_leg02_L,
        cf_a_leg02_R,
        cf_a_leg03,
        cf_a_dan,
        cf_a_bust_ty,
        cf_a_bust00_aid03_sz,
        cf_a_bust00_aid02_sz,
        cf_a_bust_L_ry,
        cf_a_bust_rx,
        cf_a_bust01_size,
        cf_a_bust_L_tx,
        cf_a_bust02_size,
        cf_a_bust_tz,
        cf_a_bust03_size,
        cf_a_bust01_shape1,
        cf_a_bust02_shape1,
        cf_a_bust03_shape1,
        cf_a_hit_bust_shape1,
        cf_a_hit_bust_shape2,
        cf_a_bnip01,
        cf_a_bnip01_size,
        cf_a_d_bnip01_size,
        cf_a_bnip02_size,
        cf_a_bnip015_size,
        cf_a_bnip02,
        cf_a_bnipacc_stand,
        cf_a_bnipacc_size,
        cf_a_bust_R_ry,
        cf_a_bust_R_tx,
        cf_a_hit_siri_shape1,
        cf_a_hit_siri_shape2,
        cf_a_hit_siri_shape3,
        cf_a_hit_siri_shape4,
        cf_a_hit_siri_shape5,
        cf_a_hit_siri_shape6,
        cf_a_hit_waist_shape1,
        cf_a_hit_waist_shape2,
        cf_a_hit_waist_shape3,
        cf_a_hit_spinety_shape,
        cf_a_hit_waist_shape4,
        cf_a_hit_waist_shape5,
        cf_a_hit_berry_shape,
        cf_a_hit_berry_shape2,
        cf_a_hit_berry_shape3,
        cf_a_hit_spine02_shape1,
        cf_a_hit_spine02_shape2,
        cf_a_hit_spine02_shape3,
        cf_a_hit_shoulder_shape1,
        cf_a_hit_shoulder_shape2,
        cf_a_hit_shoulder_shape3,
        cf_a_hit_arm_shape2,
        cf_a_hit_arm_shape3,
        cf_a_hit_arm_shape4,
        cf_a_hit_spine01_shape1,
        cf_a_hit_spine01_shape2,
        cf_a_sk_00_00,
        cf_a_sk_00_01,
        cf_a_sk_berry,
        cf_a_sk_thigh01_sz,
        cf_a_sk_01_00,
        cf_a_sk_01_01,
        cf_a_sk_thigh01_sx,
        cf_a_sk_02_00,
        cf_a_sk_02_01,
        cf_a_sk_siri,
        cf_a_sk_03_00,
        cf_a_sk_03_01,
        cf_a_sk_04_00,
        cf_a_sk_04_01,
        cf_a_sk_05_00,
        cf_a_sk_05_01,
        cf_a_sk_06_00,
        cf_a_sk_06_01,
        cf_a_sk_07_00,
        cf_a_sk_07_01
    }

    public enum CorrectKeyName
    {
        cf_s_waist02,
        cf_s_neck,
        cf_s_head,
        cf_s_spine01,
        cf_s_spine02,
        cf_s_spine03,
        cf_s_thigh01_L,
        cf_s_thigh01_R,
        cf_s_thigh02_L,
        cf_s_thigh02_R,
        cf_s_thigh03_L,
        cf_s_thigh03_R,
        cf_s_leg01_L,
        cf_s_leg01_R,
        cf_s_shoulder02_L,
        cf_s_shoulder02_R,
        cf_s_arm01_L,
        cf_s_arm01_R,
        cf_s_arm02_L,
        cf_s_arm02_R,
        cf_s_arm03_L,
        cf_s_arm03_R,
        cf_s_forearm01_L,
        cf_s_forearm01_R,
        cf_s_forearm02_L,
        cf_s_forearm02_R,
        cf_s_wrist_L,
        cf_s_wrist_R,
        cf_s_siri_L,
        cf_s_siri_R,
        cf_d_shoulder_L,
        cf_d_shoulder_R
    }

    public const int UPDATE_MASK_BUST_L = 1;

    public const int UPDATE_MASK_BUST_R = 2;

    public const int UPDATE_MASK_ETC = 4;

    public const int UPDATE_MASK_ALL = 7;

    public int updateMask = 7;

    public BoneInfo[] correctValue;

    public Transform[] fixCorrectBone = new Transform[2];

    public float correctHeadSize = 1f;

    public float correctNeckSize = 1f;

    public override void InitShapeInfo(string manifest, string assetBundleAnmKey, string assetBundleCategory, string anmKeyInfoName, string cateInfoName, Transform trfObj, int _sex)
    {
        sex = _sex;
        if (sex == 0)
        {
            correctHeadSize = 0.91f;
            correctNeckSize = 0.91f;
        }
        Dictionary<string, int> dictionary = new Dictionary<string, int>();
        DstName[] array = (DstName[])Enum.GetValues(typeof(DstName));
        DstName[] array2 = array;
        for (int i = 0; i < array2.Length; i++)
        {
            DstName value = array2[i];
            dictionary[value.ToString()] = (int)value;
        }
        Dictionary<string, int> dictionary2 = new Dictionary<string, int>();
        SrcName[] array3 = (SrcName[])Enum.GetValues(typeof(SrcName));
        SrcName[] array4 = array3;
        for (int j = 0; j < array4.Length; j++)
        {
            SrcName value2 = array4[j];
            dictionary2[value2.ToString()] = (int)value2;
        }
        FindAssist findAssist = new FindAssist();
        findAssist.Initialize(trfObj);
        GameObject objectFromName = findAssist.GetObjectFromName("cf_d_shoulder_L");
        if ((bool)objectFromName)
        {
            fixCorrectBone[0] = objectFromName.transform;
        }
        objectFromName = findAssist.GetObjectFromName("cf_d_shoulder_R");
        if ((bool)objectFromName)
        {
            fixCorrectBone[1] = objectFromName.transform;
        }
        InitShapeInfoBase(manifest, assetBundleAnmKey, assetBundleCategory, anmKeyInfoName, cateInfoName, trfObj, dictionary, dictionary2, Singleton<Character>.Instance.AddLoadAssetBundle);
        int num = Enum.GetNames(typeof(CorrectKeyName)).Length;
        correctValue = new BoneInfo[num];
        for (int k = 0; k < num; k++)
        {
            correctValue[k] = new BoneInfo();
            correctValue[k].vctScl = Vector3.zero;
        }
        LoadCorrectInfo();
        InitEnd = true;
    }

    public void SaveCorrectInfo()
    {
        string path = Application.dataPath + "/Illusion/assetbundle/chara/list/shapecorrect/shapecorrect.bytes";
        using (FileStream output = new FileStream(path, FileMode.Create, FileAccess.Write))
        {
            using (BinaryWriter binaryWriter = new BinaryWriter(output))
            {
                int num = correctValue.Length;
                binaryWriter.Write(num);
                for (int i = 0; i < num; i++)
                {
                    binaryWriter.Write(correctValue[i].vctPos.x);
                    binaryWriter.Write(correctValue[i].vctPos.y);
                    binaryWriter.Write(correctValue[i].vctPos.z);
                    binaryWriter.Write(correctValue[i].vctRot.x);
                    binaryWriter.Write(correctValue[i].vctRot.y);
                    binaryWriter.Write(correctValue[i].vctRot.z);
                    binaryWriter.Write(correctValue[i].vctScl.x);
                    binaryWriter.Write(correctValue[i].vctScl.y);
                    binaryWriter.Write(correctValue[i].vctScl.z);
                }
            }
        }
    }

    public void LoadCorrectInfo()
    {
        string assetBundleName = "list/shapecorrect/shapecorrect.unity3d";
        string assetName = "shapecorrect";
        TextAsset textAsset = CommonLib.LoadAsset<TextAsset>(assetBundleName, assetName, false, string.Empty);
        if (null != textAsset)
        {
            using (MemoryStream memoryStream = new MemoryStream())
            {
                memoryStream.Write(textAsset.bytes, 0, textAsset.bytes.Length);
                memoryStream.Seek(0L, SeekOrigin.Begin);
                using (BinaryReader binaryReader = new BinaryReader(memoryStream))
                {
                    int num = binaryReader.ReadInt32();
                    for (int i = 0; i < num; i++)
                    {
                        correctValue[i].vctPos.x = binaryReader.ReadSingle();
                        correctValue[i].vctPos.y = binaryReader.ReadSingle();
                        correctValue[i].vctPos.z = binaryReader.ReadSingle();
                        correctValue[i].vctRot.x = binaryReader.ReadSingle();
                        correctValue[i].vctRot.y = binaryReader.ReadSingle();
                        correctValue[i].vctRot.z = binaryReader.ReadSingle();
                        correctValue[i].vctScl.x = binaryReader.ReadSingle();
                        correctValue[i].vctScl.y = binaryReader.ReadSingle();
                        correctValue[i].vctScl.z = binaryReader.ReadSingle();
                    }
                }
            }
        }
        AssetBundleManager.UnloadAssetBundle(assetBundleName, true);
    }

    public override void ForceUpdate()
    {
        Update();
    }

    public override void Update()
    {
        if (!InitEnd || dictSrc.Count == 0)
        {
            return;
        }
        BoneInfo value;
        if ((updateMask & 4) != 0)
        {
            if (dictDst.TryGetValue(0, out value))
            {
                value.trfBone.SetLocalScale(dictSrc[0].vctScl.x, dictSrc[0].vctScl.y, dictSrc[0].vctScl.z);
            }
            if (dictDst.TryGetValue(1, out value))
            {
                value.trfBone.SetLocalScale(dictSrc[1].vctScl.x, dictSrc[1].vctScl.y, dictSrc[1].vctScl.z);
            }
            if (dictDst.TryGetValue(2, out value))
            {
                value.trfBone.SetLocalScale(dictSrc[1].vctScl.x, dictSrc[1].vctScl.y, dictSrc[1].vctScl.z);
            }
            if (dictDst.TryGetValue(3, out value))
            {
                float num = typeBone != 0 ? correctValue[2].vctPos.y : 0f;
                float num2 = typeBone != 0 ? correctValue[2].vctScl.x : 0f;
                float num3 = typeBone != 0 ? correctValue[2].vctScl.y : 0f;
                float num4 = typeBone != 0 ? correctValue[2].vctScl.z : 0f;
                value.trfBone.SetLocalPositionY(dictSrc[2].vctPos.y + num);
                value.trfBone.SetLocalScale(dictSrc[2].vctScl.x * dictSrc[1].vctScl.x * correctHeadSize + num2, dictSrc[2].vctScl.y * dictSrc[1].vctScl.y * correctHeadSize + num3, dictSrc[2].vctScl.z * dictSrc[1].vctScl.z * correctHeadSize + num4);
            }
            if (dictDst.TryGetValue(4, out value))
            {
                float y = typeBone != 0 ? correctValue[1].vctPos.y : 0f;
                float x = typeBone != 0 ? correctValue[1].vctRot.x : 0f;
                float num5 = typeBone != 0 ? correctValue[1].vctScl.x : 0f;
                float num6 = typeBone != 0 ? correctValue[1].vctScl.z : 0f;
                value.trfBone.SetLocalPositionY(y);
                value.trfBone.SetLocalPositionZ(dictSrc[3].vctPos.z);
                value.trfBone.SetLocalRotation(x, 0f, 0f);
                value.trfBone.SetLocalScale(dictSrc[3].vctScl.x * dictSrc[1].vctScl.x * correctNeckSize + num5, 1f, dictSrc[3].vctScl.z * dictSrc[1].vctScl.z * correctNeckSize + num6);
            }
            if (dictDst.TryGetValue(5, out value))
            {
                float num7 = typeBone != 0 ? correctValue[5].vctPos.z : 0f;
                float x2 = typeBone != 0 ? correctValue[5].vctRot.x : 0f;
                float num8 = typeBone != 0 ? correctValue[5].vctScl.x : 0f;
                float num9 = typeBone != 0 ? correctValue[5].vctScl.z : 0f;
                value.trfBone.SetLocalPositionZ(dictSrc[4].vctPos.z + num7);
                value.trfBone.SetLocalRotation(x2, 0f, 0f);
                value.trfBone.SetLocalScale(dictSrc[4].vctScl.x * dictSrc[1].vctScl.x + num8, 1f, dictSrc[4].vctScl.z * dictSrc[1].vctScl.z + num9);
            }
            if (dictDst.TryGetValue(6, out value))
            {
                float num10 = typeBone != 0 ? correctValue[14].vctPos.x : 0f;
                float num11 = typeBone != 0 ? correctValue[14].vctPos.y : 0f;
                float z = typeBone != 0 ? correctValue[14].vctPos.z : 0f;
                float num12 = typeBone != 0 ? correctValue[14].vctScl.y : 0f;
                float num13 = typeBone != 0 ? correctValue[14].vctScl.z : 0f;
                value.trfBone.SetLocalPositionX(dictSrc[6].vctPos.x + dictSrc[5].vctPos.x + num10);
                value.trfBone.SetLocalPositionY(dictSrc[5].vctPos.y + num11);
                value.trfBone.SetLocalPositionZ(z);
                value.trfBone.SetLocalScale(dictSrc[5].vctScl.x, dictSrc[5].vctScl.y * dictSrc[1].vctScl.y + num12, dictSrc[5].vctScl.z * dictSrc[6].vctScl.z * dictSrc[1].vctScl.z + num13);
            }
            if (dictDst.TryGetValue(7, out value))
            {
                float num14 = typeBone != 0 ? correctValue[15].vctPos.x : 0f;
                float num15 = typeBone != 0 ? correctValue[15].vctPos.y : 0f;
                float z2 = typeBone != 0 ? correctValue[15].vctPos.z : 0f;
                float num16 = typeBone != 0 ? correctValue[15].vctScl.y : 0f;
                float num17 = typeBone != 0 ? correctValue[15].vctScl.z : 0f;
                value.trfBone.SetLocalPositionX(dictSrc[7].vctPos.x - dictSrc[5].vctPos.x + num14);
                value.trfBone.SetLocalPositionY(dictSrc[5].vctPos.y + num15);
                value.trfBone.SetLocalPositionZ(z2);
                value.trfBone.SetLocalScale(dictSrc[5].vctScl.x, dictSrc[5].vctScl.y * dictSrc[1].vctScl.y + num16, dictSrc[5].vctScl.z * dictSrc[7].vctScl.z * dictSrc[1].vctScl.z + num17);
            }
            if (dictDst.TryGetValue(8, out value))
            {
                float num18 = typeBone != 0 ? correctValue[16].vctPos.y : 0f;
                float num19 = typeBone != 0 ? correctValue[16].vctScl.x : 0f;
                float num20 = typeBone != 0 ? correctValue[16].vctScl.y : 0f;
                float num21 = typeBone != 0 ? correctValue[16].vctScl.z : 0f;
                value.trfBone.SetLocalPositionX(dictSrc[8].vctPos.x);
                value.trfBone.SetLocalPositionY(dictSrc[5].vctPos.y + num18);
                value.trfBone.SetLocalScale(1f + num19, dictSrc[5].vctScl.y * dictSrc[1].vctScl.y + num20, dictSrc[5].vctScl.z * dictSrc[8].vctScl.z * dictSrc[1].vctScl.z + num21);
            }
            if (dictDst.TryGetValue(9, out value))
            {
                float num22 = typeBone != 0 ? correctValue[17].vctPos.y : 0f;
                float num23 = typeBone != 0 ? correctValue[17].vctScl.x : 0f;
                float num24 = typeBone != 0 ? correctValue[17].vctScl.y : 0f;
                float num25 = typeBone != 0 ? correctValue[17].vctScl.z : 0f;
                value.trfBone.SetLocalPositionX(dictSrc[9].vctPos.x);
                value.trfBone.SetLocalPositionY(dictSrc[5].vctPos.y + num22);
                value.trfBone.SetLocalScale(1f + num23, dictSrc[5].vctScl.y * dictSrc[1].vctScl.y + num24, dictSrc[5].vctScl.z * dictSrc[9].vctScl.z * dictSrc[1].vctScl.z + num25);
            }
            if (dictDst.TryGetValue(10, out value))
            {
                float num26 = typeBone != 0 ? correctValue[18].vctPos.y : 0f;
                float num27 = typeBone != 0 ? correctValue[18].vctPos.z : 0f;
                float num28 = typeBone != 0 ? correctValue[18].vctScl.y : 0f;
                float num29 = typeBone != 0 ? correctValue[18].vctScl.z : 0f;
                value.trfBone.SetLocalPositionY(dictSrc[10].vctPos.y + num26);
                value.trfBone.SetLocalPositionZ(dictSrc[10].vctPos.z + num27);
                value.trfBone.SetLocalScale(1f, dictSrc[10].vctScl.y * dictSrc[1].vctScl.y + num28, dictSrc[10].vctScl.z * dictSrc[1].vctScl.z + num29);
            }
            if (dictDst.TryGetValue(11, out value))
            {
                float num30 = typeBone != 0 ? correctValue[19].vctPos.y : 0f;
                float num31 = typeBone != 0 ? correctValue[19].vctPos.z : 0f;
                float num32 = typeBone != 0 ? correctValue[19].vctScl.y : 0f;
                float num33 = typeBone != 0 ? correctValue[19].vctScl.z : 0f;
                value.trfBone.SetLocalPositionY(dictSrc[10].vctPos.y + num30);
                value.trfBone.SetLocalPositionZ(dictSrc[10].vctPos.z + num31);
                value.trfBone.SetLocalScale(1f, dictSrc[10].vctScl.y * dictSrc[1].vctScl.y + num32, dictSrc[10].vctScl.z * dictSrc[1].vctScl.z + num33);
            }
            if (dictDst.TryGetValue(12, out value))
            {
                float y2 = typeBone != 0 ? correctValue[20].vctPos.y : 0f;
                float num34 = typeBone != 0 ? correctValue[20].vctScl.y : 0f;
                float num35 = typeBone != 0 ? correctValue[20].vctScl.z : 0f;
                value.trfBone.SetLocalPositionY(y2);
                value.trfBone.SetLocalScale(1f, dictSrc[11].vctScl.y * dictSrc[12].vctScl.y * dictSrc[1].vctScl.y + num34, dictSrc[11].vctScl.z * dictSrc[12].vctScl.z * dictSrc[1].vctScl.z + num35);
            }
            if (dictDst.TryGetValue(13, out value))
            {
                float y3 = typeBone != 0 ? correctValue[21].vctPos.y : 0f;
                float num36 = typeBone != 0 ? correctValue[21].vctScl.y : 0f;
                float num37 = typeBone != 0 ? correctValue[21].vctScl.z : 0f;
                value.trfBone.SetLocalPositionY(y3);
                value.trfBone.SetLocalScale(1f, dictSrc[11].vctScl.y * dictSrc[12].vctScl.y * dictSrc[1].vctScl.y + num36, dictSrc[11].vctScl.z * dictSrc[12].vctScl.z * dictSrc[1].vctScl.z + num37);
            }
            if (dictDst.TryGetValue(14, out value))
            {
                float y4 = typeBone != 0 ? correctValue[22].vctPos.y : 0f;
                value.trfBone.SetLocalPositionY(y4);
                value.trfBone.SetLocalScale(1f, dictSrc[13].vctScl.y * dictSrc[1].vctScl.y, dictSrc[13].vctScl.z * dictSrc[1].vctScl.z);
            }
            if (dictDst.TryGetValue(15, out value))
            {
                float y5 = typeBone != 0 ? correctValue[23].vctPos.y : 0f;
                value.trfBone.SetLocalPositionY(y5);
                value.trfBone.SetLocalScale(1f, dictSrc[13].vctScl.y * dictSrc[1].vctScl.y, dictSrc[13].vctScl.z * dictSrc[1].vctScl.z);
            }
            if (dictDst.TryGetValue(16, out value))
            {
                float y6 = typeBone != 0 ? correctValue[24].vctRot.y : 0f;
                float z3 = typeBone != 0 ? correctValue[24].vctRot.z : 0f;
                float num38 = typeBone != 0 ? correctValue[24].vctScl.y : 0f;
                float num39 = typeBone != 0 ? correctValue[24].vctScl.z : 0f;
                value.trfBone.SetLocalRotation(0f, y6, z3);
                value.trfBone.SetLocalScale(1f, dictSrc[14].vctScl.y * dictSrc[15].vctScl.y * dictSrc[1].vctScl.y + num38, dictSrc[14].vctScl.z * dictSrc[15].vctScl.z * dictSrc[1].vctScl.z + num39);
            }
            if (dictDst.TryGetValue(17, out value))
            {
                float y7 = typeBone != 0 ? correctValue[25].vctRot.y : 0f;
                float z4 = typeBone != 0 ? correctValue[25].vctRot.z : 0f;
                float num40 = typeBone != 0 ? correctValue[25].vctScl.y : 0f;
                float num41 = typeBone != 0 ? correctValue[25].vctScl.z : 0f;
                value.trfBone.SetLocalRotation(0f, y7, z4);
                value.trfBone.SetLocalScale(1f, dictSrc[14].vctScl.y * dictSrc[15].vctScl.y * dictSrc[1].vctScl.y + num40, dictSrc[14].vctScl.z * dictSrc[15].vctScl.z * dictSrc[1].vctScl.z + num41);
            }
            if (dictDst.TryGetValue(18, out value))
            {
                float num42 = typeBone != 0 ? correctValue[26].vctScl.x : 0f;
                float num43 = typeBone != 0 ? correctValue[26].vctScl.y : 0f;
                value.trfBone.SetLocalScale(1f + num42, dictSrc[16].vctScl.y * dictSrc[1].vctScl.y + num43, dictSrc[16].vctScl.z * dictSrc[1].vctScl.z);
            }
            if (dictDst.TryGetValue(19, out value))
            {
                float num44 = typeBone != 0 ? correctValue[27].vctScl.x : 0f;
                float num45 = typeBone != 0 ? correctValue[27].vctScl.y : 0f;
                value.trfBone.SetLocalScale(1f + num44, dictSrc[16].vctScl.y * dictSrc[1].vctScl.y + num45, dictSrc[16].vctScl.z * dictSrc[1].vctScl.z);
            }
            if (dictDst.TryGetValue(20, out value))
            {
                float num46 = typeBone != 0 ? correctValue[4].vctPos.z : 0f;
                float num47 = typeBone != 0 ? correctValue[4].vctScl.x : 0f;
                float num48 = typeBone != 0 ? correctValue[4].vctScl.z : 0f;
                value.trfBone.SetLocalPositionZ(dictSrc[17].vctPos.z + dictSrc[18].vctPos.z + num46);
                value.trfBone.SetLocalScale(dictSrc[17].vctScl.x * dictSrc[1].vctScl.x + num47, 1f, dictSrc[17].vctScl.z * dictSrc[1].vctScl.z * dictSrc[18].vctScl.z + num48);
            }
            if (dictDst.TryGetValue(21, out value))
            {
                float num49 = typeBone != 0 ? correctValue[3].vctPos.z : 0f;
                float num50 = typeBone != 0 ? correctValue[3].vctScl.x : 0f;
                float num51 = typeBone != 0 ? correctValue[3].vctScl.z : 0f;
                value.trfBone.SetLocalPositionY(dictSrc[19].vctPos.y + dictSrc[20].vctPos.y);
                value.trfBone.SetLocalPositionZ(dictSrc[19].vctPos.z + dictSrc[20].vctPos.z + num49);
                value.trfBone.SetLocalRotation(dictSrc[20].vctRot.x, 0f, 0f);
                value.trfBone.SetLocalScale(dictSrc[19].vctScl.x * dictSrc[1].vctScl.x * dictSrc[20].vctScl.x + num50, dictSrc[20].vctScl.y, dictSrc[19].vctScl.z * dictSrc[1].vctScl.z * dictSrc[20].vctScl.z + num51);
            }
            if (dictDst.TryGetValue(22, out value))
            {
                value.trfBone.SetLocalPositionY(dictSrc[20].vctPos.y);
                value.trfBone.SetLocalPositionZ(dictSrc[21].vctPos.z + dictSrc[20].vctPos.z);
                value.trfBone.SetLocalRotation(dictSrc[20].vctRot.x, 0f, 0f);
                value.trfBone.SetLocalScale(dictSrc[21].vctScl.x * dictSrc[1].vctScl.x * dictSrc[20].vctScl.x, dictSrc[20].vctScl.y, dictSrc[21].vctScl.z * dictSrc[1].vctScl.z * dictSrc[20].vctScl.z);
            }
            if (dictDst.TryGetValue(23, out value))
            {
                float num52 = typeBone != 0 ? correctValue[0].vctScl.x : 0f;
                value.trfBone.SetLocalPositionZ(dictSrc[22].vctPos.z);
                value.trfBone.SetLocalScale(dictSrc[22].vctScl.x * dictSrc[1].vctScl.x + num52, 1f, dictSrc[22].vctScl.z * dictSrc[1].vctScl.z);
            }
            if (dictDst.TryGetValue(24, out value))
            {
                float x3 = typeBone != 0 ? correctValue[28].vctPos.x : 0f;
                float num53 = typeBone != 0 ? correctValue[28].vctRot.x : 0f;
                float z5 = typeBone != 0 ? correctValue[28].vctRot.z : 0f;
                float num54 = typeBone != 0 ? correctValue[28].vctScl.x : 0f;
                value.trfBone.SetLocalPositionX(x3);
                value.trfBone.SetLocalPositionY(dictSrc[23].vctPos.y);
                value.trfBone.SetLocalPositionZ(dictSrc[23].vctPos.z + dictSrc[22].vctPos.z * 0.3f);
                value.trfBone.SetLocalRotation(dictSrc[23].vctRot.x + num53, 0f, z5);
                value.trfBone.SetLocalScale(dictSrc[23].vctScl.x + (-1f + dictSrc[22].vctScl.x) * 0.5f + num54, dictSrc[23].vctScl.y, dictSrc[23].vctScl.z + (-1f + dictSrc[22].vctScl.z) * 0.5f + (-1f + dictSrc[21].vctScl.z) * 0.5f);
            }
            if (dictDst.TryGetValue(25, out value))
            {
                float x4 = typeBone != 0 ? correctValue[29].vctPos.x : 0f;
                float num55 = typeBone != 0 ? correctValue[29].vctRot.x : 0f;
                float z6 = typeBone != 0 ? correctValue[29].vctRot.z : 0f;
                float num56 = typeBone != 0 ? correctValue[29].vctScl.x : 0f;
                value.trfBone.SetLocalPositionX(x4);
                value.trfBone.SetLocalPositionY(dictSrc[23].vctPos.y);
                value.trfBone.SetLocalPositionZ(dictSrc[23].vctPos.z + dictSrc[22].vctPos.z * 0.3f);
                value.trfBone.SetLocalRotation(dictSrc[23].vctRot.x + num55, 0f, z6);
                value.trfBone.SetLocalScale(dictSrc[23].vctScl.x + (-1f + dictSrc[22].vctScl.x) * 0.5f + num56, dictSrc[23].vctScl.y, dictSrc[23].vctScl.z + (-1f + dictSrc[22].vctScl.z) * 0.5f + (-1f + dictSrc[21].vctScl.z) * 0.5f);
            }
            if (dictDst.TryGetValue(26, out value))
            {
                float num57 = typeBone != 0 ? correctValue[6].vctPos.x : 0f;
                float num58 = typeBone != 0 ? correctValue[6].vctPos.z : 0f;
                float num59 = typeBone != 0 ? correctValue[6].vctRot.x : 0f;
                float y8 = typeBone != 0 ? correctValue[6].vctRot.y : 0f;
                float num60 = typeBone != 0 ? correctValue[6].vctRot.z : 0f;
                float num61 = typeBone != 0 ? correctValue[6].vctScl.x : 0f;
                float num62 = typeBone != 0 ? correctValue[6].vctScl.z : 0f;
                value.trfBone.SetLocalPositionX(dictSrc[24].vctPos.x + dictSrc[25].vctPos.x + num57);
                value.trfBone.SetLocalPositionZ(dictSrc[24].vctPos.z + num58);
                value.trfBone.SetLocalRotation(dictSrc[24].vctRot.x + num59, y8, dictSrc[24].vctRot.z + num60);
                value.trfBone.SetLocalScale(dictSrc[24].vctScl.x * dictSrc[25].vctScl.x * dictSrc[1].vctScl.x + num61, 1f, dictSrc[24].vctScl.z * dictSrc[25].vctScl.z * dictSrc[1].vctScl.z + num62);
            }
            if (dictDst.TryGetValue(27, out value))
            {
                float num63 = typeBone != 0 ? correctValue[7].vctPos.x : 0f;
                float num64 = typeBone != 0 ? correctValue[7].vctPos.z : 0f;
                float num65 = typeBone != 0 ? correctValue[7].vctRot.x : 0f;
                float y9 = typeBone != 0 ? correctValue[7].vctRot.y : 0f;
                float num66 = typeBone != 0 ? correctValue[7].vctRot.z : 0f;
                float num67 = typeBone != 0 ? correctValue[7].vctScl.x : 0f;
                float num68 = typeBone != 0 ? correctValue[7].vctScl.z : 0f;
                value.trfBone.SetLocalPositionX(dictSrc[26].vctPos.x + dictSrc[27].vctPos.x + num63);
                value.trfBone.SetLocalPositionZ(dictSrc[26].vctPos.z + num64);
                value.trfBone.SetLocalRotation(dictSrc[26].vctRot.x + num65, y9, dictSrc[26].vctRot.z + num66);
                value.trfBone.SetLocalScale(dictSrc[26].vctScl.x * dictSrc[27].vctScl.x * dictSrc[1].vctScl.x + num67, 1f, dictSrc[26].vctScl.z * dictSrc[27].vctScl.z * dictSrc[1].vctScl.z + num68);
            }
            if (dictDst.TryGetValue(28, out value))
            {
                float num69 = typeBone != 0 ? correctValue[8].vctPos.x : 0f;
                float num70 = typeBone != 0 ? correctValue[8].vctScl.x : 0f;
                float num71 = typeBone != 0 ? correctValue[8].vctScl.z : 0f;
                value.trfBone.SetLocalPositionX(dictSrc[28].vctPos.x + dictSrc[29].vctPos.x + num69);
                value.trfBone.SetLocalPositionZ(dictSrc[28].vctPos.z + dictSrc[29].vctPos.z);
                value.trfBone.SetLocalScale(dictSrc[28].vctScl.x * dictSrc[29].vctScl.x * dictSrc[1].vctScl.x + num70, 1f, dictSrc[28].vctScl.z * dictSrc[29].vctScl.z * dictSrc[1].vctScl.z + num71);
            }
            if (dictDst.TryGetValue(29, out value))
            {
                float num72 = typeBone != 0 ? correctValue[9].vctPos.x : 0f;
                float num73 = typeBone != 0 ? correctValue[9].vctScl.x : 0f;
                float num74 = typeBone != 0 ? correctValue[9].vctScl.z : 0f;
                value.trfBone.SetLocalPositionX(dictSrc[30].vctPos.x + dictSrc[31].vctPos.x + num72);
                value.trfBone.SetLocalPositionZ(dictSrc[30].vctPos.z + dictSrc[31].vctPos.z);
                value.trfBone.SetLocalScale(dictSrc[30].vctScl.x * dictSrc[31].vctScl.x * dictSrc[1].vctScl.x + num73, 1f, dictSrc[30].vctScl.z * dictSrc[31].vctScl.z * dictSrc[1].vctScl.z + num74);
            }
            if (dictDst.TryGetValue(30, out value))
            {
                float num75 = typeBone != 0 ? correctValue[10].vctPos.z : 0f;
                float num76 = typeBone != 0 ? correctValue[10].vctScl.x : 0f;
                value.trfBone.SetLocalPositionX(dictSrc[32].vctPos.x);
                value.trfBone.SetLocalPositionZ(dictSrc[32].vctPos.z + num75);
                value.trfBone.SetLocalRotation(dictSrc[32].vctRot.x, 0f, dictSrc[32].vctRot.z);
                value.trfBone.SetLocalScale(dictSrc[32].vctScl.x * dictSrc[1].vctScl.x + num76, 1f, dictSrc[32].vctScl.z * dictSrc[1].vctScl.z);
            }
            if (dictDst.TryGetValue(31, out value))
            {
                float num77 = typeBone != 0 ? correctValue[11].vctPos.z : 0f;
                float num78 = typeBone != 0 ? correctValue[11].vctScl.x : 0f;
                value.trfBone.SetLocalPositionX(dictSrc[33].vctPos.x);
                value.trfBone.SetLocalPositionZ(dictSrc[33].vctPos.z + num77);
                value.trfBone.SetLocalRotation(dictSrc[33].vctRot.x, 0f, dictSrc[33].vctRot.z);
                value.trfBone.SetLocalScale(dictSrc[33].vctScl.x * dictSrc[1].vctScl.x + num78, 1f, dictSrc[33].vctScl.z * dictSrc[1].vctScl.z);
            }
            if (dictDst.TryGetValue(32, out value))
            {
                float num79 = typeBone != 0 ? correctValue[12].vctScl.x : 0f;
                float num80 = typeBone != 0 ? correctValue[12].vctScl.z : 0f;
                value.trfBone.SetLocalPositionX(dictSrc[34].vctPos.x);
                value.trfBone.SetLocalPositionZ(dictSrc[34].vctPos.z);
                value.trfBone.SetLocalScale(dictSrc[34].vctScl.x * dictSrc[1].vctScl.x + num79, 1f, dictSrc[34].vctScl.z * dictSrc[1].vctScl.z + num80);
            }
            if (dictDst.TryGetValue(33, out value))
            {
                float num81 = typeBone != 0 ? correctValue[13].vctScl.x : 0f;
                float num82 = typeBone != 0 ? correctValue[13].vctScl.z : 0f;
                value.trfBone.SetLocalPositionX(dictSrc[35].vctPos.x);
                value.trfBone.SetLocalPositionZ(dictSrc[35].vctPos.z);
                value.trfBone.SetLocalScale(dictSrc[35].vctScl.x * dictSrc[1].vctScl.x + num81, 1f, dictSrc[35].vctScl.z * dictSrc[1].vctScl.z + num82);
            }
            if (dictDst.TryGetValue(34, out value))
            {
                value.trfBone.SetLocalPositionY(dictSrc[36].vctPos.y);
                value.trfBone.SetLocalPositionZ(dictSrc[36].vctPos.z);
                value.trfBone.SetLocalScale(dictSrc[36].vctScl.x * dictSrc[1].vctScl.x, 1f, dictSrc[36].vctScl.z * dictSrc[1].vctScl.z);
            }
            if (dictDst.TryGetValue(35, out value))
            {
                value.trfBone.SetLocalPositionY(dictSrc[37].vctPos.y);
                value.trfBone.SetLocalPositionZ(dictSrc[37].vctPos.z);
                value.trfBone.SetLocalScale(dictSrc[37].vctScl.x * dictSrc[1].vctScl.x, 1f, dictSrc[37].vctScl.z * dictSrc[1].vctScl.z);
            }
            if (dictDst.TryGetValue(36, out value))
            {
                value.trfBone.SetLocalScale(dictSrc[38].vctScl.x, 1f, dictSrc[38].vctScl.z);
            }
            if (dictDst.TryGetValue(37, out value))
            {
                value.trfBone.SetLocalScale(dictSrc[38].vctScl.x, 1f, dictSrc[38].vctScl.z);
            }
            if (dictDst.TryGetValue(67, out value))
            {
                value.trfBone.SetLocalPositionX(dictSrc[65].vctPos.x + dictSrc[66].vctPos.x + dictSrc[67].vctPos.x + dictSrc[68].vctPos.x + dictSrc[69].vctPos.x + dictSrc[70].vctPos.x);
                value.trfBone.SetLocalPositionY(dictSrc[67].vctPos.y + dictSrc[68].vctPos.y + dictSrc[70].vctPos.y);
                value.trfBone.SetLocalPositionZ(dictSrc[65].vctPos.z + dictSrc[67].vctPos.z + dictSrc[70].vctPos.z);
                value.trfBone.SetLocalScale(dictSrc[65].vctScl.x * dictSrc[67].vctScl.x * dictSrc[68].vctScl.x * dictSrc[1].vctScl.x * dictSrc[70].vctScl.x, dictSrc[65].vctScl.y * dictSrc[67].vctScl.y * dictSrc[68].vctScl.y * dictSrc[1].vctScl.y * dictSrc[70].vctScl.x, dictSrc[65].vctScl.z * dictSrc[67].vctScl.z * dictSrc[68].vctScl.z * dictSrc[1].vctScl.z * dictSrc[70].vctScl.x);
            }
            if (dictDst.TryGetValue(68, out value))
            {
                value.trfBone.SetLocalPositionX(0f - dictSrc[65].vctPos.x - dictSrc[66].vctPos.x - dictSrc[67].vctPos.x - dictSrc[68].vctPos.x - dictSrc[69].vctPos.x - dictSrc[70].vctPos.x);
                value.trfBone.SetLocalPositionY(dictSrc[67].vctPos.y + dictSrc[68].vctPos.y + dictSrc[70].vctPos.y);
                value.trfBone.SetLocalPositionZ(dictSrc[65].vctPos.z + dictSrc[67].vctPos.z + dictSrc[70].vctPos.z);
                value.trfBone.SetLocalScale(dictSrc[65].vctScl.x * dictSrc[67].vctScl.x * dictSrc[68].vctScl.x * dictSrc[1].vctScl.x * dictSrc[70].vctScl.x, dictSrc[65].vctScl.y * dictSrc[67].vctScl.y * dictSrc[68].vctScl.y * dictSrc[1].vctScl.y * dictSrc[70].vctScl.x, dictSrc[65].vctScl.z * dictSrc[67].vctScl.z * dictSrc[68].vctScl.z * dictSrc[1].vctScl.z * dictSrc[70].vctScl.x);
            }
            if (dictDst.TryGetValue(69, out value))
            {
                value.trfBone.SetLocalPositionY(dictSrc[71].vctPos.y + dictSrc[72].vctPos.y + dictSrc[73].vctPos.y + dictSrc[74].vctPos.y + dictSrc[75].vctPos.y + dictSrc[76].vctPos.y);
                value.trfBone.SetLocalPositionZ(dictSrc[72].vctPos.z + dictSrc[73].vctPos.z);
                value.trfBone.SetLocalScale(dictSrc[71].vctScl.x * dictSrc[72].vctScl.x * dictSrc[1].vctScl.x * dictSrc[73].vctScl.x * dictSrc[76].vctScl.x * dictSrc[75].vctScl.x, dictSrc[71].vctScl.x * dictSrc[72].vctScl.x * dictSrc[1].vctScl.y * dictSrc[73].vctScl.y * dictSrc[76].vctScl.y * dictSrc[75].vctScl.y, dictSrc[71].vctScl.x * dictSrc[72].vctScl.x * dictSrc[1].vctScl.z * dictSrc[73].vctScl.z * dictSrc[76].vctScl.z * dictSrc[75].vctScl.z);
            }
            if (dictDst.TryGetValue(70, out value))
            {
                value.trfBone.SetLocalPositionX(dictSrc[77].vctPos.x);
                value.trfBone.SetLocalPositionY(dictSrc[77].vctPos.y + dictSrc[74].vctPos.y * 2f + dictSrc[78].vctPos.y + dictSrc[79].vctPos.y);
                value.trfBone.SetLocalPositionZ(dictSrc[77].vctPos.z + dictSrc[78].vctPos.z + dictSrc[79].vctPos.z);
                value.trfBone.SetLocalScale(dictSrc[77].vctScl.x * dictSrc[78].vctScl.x * dictSrc[1].vctScl.x * dictSrc[79].vctScl.x, dictSrc[77].vctScl.y * dictSrc[78].vctScl.y * dictSrc[1].vctScl.y * dictSrc[79].vctScl.y, dictSrc[77].vctScl.z * dictSrc[78].vctScl.z * dictSrc[1].vctScl.z * dictSrc[79].vctScl.z);
            }
            if (dictDst.TryGetValue(71, out value))
            {
                value.trfBone.SetLocalPositionY(dictSrc[80].vctPos.y + dictSrc[81].vctPos.y + dictSrc[82].vctPos.y);
                value.trfBone.SetLocalPositionZ(dictSrc[82].vctPos.z);
                value.trfBone.SetLocalScale(dictSrc[81].vctScl.x * dictSrc[82].vctScl.x * dictSrc[1].vctScl.x, dictSrc[81].vctScl.y * dictSrc[82].vctScl.y * dictSrc[1].vctScl.y, dictSrc[81].vctScl.z * dictSrc[82].vctScl.z * dictSrc[1].vctScl.z);
            }
            if (dictDst.TryGetValue(72, out value))
            {
                value.trfBone.SetLocalPositionX(dictSrc[83].vctPos.x + dictSrc[84].vctPos.x + dictSrc[85].vctPos.x);
                value.trfBone.SetLocalPositionY(dictSrc[83].vctPos.y + dictSrc[84].vctPos.y + dictSrc[85].vctPos.y);
                value.trfBone.SetLocalPositionZ(dictSrc[83].vctPos.z + dictSrc[84].vctPos.z);
                value.trfBone.SetLocalScale(dictSrc[83].vctScl.x * dictSrc[84].vctScl.x * dictSrc[85].vctScl.x * dictSrc[1].vctScl.x, dictSrc[83].vctScl.y * dictSrc[84].vctScl.y * dictSrc[85].vctScl.y * dictSrc[1].vctScl.y, dictSrc[83].vctScl.z * dictSrc[84].vctScl.z * dictSrc[85].vctScl.z * dictSrc[1].vctScl.z);
            }
            if (dictDst.TryGetValue(73, out value))
            {
                value.trfBone.SetLocalPositionX(0f - dictSrc[83].vctPos.x - dictSrc[84].vctPos.x - dictSrc[85].vctPos.x);
                value.trfBone.SetLocalPositionY(dictSrc[83].vctPos.y + dictSrc[84].vctPos.y + dictSrc[85].vctPos.y);
                value.trfBone.SetLocalPositionZ(dictSrc[83].vctPos.z + dictSrc[84].vctPos.z);
                value.trfBone.SetLocalScale(dictSrc[83].vctScl.x * dictSrc[84].vctScl.x * dictSrc[85].vctScl.x * dictSrc[1].vctScl.x, dictSrc[83].vctScl.y * dictSrc[84].vctScl.y * dictSrc[85].vctScl.y * dictSrc[1].vctScl.y, dictSrc[83].vctScl.z * dictSrc[84].vctScl.z * dictSrc[85].vctScl.z * dictSrc[1].vctScl.z);
            }
            if (dictDst.TryGetValue(74, out value))
            {
                value.trfBone.SetLocalScale(1f, dictSrc[86].vctScl.y * dictSrc[87].vctScl.y * dictSrc[88].vctScl.y * dictSrc[1].vctScl.x, dictSrc[86].vctScl.z * dictSrc[87].vctScl.z * dictSrc[88].vctScl.z * dictSrc[1].vctScl.x);
            }
            if (dictDst.TryGetValue(75, out value))
            {
                value.trfBone.SetLocalScale(1f, dictSrc[86].vctScl.y * dictSrc[87].vctScl.y * dictSrc[88].vctScl.y * dictSrc[1].vctScl.x, dictSrc[86].vctScl.z * dictSrc[87].vctScl.z * dictSrc[88].vctScl.z * dictSrc[1].vctScl.x);
            }
            if (dictDst.TryGetValue(76, out value))
            {
                value.trfBone.SetLocalPositionZ(dictSrc[89].vctPos.z + dictSrc[90].vctPos.z);
                value.trfBone.SetLocalScale(dictSrc[89].vctScl.x * dictSrc[90].vctScl.x * dictSrc[1].vctScl.x, dictSrc[89].vctScl.y * dictSrc[90].vctScl.y * dictSrc[1].vctScl.y, dictSrc[89].vctScl.z * dictSrc[90].vctScl.z * dictSrc[1].vctScl.z);
            }
            float num83 = !(180f < dictSrc[94].vctRot.x) ? dictSrc[94].vctRot.x : dictSrc[94].vctRot.x - 360f;
            float num84 = !(180f < dictSrc[97].vctRot.x) ? dictSrc[97].vctRot.x : dictSrc[97].vctRot.x - 360f;
            if (dictDst.TryGetValue(77, out value))
            {
                value.trfBone.SetLocalScale(dictSrc[1].vctScl.x, dictSrc[1].vctScl.y, dictSrc[1].vctScl.z);
            }
            if (dictDst.TryGetValue(78, out value))
            {
                value.trfBone.SetLocalPositionX(dictSrc[91].vctPos.x + dictSrc[92].vctPos.x);
                value.trfBone.SetLocalPositionZ(dictSrc[91].vctPos.z + dictSrc[92].vctPos.z + dictSrc[93].vctPos.z);
                value.trfBone.SetLocalRotation(dictSrc[91].vctRot.x + dictSrc[92].vctRot.x + dictSrc[92].vctRot.z + num83, dictSrc[91].vctRot.y, dictSrc[91].vctRot.z);
            }
            if (dictDst.TryGetValue(79, out value))
            {
                value.trfBone.SetLocalPositionX(dictSrc[95].vctPos.x + dictSrc[96].vctPos.x - dictSrc[93].vctPos.x * 0.5f);
                value.trfBone.SetLocalPositionZ(dictSrc[95].vctPos.z + dictSrc[96].vctPos.z + dictSrc[93].vctPos.z);
                value.trfBone.SetLocalRotation(dictSrc[95].vctRot.x + dictSrc[96].vctRot.x + dictSrc[96].vctRot.z + num83 * 0.6f + num84 * 0.6f, dictSrc[95].vctRot.y, dictSrc[95].vctRot.z);
            }
            if (dictDst.TryGetValue(80, out value))
            {
                value.trfBone.SetLocalPositionX(dictSrc[98].vctPos.x + dictSrc[99].vctPos.x + dictSrc[100].vctPos.x * 0.5f - dictSrc[93].vctPos.x);
                value.trfBone.SetLocalPositionZ(dictSrc[98].vctPos.z + dictSrc[99].vctPos.z);
                value.trfBone.SetLocalRotation(dictSrc[98].vctRot.x + dictSrc[99].vctRot.x + dictSrc[99].vctRot.z + num84, dictSrc[98].vctRot.y, dictSrc[98].vctRot.z);
            }
            if (dictDst.TryGetValue(81, out value))
            {
                value.trfBone.SetLocalPositionX(dictSrc[101].vctPos.x + dictSrc[102].vctPos.x + dictSrc[100].vctPos.x);
                value.trfBone.SetLocalPositionZ(dictSrc[101].vctPos.z + dictSrc[102].vctPos.z + dictSrc[100].vctPos.z);
                value.trfBone.SetLocalRotation(dictSrc[101].vctRot.x + dictSrc[102].vctRot.x + dictSrc[102].vctRot.z + num83 * 0.6f + num84 * 0.6f + dictSrc[100].vctRot.x, dictSrc[101].vctRot.y, dictSrc[101].vctRot.z);
            }
            if (dictDst.TryGetValue(82, out value))
            {
                value.trfBone.SetLocalPositionX(dictSrc[103].vctPos.x + dictSrc[104].vctPos.x);
                value.trfBone.SetLocalPositionZ(dictSrc[103].vctPos.z + dictSrc[104].vctPos.z + dictSrc[100].vctPos.z);
                value.trfBone.SetLocalRotation(dictSrc[103].vctRot.x + dictSrc[104].vctRot.x + dictSrc[104].vctRot.z + num83 + dictSrc[100].vctRot.x, dictSrc[103].vctRot.y, dictSrc[103].vctRot.z);
            }
            if (dictDst.TryGetValue(83, out value))
            {
                value.trfBone.SetLocalPositionX(dictSrc[105].vctPos.x + dictSrc[106].vctPos.x - dictSrc[100].vctPos.x);
                value.trfBone.SetLocalPositionZ(dictSrc[105].vctPos.z + dictSrc[106].vctPos.z + dictSrc[100].vctPos.z);
                value.trfBone.SetLocalRotation(dictSrc[105].vctRot.x + dictSrc[106].vctRot.x + dictSrc[106].vctRot.z + num83 * 0.6f + num84 * 0.6f + dictSrc[100].vctRot.x, dictSrc[105].vctRot.y, dictSrc[105].vctRot.z);
            }
            if (dictDst.TryGetValue(84, out value))
            {
                value.trfBone.SetLocalPositionX(dictSrc[107].vctPos.x + dictSrc[108].vctPos.x - dictSrc[100].vctPos.x * 0.5f + dictSrc[93].vctPos.x);
                value.trfBone.SetLocalPositionZ(dictSrc[107].vctPos.z + dictSrc[108].vctPos.z);
                value.trfBone.SetLocalRotation(dictSrc[107].vctRot.x + dictSrc[108].vctRot.x + dictSrc[108].vctRot.z + num84, dictSrc[107].vctRot.y, dictSrc[107].vctRot.z);
            }
            if (dictDst.TryGetValue(85, out value))
            {
                value.trfBone.SetLocalPositionX(dictSrc[109].vctPos.x + dictSrc[110].vctPos.x + dictSrc[93].vctPos.x * 0.5f);
                value.trfBone.SetLocalPositionZ(dictSrc[109].vctPos.z + dictSrc[110].vctPos.z + dictSrc[93].vctPos.z);
                value.trfBone.SetLocalRotation(dictSrc[109].vctRot.x + dictSrc[110].vctRot.x + dictSrc[110].vctRot.z + num83 * 0.6f + num84 * 0.6f, dictSrc[109].vctRot.y, dictSrc[109].vctRot.z);
            }
        }
        if ((updateMask & 1) != 0)
        {
            if (dictDst.TryGetValue(39, out value))
            {
                value.trfBone.SetLocalPositionY(dictSrc[40].vctPos.y);
                value.trfBone.SetLocalPositionZ(dictSrc[41].vctPos.z + dictSrc[42].vctPos.z + dictSrc[43].vctPos.z + dictSrc[40].vctPos.z + dictSrc[44].vctPos.z);
                value.trfBone.SetLocalRotation(dictSrc[44].vctRot.x, 0f, 0f);
            }
            if (dictDst.TryGetValue(40, out value))
            {
                value.trfBone.SetLocalPositionX(dictSrc[46].vctPos.x);
                value.trfBone.SetLocalPositionY(dictSrc[45].vctPos.y);
                value.trfBone.SetLocalPositionZ(dictSrc[45].vctPos.z);
                value.trfBone.SetLocalRotation(dictSrc[45].vctRot.x, dictSrc[43].vctRot.y + dictSrc[45].vctRot.y, 0f);
                value.trfBone.SetLocalScale(dictSrc[45].vctScl.x, dictSrc[45].vctScl.y, dictSrc[45].vctScl.z);
            }
            if (dictDst.TryGetValue(41, out value))
            {
                value.trfBone.SetLocalPositionY(dictSrc[47].vctPos.y);
                value.trfBone.SetLocalPositionZ(dictSrc[47].vctPos.z + dictSrc[48].vctPos.z);
                value.trfBone.SetLocalRotation(dictSrc[47].vctRot.x, 0f, 0f);
                value.trfBone.SetLocalScale(dictSrc[47].vctScl.x, dictSrc[47].vctScl.y, dictSrc[47].vctScl.z);
            }
            if (dictDst.TryGetValue(42, out value))
            {
                value.trfBone.SetLocalPositionY(dictSrc[49].vctPos.y);
                value.trfBone.SetLocalPositionZ(dictSrc[49].vctPos.z + dictSrc[48].vctPos.z / 2f);
                value.trfBone.SetLocalRotation(dictSrc[49].vctRot.x, 0f, 0f);
                value.trfBone.SetLocalScale(dictSrc[49].vctScl.x, dictSrc[49].vctScl.y, dictSrc[49].vctScl.z);
            }
            if (dictDst.TryGetValue(43, out value))
            {
                value.trfBone.SetLocalPositionX(dictSrc[50].vctPos.x);
                value.trfBone.SetLocalPositionY(dictSrc[50].vctPos.y);
                value.trfBone.SetLocalPositionZ(dictSrc[50].vctPos.z);
                value.trfBone.SetLocalRotation(dictSrc[50].vctRot.x, dictSrc[50].vctRot.y, 0f);
                value.trfBone.SetLocalScale(dictSrc[50].vctScl.x, dictSrc[50].vctScl.y, dictSrc[48].vctScl.z);
            }
            if (dictDst.TryGetValue(44, out value))
            {
                value.trfBone.SetLocalPositionX(dictSrc[51].vctPos.x);
                value.trfBone.SetLocalPositionY(dictSrc[51].vctPos.y);
                value.trfBone.SetLocalPositionZ(dictSrc[51].vctPos.z);
                value.trfBone.SetLocalRotation(dictSrc[51].vctRot.x, dictSrc[51].vctRot.y, 0f);
                value.trfBone.SetLocalScale(dictSrc[51].vctScl.x * dictSrc[48].vctScl.x, dictSrc[51].vctScl.y * dictSrc[48].vctScl.y, dictSrc[51].vctScl.z);
            }
            if (dictDst.TryGetValue(45, out value))
            {
                value.trfBone.SetLocalPositionY(dictSrc[52].vctPos.y);
                value.trfBone.SetLocalPositionZ(dictSrc[52].vctPos.z);
                value.trfBone.SetLocalRotation(dictSrc[52].vctRot.x, 0f, 0f);
                value.trfBone.SetLocalScale(dictSrc[52].vctScl.x * dictSrc[48].vctScl.x, dictSrc[52].vctScl.y * dictSrc[48].vctScl.y, 1f);
            }
            if (dictDst.TryGetValue(46, out value))
            {
                value.trfBone.SetLocalPositionX(dictSrc[53].vctPos.x);
                value.trfBone.SetLocalPositionY(dictSrc[53].vctPos.y);
                value.trfBone.SetLocalPositionZ(dictSrc[53].vctPos.z + dictSrc[54].vctPos.z);
                value.trfBone.SetLocalScale(dictSrc[53].vctScl.x * dictSrc[54].vctScl.x, dictSrc[53].vctScl.y * dictSrc[54].vctScl.x, dictSrc[53].vctScl.z * dictSrc[54].vctScl.x);
            }
            if (dictDst.TryGetValue(47, out value))
            {
                value.trfBone.SetLocalPositionZ(dictSrc[55].vctPos.z + dictSrc[56].vctPos.z);
                value.trfBone.SetLocalScale(dictSrc[57].vctScl.x, dictSrc[57].vctScl.x, dictSrc[57].vctScl.z);
            }
            if (dictDst.TryGetValue(48, out value))
            {
                value.trfBone.SetLocalPositionZ((0f - (dictSrc[55].vctPos.z - 0.01f)) * 1.2f);
                value.trfBone.SetLocalScale(dictSrc[55].vctScl.x * dictSrc[56].vctScl.x, dictSrc[55].vctScl.y * dictSrc[56].vctScl.y, dictSrc[55].vctScl.z * dictSrc[56].vctScl.z);
            }
            if (dictDst.TryGetValue(49, out value))
            {
                value.trfBone.SetLocalScale(1f / dictSrc[55].vctScl.x * (dictSrc[58].vctScl.x * 1.2f), 1f / dictSrc[55].vctScl.y * (dictSrc[58].vctScl.y * 1.2f), 1f / dictSrc[55].vctScl.z);
            }
            if (dictDst.TryGetValue(50, out value))
            {
                value.trfBone.SetLocalPositionZ(0.0025f + dictSrc[59].vctPos.z - (dictSrc[55].vctPos.z - 0.01f) * 1f);
                value.trfBone.SetLocalScale(0.1f + dictSrc[59].vctScl.y * dictSrc[59].vctScl.x, 0.1f + dictSrc[59].vctScl.y * dictSrc[59].vctScl.x, 0.1f + dictSrc[59].vctScl.z * dictSrc[59].vctScl.x);
            }
            if (dictDst.TryGetValue(51, out value))
            {
                value.trfBone.SetLocalPositionZ(0.004f + dictSrc[60].vctPos.z + dictSrc[55].vctPos.x + dictSrc[58].vctPos.z);
                value.trfBone.SetLocalScale(dictSrc[60].vctScl.x * dictSrc[58].vctScl.x, dictSrc[60].vctScl.y * dictSrc[58].vctScl.y, dictSrc[60].vctScl.z * dictSrc[58].vctScl.z);
            }
            if (dictDst.TryGetValue(52, out value))
            {
                value.trfBone.SetLocalPositionZ(dictSrc[61].vctPos.z);
                value.trfBone.SetLocalScale(1f * dictSrc[61].vctScl.x / dictSrc[60].vctScl.x / dictSrc[58].vctScl.x * dictSrc[62].vctScl.x, 1f * dictSrc[61].vctScl.y / dictSrc[60].vctScl.y / dictSrc[58].vctScl.y * dictSrc[62].vctScl.y, 1f * dictSrc[61].vctScl.z / dictSrc[60].vctScl.z / dictSrc[58].vctScl.z * dictSrc[62].vctScl.z);
            }
        }
        if ((updateMask & 2) != 0)
        {
            if (dictDst.TryGetValue(53, out value))
            {
                value.trfBone.SetLocalPositionY(dictSrc[40].vctPos.y);
                value.trfBone.SetLocalPositionZ(dictSrc[41].vctPos.z + dictSrc[42].vctPos.z + dictSrc[43].vctPos.z + dictSrc[40].vctPos.z + dictSrc[44].vctPos.z);
                value.trfBone.SetLocalRotation(dictSrc[44].vctRot.x, 0f, 0f);
            }
            if (dictDst.TryGetValue(54, out value))
            {
                value.trfBone.SetLocalPositionX(dictSrc[64].vctPos.x);
                value.trfBone.SetLocalPositionY(dictSrc[45].vctPos.y);
                value.trfBone.SetLocalPositionZ(dictSrc[45].vctPos.z);
                value.trfBone.SetLocalRotation(dictSrc[45].vctRot.x, dictSrc[63].vctRot.y - dictSrc[45].vctRot.y, 0f);
                value.trfBone.SetLocalScale(dictSrc[45].vctScl.x, dictSrc[45].vctScl.y, dictSrc[45].vctScl.z);
            }
            if (dictDst.TryGetValue(55, out value))
            {
                value.trfBone.SetLocalPositionY(dictSrc[47].vctPos.y);
                value.trfBone.SetLocalPositionZ(dictSrc[47].vctPos.z + dictSrc[48].vctPos.z);
                value.trfBone.SetLocalRotation(dictSrc[47].vctRot.x, 0f, 0f);
                value.trfBone.SetLocalScale(dictSrc[47].vctScl.x, dictSrc[47].vctScl.y, dictSrc[47].vctScl.z);
            }
            if (dictDst.TryGetValue(56, out value))
            {
                value.trfBone.SetLocalPositionY(dictSrc[49].vctPos.y);
                value.trfBone.SetLocalPositionZ(dictSrc[49].vctPos.z + dictSrc[48].vctPos.z / 2f);
                value.trfBone.SetLocalRotation(dictSrc[49].vctRot.x, 0f, 0f);
                value.trfBone.SetLocalScale(dictSrc[49].vctScl.x, dictSrc[49].vctScl.y, dictSrc[49].vctScl.z);
            }
            if (dictDst.TryGetValue(57, out value))
            {
                value.trfBone.SetLocalPositionX(0f - dictSrc[50].vctPos.x);
                value.trfBone.SetLocalPositionY(dictSrc[50].vctPos.y);
                value.trfBone.SetLocalPositionZ(dictSrc[50].vctPos.z);
                value.trfBone.SetLocalRotation(dictSrc[50].vctRot.x, 0f - dictSrc[50].vctRot.y, 0f);
                value.trfBone.SetLocalScale(dictSrc[50].vctScl.x, dictSrc[50].vctScl.y, dictSrc[48].vctScl.z);
            }
            if (dictDst.TryGetValue(58, out value))
            {
                value.trfBone.SetLocalPositionX(0f - dictSrc[51].vctPos.x);
                value.trfBone.SetLocalPositionY(dictSrc[51].vctPos.y);
                value.trfBone.SetLocalPositionZ(dictSrc[51].vctPos.z);
                value.trfBone.SetLocalRotation(dictSrc[51].vctRot.x, 0f - dictSrc[51].vctRot.y, 0f);
                value.trfBone.SetLocalScale(dictSrc[51].vctScl.x * dictSrc[48].vctScl.x, dictSrc[51].vctScl.y * dictSrc[48].vctScl.y, dictSrc[51].vctScl.z);
            }
            if (dictDst.TryGetValue(59, out value))
            {
                value.trfBone.SetLocalPositionY(dictSrc[52].vctPos.y);
                value.trfBone.SetLocalPositionZ(dictSrc[52].vctPos.z);
                value.trfBone.SetLocalRotation(dictSrc[52].vctRot.x, 0f, 0f);
                value.trfBone.SetLocalScale(dictSrc[52].vctScl.x * dictSrc[48].vctScl.x, dictSrc[52].vctScl.y * dictSrc[48].vctScl.y, 1f);
            }
            if (dictDst.TryGetValue(60, out value))
            {
                value.trfBone.SetLocalPositionX(0f - dictSrc[53].vctPos.x);
                value.trfBone.SetLocalPositionY(dictSrc[53].vctPos.y);
                value.trfBone.SetLocalPositionZ(dictSrc[53].vctPos.z + dictSrc[54].vctPos.z);
                value.trfBone.SetLocalScale(dictSrc[53].vctScl.x * dictSrc[54].vctScl.x, dictSrc[53].vctScl.y * dictSrc[54].vctScl.x, dictSrc[53].vctScl.z * dictSrc[54].vctScl.x);
            }
            if (dictDst.TryGetValue(61, out value))
            {
                value.trfBone.SetLocalPositionZ(dictSrc[55].vctPos.z + dictSrc[56].vctPos.z);
                value.trfBone.SetLocalScale(dictSrc[57].vctScl.x, dictSrc[57].vctScl.x, dictSrc[57].vctScl.z);
            }
            if (dictDst.TryGetValue(62, out value))
            {
                value.trfBone.SetLocalPositionZ((0f - (dictSrc[55].vctPos.z - 0.01f)) * 1.2f);
                value.trfBone.SetLocalScale(dictSrc[55].vctScl.x * dictSrc[56].vctScl.x, dictSrc[55].vctScl.y * dictSrc[56].vctScl.y, dictSrc[55].vctScl.z * dictSrc[56].vctScl.z);
            }
            if (dictDst.TryGetValue(63, out value))
            {
                value.trfBone.SetLocalScale(1f / dictSrc[55].vctScl.x * (dictSrc[58].vctScl.x * 1.2f), 1f / dictSrc[55].vctScl.y * (dictSrc[58].vctScl.y * 1.2f), 1f / dictSrc[55].vctScl.z);
            }
            if (dictDst.TryGetValue(64, out value))
            {
                value.trfBone.SetLocalPositionZ(0.0025f + dictSrc[59].vctPos.z - (dictSrc[55].vctPos.z - 0.01f) * 1f);
                value.trfBone.SetLocalScale(0.1f + dictSrc[59].vctScl.y * dictSrc[59].vctScl.x, 0.1f + dictSrc[59].vctScl.y * dictSrc[59].vctScl.x, 0.1f + dictSrc[59].vctScl.z * dictSrc[59].vctScl.x);
            }
            if (dictDst.TryGetValue(65, out value))
            {
                value.trfBone.SetLocalPositionZ(0.004f + dictSrc[60].vctPos.z + dictSrc[55].vctPos.x + dictSrc[58].vctPos.z);
                value.trfBone.SetLocalScale(dictSrc[60].vctScl.x * dictSrc[58].vctScl.x, dictSrc[60].vctScl.y * dictSrc[58].vctScl.y, dictSrc[60].vctScl.z * dictSrc[58].vctScl.z);
            }
            if (dictDst.TryGetValue(66, out value))
            {
                value.trfBone.SetLocalPositionZ(dictSrc[61].vctPos.z);
                value.trfBone.SetLocalScale(1f * dictSrc[61].vctScl.x / dictSrc[60].vctScl.x / dictSrc[58].vctScl.x * dictSrc[62].vctScl.x, 1f * dictSrc[61].vctScl.y / dictSrc[60].vctScl.y / dictSrc[58].vctScl.y * dictSrc[62].vctScl.y, 1f * dictSrc[61].vctScl.z / dictSrc[60].vctScl.z / dictSrc[58].vctScl.z * dictSrc[62].vctScl.z);
            }
        }
    }

    public override void UpdateAlways()
    {
        if (!InitEnd || dictSrc.Count == 0)
        {
            return;
        }
        BoneInfo value;
        if (dictDst.TryGetValue(38, out value))
        {
            value.trfBone.SetLocalPositionZ(dictSrc[39].vctPos.z);
        }
        if (fixCorrectBone != null && fixCorrectBone.Length == 2)
        {
            if ((bool)fixCorrectBone[0])
            {
                float x = typeBone != 0 ? correctValue[30].vctPos.x : -0.01563369f;
                fixCorrectBone[0].SetLocalPositionX(x);
            }
            if ((bool)fixCorrectBone[1])
            {
                float x2 = typeBone != 0 ? correctValue[31].vctPos.x : 0.01560147f;
                fixCorrectBone[1].SetLocalPositionX(x2);
            }
        }
    }
}
