using IllusionUtility.SetUtility;
using Manager;
using System;
using System.Collections.Generic;
using UnityEngine;

public class ShapeHandInfo : ShapeInfoBase
{
    public enum DstName
    {
        cf_j_index01_L,
        cf_j_index02_L,
        cf_j_index03_L,
        cf_j_little01_L,
        cf_j_little02_L,
        cf_j_little03_L,
        cf_j_middle01_L,
        cf_j_middle02_L,
        cf_j_middle03_L,
        cf_j_ring01_L,
        cf_j_ring02_L,
        cf_j_ring03_L,
        cf_j_thumb01_L,
        cf_j_thumb02_L,
        cf_j_thumb03_L,
        cf_j_index01_R,
        cf_j_index02_R,
        cf_j_index03_R,
        cf_j_little01_R,
        cf_j_little02_R,
        cf_j_little03_R,
        cf_j_middle01_R,
        cf_j_middle02_R,
        cf_j_middle03_R,
        cf_j_ring01_R,
        cf_j_ring02_R,
        cf_j_ring03_R,
        cf_j_thumb01_R,
        cf_j_thumb02_R,
        cf_j_thumb03_R
    }

    public enum SrcName
    {
        cf_j_index01_L,
        cf_j_index02_L,
        cf_j_index03_L,
        cf_j_little01_L,
        cf_j_little02_L,
        cf_j_little03_L,
        cf_j_middle01_L,
        cf_j_middle02_L,
        cf_j_middle03_L,
        cf_j_ring01_L,
        cf_j_ring02_L,
        cf_j_ring03_L,
        cf_j_thumb01_L,
        cf_j_thumb02_L,
        cf_j_thumb03_L,
        cf_j_index01_R,
        cf_j_index02_R,
        cf_j_index03_R,
        cf_j_little01_R,
        cf_j_little02_R,
        cf_j_little03_R,
        cf_j_middle01_R,
        cf_j_middle02_R,
        cf_j_middle03_R,
        cf_j_ring01_R,
        cf_j_ring02_R,
        cf_j_ring03_R,
        cf_j_thumb01_R,
        cf_j_thumb02_R,
        cf_j_thumb03_R
    }

    public const int UPDATE_MASK_HAND_L = 1;

    public const int UPDATE_MASK_HAND_R = 2;

    public int updateMask;

    public override void InitShapeInfo(string manifest, string assetBundleAnmKey, string assetBundleCategory, string anmKeyInfoName, string cateInfoName, Transform trfObj, int _sex)
    {
        sex = _sex;
        Dictionary<string, int> dictionary = new Dictionary<string, int>();
        DstName[] array = (DstName[])Enum.GetValues(typeof(DstName));
        DstName[] array2 = array;
        for (int i = 0; i < array2.Length; i++)
        {
            DstName value = array2[i];
            dictionary[value.ToString()] = (int)value;
        }
        Dictionary<string, int> dictionary2 = new Dictionary<string, int>();
        SrcName[] array3 = (SrcName[])Enum.GetValues(typeof(SrcName));
        SrcName[] array4 = array3;
        for (int j = 0; j < array4.Length; j++)
        {
            SrcName value2 = array4[j];
            dictionary2[value2.ToString()] = (int)value2;
        }
        InitShapeInfoBase(manifest, assetBundleAnmKey, assetBundleCategory, anmKeyInfoName, cateInfoName, trfObj, dictionary, dictionary2, Singleton<Character>.Instance.AddLoadAssetBundle);
        InitEnd = true;
    }

    public override void ForceUpdate()
    {
        Update();
    }

    public override void Update()
    {
    }

    public override void UpdateAlways()
    {
        if (!InitEnd || dictSrc.Count == 0)
        {
            return;
        }
        BoneInfo value;
        if ((updateMask & 1) != 0)
        {
            int num = 0;
            int num2 = 14;
            for (int i = num; i <= num2; i++)
            {
                if (dictDst.TryGetValue(i, out value))
                {
                    value.trfBone.SetLocalRotation(dictSrc[i].vctRot.x, dictSrc[i].vctRot.y, dictSrc[i].vctRot.z);
                }
            }
        }
        if ((updateMask & 2) == 0)
        {
            return;
        }
        int num3 = 15;
        int num4 = 29;
        for (int j = num3; j <= num4; j++)
        {
            if (dictDst.TryGetValue(j, out value))
            {
                value.trfBone.SetLocalRotation(dictSrc[j].vctRot.x, dictSrc[j].vctRot.y, dictSrc[j].vctRot.z);
            }
        }
    }
}
