using IllusionUtility.SetUtility;
using Manager;
using System;
using System.Collections.Generic;
using UnityEngine;

public class ShapeHeadInfoFemale : ShapeInfoBase
{
    public enum DstBoneName
    {
        cf_J_FaceBase,
        cf_J_FaceUp_tz,
        cf_J_NoseBridge_ty,
        cf_J_FaceUp_ty,
        cf_J_FaceLow_tz,
        cf_J_FaceLow_sx,
        cf_J_CheekUp2_L,
        cf_J_CheekUp2_R,
        cf_J_ChinLow,
        cf_J_CheekLow_s_L,
        cf_J_CheekLow_s_R,
        cf_J_Chin_Base,
        cf_J_ChinTip_Base,
        cf_J_Nose_tip,
        cf_J_NoseBase_rx,
        cf_J_NoseBridge_rx,
        cf_J_CheekUpBase,
        cf_J_CheekUp_s_L,
        cf_J_CheekUp_s_R,
        cf_J_Eye_tx_L,
        cf_J_Eye_tx_R,
        cf_J_megane_rx_ear,
        cf_J_Eye_rz_L,
        cf_J_Eye_rz_R,
        cf_J_Eye_tz,
        cf_J_Eye01_s_L,
        cf_J_Eye01_s_R,
        cf_J_Eye05_s_L,
        cf_J_Eye05_s_R,
        cf_J_Eye02_s_L,
        cf_J_Eye02_s_R,
        cf_J_Eye03_s_L,
        cf_J_Eye03_s_R,
        cf_J_Eye04_s_L,
        cf_J_Eye04_s_R,
        cf_J_Eye08_s_L,
        cf_J_Eye08_s_R,
        cf_J_Eye07_s_L,
        cf_J_Eye07_s_R,
        cf_J_Eye06_s_L,
        cf_J_Eye06_s_R,
        cf_J_Mayu_L,
        cf_J_Mayu_R,
        cf_J_MayuMid_s_L,
        cf_J_MayuMid_s_R,
        cf_J_MayuTip_s_L,
        cf_J_MayuTip_s_R,
        cf_J_EarBase_ry_L,
        cf_J_EarBase_ry_R,
        cf_J_EarUp_L,
        cf_J_EarUp_R,
        cf_J_EarLow_L,
        cf_J_EarLow_R,
        cf_J_MouthBase_ty,
        cf_J_Mouth_L,
        cf_J_Mouth_R,
        cf_J_MouthBase_rx,
        cf_J_Mouthup,
        cf_J_MouthLow
    }

    public enum SrcBoneName
    {
        cf_J_FaceBase,
        cf_J_FaceUp_tz,
        cf_J_NoseBridge_ty,
        cf_J_FaceUp_ty,
        cf_J_FaceLow_tz,
        cf_J_FaceLow_sx,
        cf_J_CheekUp2_L,
        cf_J_CheekUp2_R,
        cf_J_ChinLow,
        cf_J_CheekLow_s_L,
        cf_J_CheekLow_s_R,
        cf_J_Chin_Base,
        cf_J_ChinTip_Base,
        cf_J_Nose_tip,
        cf_J_NoseBase_rx,
        cf_J_NoseBridge_rx,
        cf_J_CheekUpBase,
        cf_J_CheekUp_s_L,
        cf_J_CheekUp_s_R,
        cf_J_Eye_tx_L,
        cf_J_Eye_tx_R,
        cf_J_megane_rx_ear,
        cf_J_Eye_rz_L,
        cf_J_Eye_rz_R,
        cf_J_Eye_tz,
        cf_J_Eye01_s_L,
        cf_J_Eye01_s_R,
        cf_J_Eye05_s_L,
        cf_J_Eye05_s_R,
        cf_J_Eye02_s_L,
        cf_J_Eye02_s_R,
        cf_J_Eye03_s_L,
        cf_J_Eye03_s_R,
        cf_J_Eye04_s_L,
        cf_J_Eye04_s_R,
        cf_J_Eye08_s_L,
        cf_J_Eye08_s_R,
        cf_J_Eye07_s_L,
        cf_J_Eye07_s_R,
        cf_J_Eye06_s_L,
        cf_J_Eye06_s_R,
        cf_J_Mayu_L,
        cf_J_Mayu_R,
        cf_J_MayuMid_s_L,
        cf_J_MayuMid_s_R,
        cf_J_MayuTip_s_L,
        cf_J_MayuTip_s_R,
        cf_J_EarBase_ry_L,
        cf_J_EarBase_ry_R,
        cf_J_EarUp_L,
        cf_J_EarUp_R,
        cf_J_EarLow_L,
        cf_J_EarLow_R,
        cf_J_MouthBase_ty,
        cf_J_Mouth_L,
        cf_J_Mouth_R,
        cf_J_MouthBase_rx,
        cf_J_Mouthup,
        cf_J_MouthLow
    }

    public float headCorrectValue = 1f;

    public override void InitShapeInfo(string manifest, string assetBundleAnmKey, string assetBundleCategory, string anmKeyInfoName, string cateInfoName, Transform trfObj, int _sex)
    {
        sex = _sex;
        Dictionary<string, int> dictionary = new Dictionary<string, int>();
        DstBoneName[] array = (DstBoneName[])Enum.GetValues(typeof(DstBoneName));
        DstBoneName[] array2 = array;
        for (int i = 0; i < array2.Length; i++)
        {
            DstBoneName value = array2[i];
            dictionary[value.ToString()] = (int)value;
        }
        Dictionary<string, int> dictionary2 = new Dictionary<string, int>();
        SrcBoneName[] array3 = (SrcBoneName[])Enum.GetValues(typeof(SrcBoneName));
        SrcBoneName[] array4 = array3;
        for (int j = 0; j < array4.Length; j++)
        {
            SrcBoneName value2 = array4[j];
            dictionary2[value2.ToString()] = (int)value2;
        }
        InitShapeInfoBase(manifest, assetBundleAnmKey, assetBundleCategory, anmKeyInfoName, cateInfoName, trfObj, dictionary, dictionary2, Singleton<Character>.Instance.AddLoadAssetBundle);
        InitEnd = true;
    }

    public override void ForceUpdate()
    {
        Update();
    }

    public override void Update()
    {
        if (InitEnd && dictSrc.Count != 0)
        {
            BoneInfo value;
            if (dictDst.TryGetValue(0, out value))
            {
                Transform parent = value.trfBone.parent;
                float num = typeBone != 0 ? headCorrectValue : 1f;
                Vector3 lossyScale = parent.lossyScale;
                float num2 = lossyScale.y * num;
                Vector3 lossyScale2 = parent.lossyScale;
                float num3 = num2 / lossyScale2.x;
                Vector3 lossyScale3 = parent.lossyScale;
                float y = num2 / lossyScale3.y;
                Vector3 lossyScale4 = parent.lossyScale;
                float z = num2 / lossyScale4.z;
                value.trfBone.SetLocalScale(num3 + (dictSrc[0].vctScl.x - 1f), y, z);
            }
            if (dictDst.TryGetValue(1, out value))
            {
                value.trfBone.SetLocalPositionZ(dictSrc[1].vctPos.z);
            }
            if (dictDst.TryGetValue(2, out value))
            {
                value.trfBone.SetLocalPositionY(dictSrc[2].vctPos.y);
                value.trfBone.SetLocalPositionZ(dictSrc[2].vctPos.z);
            }
            if (dictDst.TryGetValue(3, out value))
            {
                value.trfBone.SetLocalPositionY(dictSrc[3].vctPos.y);
                value.trfBone.SetLocalScale(dictSrc[3].vctScl.x, dictSrc[3].vctScl.y, dictSrc[3].vctScl.z);
            }
            if (dictDst.TryGetValue(4, out value))
            {
                value.trfBone.SetLocalPositionZ(dictSrc[4].vctPos.z);
            }
            if (dictDst.TryGetValue(5, out value))
            {
                value.trfBone.SetLocalScale(dictSrc[5].vctScl.x, 1f, 1f);
            }
            if (dictDst.TryGetValue(6, out value))
            {
                value.trfBone.SetLocalPositionX(dictSrc[6].vctPos.x);
                value.trfBone.SetLocalPositionZ(dictSrc[6].vctPos.z);
                value.trfBone.SetLocalScale(dictSrc[6].vctScl.x, 1f, 1f);
            }
            if (dictDst.TryGetValue(7, out value))
            {
                value.trfBone.SetLocalPositionX(dictSrc[7].vctPos.x);
                value.trfBone.SetLocalPositionZ(dictSrc[7].vctPos.z);
                value.trfBone.SetLocalScale(dictSrc[7].vctScl.x, 1f, 1f);
            }
            if (dictDst.TryGetValue(8, out value))
            {
                value.trfBone.SetLocalPositionY(dictSrc[8].vctPos.y);
                value.trfBone.SetLocalScale(dictSrc[8].vctScl.x, dictSrc[8].vctScl.y, dictSrc[8].vctScl.z);
            }
            if (dictDst.TryGetValue(9, out value))
            {
                value.trfBone.SetLocalPositionZ(dictSrc[9].vctPos.z);
                value.trfBone.SetLocalScale(1f, 1f, dictSrc[9].vctScl.z);
            }
            if (dictDst.TryGetValue(10, out value))
            {
                value.trfBone.SetLocalPositionZ(dictSrc[10].vctPos.z);
                value.trfBone.SetLocalScale(1f, 1f, dictSrc[10].vctScl.z);
            }
            if (dictDst.TryGetValue(11, out value))
            {
                value.trfBone.SetLocalPositionY(dictSrc[11].vctPos.y);
                value.trfBone.SetLocalPositionZ(dictSrc[11].vctPos.z);
                value.trfBone.SetLocalScale(dictSrc[11].vctScl.x, 1f, 1f);
            }
            if (dictDst.TryGetValue(12, out value))
            {
                value.trfBone.SetLocalPositionY(dictSrc[12].vctPos.y);
                value.trfBone.SetLocalPositionZ(dictSrc[12].vctPos.z);
                value.trfBone.SetLocalScale(dictSrc[12].vctScl.x, 1f, 1f);
            }
            if (dictDst.TryGetValue(13, out value))
            {
                value.trfBone.SetLocalPositionZ(dictSrc[13].vctPos.z);
            }
            if (dictDst.TryGetValue(14, out value))
            {
                value.trfBone.SetLocalPositionY(dictSrc[14].vctPos.y);
                value.trfBone.SetLocalPositionZ(dictSrc[14].vctPos.z);
            }
            if (dictDst.TryGetValue(15, out value))
            {
                value.trfBone.SetLocalPositionZ(dictSrc[15].vctPos.z);
            }
            if (dictDst.TryGetValue(16, out value))
            {
                value.trfBone.SetLocalPositionY(dictSrc[16].vctPos.y);
            }
            if (dictDst.TryGetValue(17, out value))
            {
                value.trfBone.SetLocalPositionX(dictSrc[17].vctPos.x);
                value.trfBone.SetLocalPositionY(dictSrc[17].vctPos.y);
                value.trfBone.SetLocalPositionZ(dictSrc[17].vctPos.z);
            }
            if (dictDst.TryGetValue(18, out value))
            {
                value.trfBone.SetLocalPositionX(dictSrc[18].vctPos.x);
                value.trfBone.SetLocalPositionY(dictSrc[18].vctPos.y);
                value.trfBone.SetLocalPositionZ(dictSrc[18].vctPos.z);
            }
            if (dictDst.TryGetValue(19, out value))
            {
                value.trfBone.SetLocalPositionY(dictSrc[19].vctPos.y);
                value.trfBone.SetLocalRotation(0f, 0f, dictSrc[19].vctRot.z);
            }
            if (dictDst.TryGetValue(20, out value))
            {
                value.trfBone.SetLocalPositionY(dictSrc[20].vctPos.y);
                value.trfBone.SetLocalRotation(0f, 0f, dictSrc[20].vctRot.z);
            }
            if (dictDst.TryGetValue(21, out value))
            {
                value.trfBone.SetLocalPositionY(dictSrc[21].vctPos.y);
                value.trfBone.SetLocalRotation(dictSrc[21].vctRot.x, 0f, 0f);
            }
            if (dictDst.TryGetValue(22, out value))
            {
                value.trfBone.SetLocalPositionX(dictSrc[22].vctPos.x);
                value.trfBone.SetLocalScale(dictSrc[22].vctScl.x, dictSrc[22].vctScl.y, 1f);
            }
            if (dictDst.TryGetValue(23, out value))
            {
                value.trfBone.SetLocalPositionX(dictSrc[23].vctPos.x);
                value.trfBone.SetLocalScale(dictSrc[23].vctScl.x, dictSrc[23].vctScl.y, 1f);
            }
            if (dictDst.TryGetValue(24, out value))
            {
                value.trfBone.SetLocalPositionZ(dictSrc[24].vctPos.z);
            }
            if (dictDst.TryGetValue(25, out value))
            {
                value.trfBone.SetLocalPositionX(dictSrc[25].vctPos.x);
            }
            if (dictDst.TryGetValue(26, out value))
            {
                value.trfBone.SetLocalPositionX(dictSrc[26].vctPos.x);
            }
            if (dictDst.TryGetValue(27, out value))
            {
                value.trfBone.SetLocalPositionY(dictSrc[27].vctPos.y);
            }
            if (dictDst.TryGetValue(28, out value))
            {
                value.trfBone.SetLocalPositionY(dictSrc[28].vctPos.y);
            }
            if (dictDst.TryGetValue(29, out value))
            {
                value.trfBone.SetLocalPositionY(dictSrc[29].vctPos.y);
            }
            if (dictDst.TryGetValue(30, out value))
            {
                value.trfBone.SetLocalPositionY(dictSrc[30].vctPos.y);
            }
            if (dictDst.TryGetValue(31, out value))
            {
                value.trfBone.SetLocalPositionY(dictSrc[31].vctPos.y);
            }
            if (dictDst.TryGetValue(32, out value))
            {
                value.trfBone.SetLocalPositionY(dictSrc[32].vctPos.y);
            }
            if (dictDst.TryGetValue(33, out value))
            {
                value.trfBone.SetLocalPositionY(dictSrc[33].vctPos.y);
            }
            if (dictDst.TryGetValue(34, out value))
            {
                value.trfBone.SetLocalPositionY(dictSrc[34].vctPos.y);
            }
            if (dictDst.TryGetValue(35, out value))
            {
                value.trfBone.SetLocalPositionY(dictSrc[35].vctPos.y);
            }
            if (dictDst.TryGetValue(36, out value))
            {
                value.trfBone.SetLocalPositionY(dictSrc[36].vctPos.y);
            }
            if (dictDst.TryGetValue(37, out value))
            {
                value.trfBone.SetLocalPositionY(dictSrc[37].vctPos.y);
            }
            if (dictDst.TryGetValue(38, out value))
            {
                value.trfBone.SetLocalPositionY(dictSrc[38].vctPos.y);
            }
            if (dictDst.TryGetValue(39, out value))
            {
                value.trfBone.SetLocalPositionY(dictSrc[39].vctPos.y);
            }
            if (dictDst.TryGetValue(40, out value))
            {
                value.trfBone.SetLocalPositionY(dictSrc[40].vctPos.y);
            }
            if (dictDst.TryGetValue(41, out value))
            {
                value.trfBone.SetLocalPositionX(dictSrc[41].vctPos.x);
                value.trfBone.SetLocalPositionY(dictSrc[41].vctPos.y);
                value.trfBone.SetLocalPositionZ(dictSrc[41].vctPos.z);
                value.trfBone.SetLocalRotation(0f, 0f, dictSrc[41].vctRot.z);
            }
            if (dictDst.TryGetValue(42, out value))
            {
                value.trfBone.SetLocalPositionX(dictSrc[42].vctPos.x);
                value.trfBone.SetLocalPositionY(dictSrc[42].vctPos.y);
                value.trfBone.SetLocalPositionZ(dictSrc[42].vctPos.z);
                value.trfBone.SetLocalRotation(0f, 0f, dictSrc[42].vctRot.z);
            }
            if (dictDst.TryGetValue(43, out value))
            {
                value.trfBone.SetLocalRotation(0f, 0f, dictSrc[43].vctRot.z);
            }
            if (dictDst.TryGetValue(44, out value))
            {
                value.trfBone.SetLocalRotation(0f, 0f, dictSrc[44].vctRot.z);
            }
            if (dictDst.TryGetValue(45, out value))
            {
                value.trfBone.SetLocalRotation(0f, 0f, dictSrc[45].vctRot.z);
            }
            if (dictDst.TryGetValue(46, out value))
            {
                value.trfBone.SetLocalRotation(0f, 0f, dictSrc[46].vctRot.z);
            }
            if (dictDst.TryGetValue(47, out value))
            {
                value.trfBone.SetLocalRotation(0f, dictSrc[47].vctRot.y, dictSrc[47].vctRot.z);
                value.trfBone.SetLocalScale(dictSrc[47].vctScl.x, dictSrc[47].vctScl.y, dictSrc[47].vctScl.z);
            }
            if (dictDst.TryGetValue(48, out value))
            {
                value.trfBone.SetLocalRotation(0f, dictSrc[48].vctRot.y, dictSrc[48].vctRot.z);
                value.trfBone.SetLocalScale(dictSrc[48].vctScl.x, dictSrc[48].vctScl.y, dictSrc[48].vctScl.z);
            }
            if (dictDst.TryGetValue(49, out value))
            {
                value.trfBone.SetLocalPositionX(dictSrc[49].vctPos.x);
                value.trfBone.SetLocalPositionY(dictSrc[49].vctPos.y);
                value.trfBone.SetLocalScale(dictSrc[49].vctScl.x, dictSrc[49].vctScl.y, dictSrc[49].vctScl.z);
            }
            if (dictDst.TryGetValue(50, out value))
            {
                value.trfBone.SetLocalPositionX(dictSrc[50].vctPos.x);
                value.trfBone.SetLocalPositionY(dictSrc[50].vctPos.y);
                value.trfBone.SetLocalScale(dictSrc[50].vctScl.x, dictSrc[50].vctScl.y, dictSrc[50].vctScl.z);
            }
            if (dictDst.TryGetValue(51, out value))
            {
                value.trfBone.SetLocalPositionY(dictSrc[51].vctPos.y);
            }
            if (dictDst.TryGetValue(52, out value))
            {
                value.trfBone.SetLocalPositionY(dictSrc[52].vctPos.y);
            }
            if (dictDst.TryGetValue(53, out value))
            {
                value.trfBone.SetLocalPositionY(dictSrc[53].vctPos.y);
                value.trfBone.SetLocalPositionZ(dictSrc[53].vctPos.z);
            }
            if (dictDst.TryGetValue(54, out value))
            {
                value.trfBone.SetLocalPositionX(dictSrc[54].vctPos.x);
                value.trfBone.SetLocalPositionY(dictSrc[54].vctPos.y);
            }
            if (dictDst.TryGetValue(55, out value))
            {
                value.trfBone.SetLocalPositionX(dictSrc[55].vctPos.x);
                value.trfBone.SetLocalPositionY(dictSrc[55].vctPos.y);
            }
            if (dictDst.TryGetValue(56, out value))
            {
                value.trfBone.SetLocalPositionZ(dictSrc[56].vctPos.z);
            }
            if (dictDst.TryGetValue(57, out value))
            {
                value.trfBone.SetLocalPositionZ(dictSrc[57].vctPos.z);
            }
            if (dictDst.TryGetValue(58, out value))
            {
                value.trfBone.SetLocalPositionZ(dictSrc[58].vctPos.z);
            }
        }
    }

    public override void UpdateAlways()
    {
    }
}
