using ActionGame;
using Illusion.Game;
using Manager;
using StaffRoom;
using System.Collections.Generic;
using System.Linq;
using UnityEngine;

public class StaffRoomClubCharaFile : MonoBehaviour
{
    [SerializeField]
    private StaffRoomMenuScene staffroomoscene;

    [SerializeField]
    private StaffRoomCharaListCtrl listCtrl;

    private void Start()
    {
        SaveData.Heroine[] array = (from p in Singleton<Game>.Instance.actScene.npcList
                                    select p.heroine into p
                                    where p != null
                                    where p.isStaff
                                    select p).ToArray();
        listCtrl.ClearList();
        int num = array.Length;
        int num2 = 0;
        Dictionary<int, SaveData.Heroine> chaFileDic = new Dictionary<int, SaveData.Heroine>();
        for (int i = 0; i < num; i++)
        {
            bool disable = array[i].isAnger || array[i].talkTime <= 0;
            listCtrl.AddList(num2, array[i].parameter.fullname, array[i].charFile.ConvertCharaFilePath(array[i].charFile.charaFileName, 1), array[i].charFile.charaFileName, array[i].charFile.facePngData, disable);
            chaFileDic.Add(num2, array[i]);
            num2++;
        }
        listCtrl.OnPointerClick += delegate (FileInfo info)
        {
            staffroomoscene.SetHeroine(info != null ? chaFileDic[info.index] : null);
            Utils.Sound.Play(SystemSE.sel);
        };
        listCtrl.Create(delegate (StaffRoomInfoComponent fic)
        {
            if (!(fic == null))
            {
                fic.transform.GetChild(0).GetOrAddComponent<PreviewDataComponent>().SetChaFile(chaFileDic[fic.info.index].charFile);
            }
        });
    }
}
