using UnityEngine;

namespace StrayTech.CustomAttributes
{
    public class Helpbox : PropertyAttribute, IValidates
    {
        public enum Type
        {
            Info,
            Warning,
            Error
        }

        public readonly Type MessageType;

        public readonly string Message;

        public Helpbox(string message, Type displayType = Type.Info)
        {
            MessageType = displayType;
            Message = message;
        }

        public bool IsValid()
        {
            if (string.IsNullOrEmpty(Message))
            {
                return false;
            }
            return true;
        }
    }
}
