using UnityEngine;

namespace StrayTech.CustomAttributes
{
    public class UneditableAttribute : PropertyAttribute
    {
        public enum Effective
        {
            Always,
            OnlyWhilePlaying,
            OnlyWhileEditing
        }

        public readonly Effective EffectiveWhen;

        public UneditableAttribute()
            : this(Effective.Always)
        {
        }

        public UneditableAttribute(Effective effectiveWhen)
        {
            EffectiveWhen = effectiveWhen;
        }
    }
}
