using UnityEngine;

namespace StrayTech
{
    public class UserDefinedFlagTriggerGate : MonoBehaviour, ITriggerGate
    {
        [Tooltip("If this user defined flag is false, OnTriggerEnter logic will be bypassed.")]
        [SerializeField]
        private string _userDefinedFlagName;

        public bool IsActive
        {
            get
            {
                return gameObject.activeInHierarchy;
            }
        }

        private void Start()
        {
            if (MonoBehaviourSingleton<CameraSystem>.Instance == null)
            {
                enabled = false;
            }
        }

        public void TriggerWasEntered(Collider other)
        {
        }

        public bool IsTriggerBlocked()
        {
            return !MonoBehaviourSingleton<CameraSystem>.Instance.GetUserDefinedFlagValue(_userDefinedFlagName);
        }
    }
}
