using UnityEngine;

namespace Studio
{
    [AddComponentMenu("Studio/Manager/Input Field", 1000)]
    public class InputFieldManager : Singleton<InputFieldManager>
    {
        private StudioInputField m_StudioInputField;

        public static StudioInputField studioInputField
        {
            set
            {
                if (IsInstance())
                {
                    Instance.m_StudioInputField = value;
                    Instance.enabled = value != null;
                }
            }
        }

        public static bool isFocused
        {
            get
            {
                return IsInstance() && Instance.m_StudioInputField && Instance.m_StudioInputField.isFocused;
            }
        }

        protected override void Awake()
        {
            if (CheckInstance())
            {
                DontDestroyOnLoad(gameObject);
                studioInputField = null;
            }
        }

        private void Update()
        {
            if (m_StudioInputField && m_StudioInputField.isFocused && Input.anyKey && !Input.GetMouseButton(0))
            {
                Input.ResetInputAxes();
            }
        }
    }
}
