using System.Collections.Generic;
using System.Linq;
using UnityEngine;

namespace Studio
{
    public class SortCanvas : Singleton<SortCanvas>
    {
        [SerializeField]
        private Canvas[] canvas;

        public static Canvas select
        {
            set
            {
                if (IsInstance())
                {
                    Instance.OnSelect(value);
                }
            }
        }

        public void OnSelect(Canvas _canvas)
        {
            if (!(_canvas == null))
            {
                SortedList<int, Canvas> sortedList = new SortedList<int, Canvas>();
                _canvas.sortingOrder = 10;
                for (int j = 0; j < canvas.Length; j++)
                {
                    sortedList.Add(canvas[j].sortingOrder, canvas[j]);
                }
                foreach (var item in sortedList.Select((l, i) => new
                {
                    l.Value,
                    i
                }))
                {
                    item.Value.sortingOrder = item.i;
                }
            }
        }

        protected override void Awake()
        {
            if (CheckInstance())
            {
                DontDestroyOnLoad(gameObject);
            }
        }
    }
}
