using UnityEngine;

[AddComponentMenu("UBER/Apply Light for Deferred")]
[ExecuteInEditMode]
public class UBER_applyLightForDeferred : MonoBehaviour
{
    public Light lightForSelfShadowing;

    private Renderer _renderer;

    private void Start()
    {
        Reset();
    }

    private void Reset()
    {
        if (GetComponent<Light>() && lightForSelfShadowing == null)
        {
            lightForSelfShadowing = GetComponent<Light>();
        }
        if (GetComponent<Renderer>() && _renderer == null)
        {
            _renderer = GetComponent<Renderer>();
        }
    }

    private void Update()
    {
        if (!lightForSelfShadowing)
        {
            return;
        }
        if ((bool)_renderer)
        {
            if (lightForSelfShadowing.type == LightType.Directional)
            {
                for (int i = 0; i < _renderer.sharedMaterials.Length; i++)
                {
                    _renderer.sharedMaterials[i].SetVector("_WorldSpaceLightPosCustom", -lightForSelfShadowing.transform.forward);
                }
                return;
            }
            for (int j = 0; j < _renderer.materials.Length; j++)
            {
                Material obj = _renderer.sharedMaterials[j];
                Vector3 position = lightForSelfShadowing.transform.position;
                float x = position.x;
                Vector3 position2 = lightForSelfShadowing.transform.position;
                float y = position2.y;
                Vector3 position3 = lightForSelfShadowing.transform.position;
                obj.SetVector("_WorldSpaceLightPosCustom", new Vector4(x, y, position3.z, 1f));
            }
        }
        else if (lightForSelfShadowing.type == LightType.Directional)
        {
            Shader.SetGlobalVector("_WorldSpaceLightPosCustom", -lightForSelfShadowing.transform.forward);
        }
        else
        {
            Vector3 position4 = lightForSelfShadowing.transform.position;
            float x2 = position4.x;
            Vector3 position5 = lightForSelfShadowing.transform.position;
            float y2 = position5.y;
            Vector3 position6 = lightForSelfShadowing.transform.position;
            Shader.SetGlobalVector("_WorldSpaceLightPosCustom", new Vector4(x2, y2, position6.z, 1f));
        }
    }
}
