using Illusion.Extensions;
using System;
using System.Linq;
using UniRx;
using UnityEngine;
using UnityEngine.UI;

public class UI_ToggleGroupCtrl : MonoBehaviour
{
    [Serializable]
    public class ItemInfo
    {
        public Toggle tglItem;

        public CanvasGroup cgItem;
    }

    public ItemInfo[] items;

    public virtual void Start()
    {
        if (items.Any())
            (from item in items.Select((val, idx) => new
            {
                val,
                idx
            })
             where item.val != null && checked(item.val.tglItem != null)
             select item).ToList().ForEach(item =>
             {
                 UI_ToggleGroupCtrl uI_ToggleGroupCtrl = this;
                 (from isOn in item.val.tglItem.OnValueChangedAsObservable()
                  where isOn
                  select isOn).Subscribe(delegate
                  {
                      foreach (var item2 in uI_ToggleGroupCtrl.items.Select((v, i) => new
                      {
                          v,
                          i
                      }))
                      {
                          if (item2.i != item.idx && item2.v != null)
                          {
                              CanvasGroup cgItem = item2.v.cgItem;
                              if ((bool)cgItem)
                                  cgItem.Enable(false, false);
                          }
                      }
                      if ((bool)item.val.cgItem)
                          item.val.cgItem.Enable(true, false);
                  });
             });
    }

    public int GetSelectIndex()
    {
        var anon = items.Select((v, i) => new
        {
            v,
            i
        }).FirstOrDefault(x => x.v.tglItem.isOn);
        if (anon != null)
        {
            return anon.i;
        }
        return -1;
    }
}
