using ActionGame;
using ChaCustom;
using Illusion.Game;
using Manager;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using UniRx;
using UnityEngine;
using UnityEngine.UI;

namespace Wedding
{
    public class WeddingClassRoomCharaFile : MonoBehaviour
    {
        [SerializeField]
        private ClassRoomFileListCtrl listCtrl;

        [SerializeField]
        private Button enterButton;

        [Header("-1:standby,0:Male,1:Female")]
        [SerializeField]
        private int _sex = -1;

        private ReactiveProperty<ChaFileControl> info = new ReactiveProperty<ChaFileControl>();

        public int sex
        {
            get
            {
                return _sex;
            }
            set
            {
                _sex = value;
            }
        }

        public event Action<ChaFileControl> onEnter = delegate
        {
        };

        private IEnumerator Start()
        {
            while (_sex == -1)
            {
                yield return null;
            }
            FolderAssist faCharaFile = new FolderAssist();
            faCharaFile.CreateFolderInfoEx(UserData.Path + (_sex != 0 ? "chara/female/" : "chara/male/"), new string[1]
            {
                "*.png"
            });
            listCtrl.ClearList();
            int loop = faCharaFile.GetFileCount();
            int index = 0;
            Dictionary<int, ChaFileControl> chaFileDic = new Dictionary<int, ChaFileControl>();
            for (int i = 0; i < loop; i++)
            {
                FolderAssist.FileInfo fileInfo = faCharaFile.lstFile[i];
                ChaFileControl chaFileControl = new ChaFileControl();
                if (chaFileControl.LoadCharaFile(fileInfo.FullPath) && chaFileControl.parameter.sex == _sex)
                {
                    string club = string.Empty;
                    string personality = string.Empty;
                    if (_sex != 0)
                    {
                        VoiceInfo.Param value;
                        personality = Singleton<Voice>.Instance.voiceInfoDic.TryGetValue(chaFileControl.parameter.personality, out value) ? value.Personality : "不明";
                        ClubInfo.Param value2;
                        club = Game.ClubInfos.TryGetValue(chaFileControl.parameter.clubActivities, out value2) ? value2.Name : "不明";
                    }
                    else
                    {
                        listCtrl.DisableAddInfo();
                    }
                    listCtrl.AddList(index, chaFileControl.parameter.fullname, club, personality, fileInfo.FullPath, fileInfo.FileName, fileInfo.time);
                    chaFileDic.Add(index, chaFileControl);
                    index++;
                }
            }
            listCtrl.OnPointerClick += delegate (CustomFileInfo info)
            {
                this.info.Value = info != null ? chaFileDic[info.index] : null;
                Utils.Sound.Play(SystemSE.sel);
            };
            listCtrl.Create(delegate (CustomFileInfoComponent fic)
            {
                if (!(fic == null))
                {
                    fic.transform.GetChild(0).GetOrAddComponent<PreviewDataComponent>().SetChaFile(chaFileDic[fic.info.index]);
                }
            });
            info.Select(p => p != null).SubscribeToInteractable(enterButton);
            enterButton.OnClickAsObservable().Subscribe(delegate
            {
                onEnter(info.Value);
            });
            Button[] enters = new Button[1]
            {
                enterButton
            };
            enters.ToList().ForEach(delegate (Button bt)
            {
                bt.OnClickAsObservable().Subscribe(delegate
                {
                    Utils.Sound.Play(SystemSE.ok_s);
                });
            });
        }
    }
}
