using Illusion.Game;
using Manager;
using System;
using UniRx;
using UniRx.Triggers;
using UnityEngine;
using UnityEngine.UI;

namespace Wedding
{
    public class WeddingPreviewCharaList : BaseLoader
    {
        [SerializeField]
        private Canvas _canvas;

        [SerializeField]
        private WeddingClassRoomCharaFile _classRoomCharaFile;

        [SerializeField]
        private Button cancel;

        [SerializeField]
        private Button cancel2;

        public Canvas canvas
        {
            get
            {
                return _canvas;
            }
        }

        public WeddingClassRoomCharaFile classRoomCharaFile
        {
            get
            {
                return _classRoomCharaFile;
            }
        }

        public event Action<ChaFileControl> onEnter = delegate
        {
        };

        public event Action onCancel = delegate
        {
        };

        private void Start()
        {
            CanvasGroup canvasGroup = GetComponent<CanvasGroup>();
            this.ObserveEveryValueChanged(_ => !Singleton<Scene>.Instance.IsNowLoadingFade).Subscribe(delegate (bool isOn)
            {
                canvasGroup.interactable = isOn;
            });
            _classRoomCharaFile.onEnter += delegate (ChaFileControl file)
            {
                onEnter(file);
            };
            cancel.OnClickAsObservable().Subscribe(delegate
            {
                Utils.Sound.Play(SystemSE.cancel);
                onCancel();
            });
            cancel2.OnClickAsObservable().Subscribe(delegate
            {
                Utils.Sound.Play(SystemSE.cancel);
                onCancel();
            });
            (from _ in this.UpdateAsObservable()
             where _canvas.enabled
             where Singleton<Scene>.Instance.NowSceneNames[0] == "WeddingCharaSelect"
             where Input.GetMouseButtonDown(1)
             select _).Subscribe(delegate
         {
             Utils.Sound.Play(SystemSE.cancel);
             onCancel();
         });
        }
    }
}
